// Template file v5.202 (02/20/02)
////////////////////////////////////////////////////////////////////////
// File: doors.wdl
//		WDL prefabs for doors, platforms, gates, switchs, etc
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// ACTIONS:
//
//	FUNCTIONS:
//
//
////////////////////////////////////////////////////////////////////////

IFNDEF DOORS_DEF;
 SOUND gate_snd <sounds\doors\dsdoropn.wav>;		// elevators
 SOUND open_snd <sounds\doors\dsdoropn.wav>;
 SOUND close_snd <sounds\doors\dsdorcls.wav>;
 SOUND key_fetch <beamer.wav>;
 SOUND trigger_snd <click.wav>;
ENDIF;

IFNDEF DOORS_DEF2;
 SOUND teleport_snd <sounds\doors\teleport.wav>;
ENDIF;
////////////////////////////////////////////////////////////////////////
// Strings for needing and picking up keys; can be redefined
STRING need_key1_str "Red key required";
STRING need_key2_str "Green key required";
STRING need_key3_str "Blue key required";
STRING need_key4_str "Silver key required";
STRING need_key5_str "Golden key required";
STRING need_key6_str "Black key required";
STRING need_key7_str "White key required";
STRING need_key8_str "Yet another key required";
STRING got_key1_str "Found a red key!";
STRING got_key2_str "Found a green key!";
STRING got_key3_str "Found a blue key!";
STRING got_key4_str "Found a silver key!";
STRING got_key5_str "Found a golden key!";
STRING got_key6_str "Found a black key!";
STRING got_key7_str "Found a white key!";
STRING got_key8_str "Found a yet another key!";

// These skills may not only be set by keys, but can also be set by
// dedicated actions, dialogues in adventures, and so on.
// If a key skill is set to 1, the door or elevator will work.
var key1 = 0;
var key2 = 0;
var key3 = 0;
var key4 = 0;
var key5 = 0;
var key6 = 0;
var key7 = 0;
var key8 = 0;

var_nsave DOOR_BEEP;
var		temp_dist = 0; 		// temp store a distance (used in range trigger)
var		temp_dist2 = 0; 		// temp store a distance (used in range trigger)
//SYNONYM	temp_elevator	{ TYPE ENTITY; }  // store the current elevator  (dcp - changed from temp_ent because of name conflict in movement.wdl)
entity*	temp_elevator;			// store the current elevator  (dcp - changed from temp_ent because of name conflict in movement.wdl)

///////////////////////////////////////////////////////////////////////
DEFINE _ENDPOS_X,SKILL1;	// target position for elevator
DEFINE _ENDPOS_Y,SKILL2;
DEFINE _ENDPOS_Z,SKILL3;	// target height for elevator
DEFINE _ENDPOS,SKILL3;		// opening angle for doors
DEFINE _KEY,SKILL4;			// key number, 0 = no key needed
DEFINE _KEYTYPE,SKILL4;		// legacy
DEFINE _PAUSE,SKILL6;		// wait time at end positions
DEFINE _TRIGGER_RANGE,SKILL7;	// door/elevator may be triggered
DEFINE _SWITCH,SKILL8;		// remote switch number for operating

DEFINE _ENTROT_PAN, SKILL1;  // ent_rotate() pan speed
DEFINE _ENTROT_TILT, SKILL2; // ent_rotate() tilt speed
DEFINE _ENTROT_ROLL, SKILL3; // ent_rotate() roll speed

DEFINE _CURRENTPOS,SKILL9;
DEFINE _TRIGGERFRAME,SKILL10;	// Frame number of the last received trigger
DEFINE _STARTPOS_X,SKILL27;	// start position for elevator
DEFINE _STARTPOS_Y,SKILL28;
DEFINE _STARTPOS_Z,SKILL29;	// start height for elevator

DEFINE __ROTATE,FLAG1;	// key item rotates
DEFINE __SILENT,FLAG2;	// no message
DEFINE __GATE,FLAG5;		// elevator is a gate   (DCP: changed from 7 to 5)
DEFINE __REMOTE,FLAG6;	// platform can be remote started from the target position
DEFINE __LID,FLAG7;		// door is a lid (opens vertically)

DEFINE __MOVING,FLAG8;  // set during movement


//////////////////////////////////////////////////////////////////////////////////////////////////
var	doorswitch_states = 0;		// the states of each door switch (0-off, 1-on)


// Desc: the door switch event
//			if the _doorevent_check returns a valid value, set/reset (XOR)
//		  the doorswitch_states value using the switch's _SWITCH value
//

// Desc: Reset all the door switches
//

////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////
// Key actions.

// Desc: rotate an item horizontally
//
// no WED defined skills
ACTION item_rotate
{
	//store the current position
	MY._STARTPOS_X = MY.X;
	MY._STARTPOS_Y = MY.Y;
	MY._STARTPOS_Z = MY.Z;

	// rotate it als long as it isn't picked up
	while(MY.INVISIBLE == OFF
		&& MY._STARTPOS_X == MY.X
		&& MY._STARTPOS_Y == MY.Y
		&& MY._STARTPOS_Z == MY.Z)
	{
		MY.PAN += 3*TIME;
		wait(1);
	}
}

// Desc: action to enable an entity to be picked up
//
// uses __ROTATE
ACTION item_pickup
{
	MY.PUSH = -2;
//	MY.ENABLE_SCAN = ON;		// pick up pressing SPACE..
	MY.ENABLE_CLICK = Off;	// clicking with the mouse...
	MY.ENABLE_PUSH = ON;		// or touching the item
	MY.ENABLE_SCAN = Off;
	my.ENABLE_shoot = Off;
my.untouchable = on; // now entities behind can be clicked at
	
//	if(MY.__ROTATE == ON) { item_rotate(); }
	MY.unlit=ON;
	MY.Ambient=100;


}

// Desc: called when a "key" receives an EVENT
//			set corisponding key value to 1, display string, play sound, and remove key
//
//
//	Mod Date: 9/21/01 DCP
//				Remove key message after removing key
function _key_pickup()
{
	if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }

	if(MY._KEY == 1) { key1 = 1; msg.STRING = got_key1_str; }
	if(MY._KEY == 2) { key2 = 1; msg.STRING = got_key2_str; }
	if(MY._KEY == 3) { key3 = 1; msg.STRING = got_key3_str; }
	if(MY._KEY == 4) { key4 = 1; msg.STRING = got_key4_str; }
	if(MY._KEY == 5) { key5 = 1; msg.STRING = got_key5_str; }
	if(MY._KEY == 6) { key6 = 1; msg.STRING = got_key6_str; }
	if(MY._KEY == 7) { key7 = 1; msg.STRING = got_key7_str; }
	if(MY._KEY == 8) { key8 = 1; msg.STRING = got_key8_str; }
	if(MY.__SILENT != ON) { show_message(); }
	play_sound(key_fetch,150);
	wait(1);
	remove(ME);
	waitt(MSG_TICKS);
	msg.string = empty_str;
}

function _computer_pickup()
{
	if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }
/*
	if(MY._KEY == 1) { key1 = 1; msg.STRING = got_key1_str; }
	if(MY._KEY == 2) { key2 = 1; msg.STRING = got_key2_str; }
	if(MY._KEY == 3) { key3 = 1; msg.STRING = got_key3_str; }
	if(MY._KEY == 4) { key4 = 1; msg.STRING = got_key4_str; }
	if(MY._KEY == 5) { key5 = 1; msg.STRING = got_key5_str; }
	if(MY._KEY == 6) { key6 = 1; msg.STRING = got_key6_str; }
	if(MY._KEY == 7) { key7 = 1; msg.STRING = got_key7_str; }
	if(MY._KEY == 8) { key8 = 1; msg.STRING = got_key8_str; }
*/	
	msg.STRING = "UAC personal computer";
	if(MY.__SILENT != ON) { show_message(); }
	play_sound(key_fetch,150);
	wait(1);
	remove(ME);
	waitt(MSG_TICKS);
	msg.string = empty_str;
}
function switch_event()
{
	if((EVENT_TYPE == EVENT_SCAN) && (indicator == _HANDLE))
	{
	doorswitch_states = MY._SWITCH;
	LightSwitch();
	}
}

function LightSwitch()
{

My.ambient=100;
my.lightrange = 60; // lightsphere 200 quants
my.green=255;
my.red=50;
my.blue=50;
wait(400);
	MY.unlit=ON;
	my.green=50;
	my.red=255;
	my.blue=50;
	my.lightrange = 0; // lightsphere 200 quants
}

action doorswitch
{
	MY.EVENT = switch_event;
//	_doorevent_init();
	MY.ENABLE_SCAN  = ON;
	my.push=-10;
	my.passable=on;
	MY.unlit=ON;
	MY.Ambient=100;
	if(MY._SWITCH == 0) { MY._SWITCH = 1; }	// default to switch 1

}


// Desc: This entity must not look like a key at all...
//
// uses _KEY
// uses __ROTATE
ACTION key
{
	if(MY._KEY == 0) { MY._KEY = 1; }
/*	
	my.lightrange = 0; // don't illuminate the environment
 	my.light = ON; // illuminate myself
	
	if (MY._KEY==1) 
	{
 	my.red=255;
 	my.blue= 255;
 	my.green=255; 
	}


	if (MY._KEY==2) 
	{
 	my.red=10;
 	my.blue= 10;
 	my.green=255; 
	}
	
	if (MY._KEY==2) 
	{
 	my.red=10;
 	my.blue= 255;
 	my.green=10; 
	}
	
*/	
	ToGround();

	MY.EVENT = _key_pickup;
	item_pickup();
}


ACTION computer
{
	//if(MY._KEY == 0) { MY._KEY = 1; }
	ToGround();
	MY.EVENT = _computer_pickup;
	item_pickup();
}


// Desc: reset key values to zero
//
function key_init()
{
	key1 = 0;
	key2 = 0;
	key3 = 0;
	key4 = 0;
	key5 = 0;
	key6 = 0;
	key7 = 0;
	key8 = 0;
}

////////////////////////////////////////////////////////////////////////

// Desc: handle "teleporter" events
//
function _tele_event()
{
//	handle_touch();	// show mouse touch text, if any

	// entity walked over it while performing SONAR, or touched it
	//if(  EVENT_TYPE == EVENT_SONAR ||
	//	|| EVENT_TYPE == EVENT_IMPACT
		if ( (EVENT_TYPE == EVENT_PUSH)
		|| (EVENT_TYPE == EVENT_SONAR) )
	{
		wait(1);	// the entity was already moving, so this must be finished before displacing it

		YOUR.X = MY.SKILL1;	// displace the entity
		YOUR.Y = MY.SKILL2;
		YOUR.Z = MY.SKILL3;
		YOUR.PAN = MY.SKILL5;
		CAMERA.AMBIENT += 30;	// a short flash
		PLAY_SOUND teleport_snd,250;
		waitt(2);

		CAMERA.AMBIENT -= 20;
		waitt(2);

		CAMERA.AMBIENT -= 10;
	}
}

// Desc:  Teleporter action. Transports an entity to the SKILL1,2,3 position
// 		it touched. SKILL5 gives an angle.
//
// uses _TRIGGER_RANGE
ACTION teleporter
{
	my.push = -1; 
	MY.EVENT = _tele_event;
	//MY.ENABLE_IMPACT = ON;
	My.enable_push=on;
my.untouchable = on; // now entities behind can be clicked at
	// enable operating on stepping onto (for platform teleporters)
//	if(MY._TRIGGER_RANGE == 1) {	MY.ENABLE_SONAR = ON; }

	// enable mouse text
//	if(MY.STRING1 != NULL) { MY.ENABLE_TOUCH = ON; }
	
	while(1)
	{
	
	
	//	if (my.visible==on)
	//	{
	
		emit(1,MY.POS,particle_teleport_in); 	
		
		temp.x=my.SKILL1;
		temp.y=my.SKILL2;
		temp.z=my.SKILL3;
		
		emit(1,temp,particle_teleport_out); 	
	//	}	
		wait(30);
		
	}
	
}









function Direct_Open_Door(ent)
{
			my = ent; 
			if(my._KEY != 0){return;}	
			if (my.__MOVING ==ON) {return;}	
			slide_door_move();
				
}


////////////////////////////////////////////////////////////////////////

// Desc: handle elevator events



function slide_door_event()
{
	if((EVENT_TYPE == EVENT_SCAN) && (indicator == _HANDLE))
	{
	if (MY.__MOVING ==ON) {return;}
	

	

	if((MY._KEY == 1)&&(key1 == 0)) { msg.STRING = need_key1_str; GOTO message; }
	if((MY._KEY == 2)&&(key2 == 0)) { msg.STRING = need_key2_str; GOTO message; }
	if((MY._KEY == 3)&&(key3 == 0)) { msg.STRING = need_key3_str; GOTO message; }
	if((MY._KEY == 4)&&(key4 == 0)) { msg.STRING = need_key4_str; GOTO message; }
	if((MY._KEY == 5)&&(key5 == 0)) { msg.STRING = need_key5_str; GOTO message; }
	if((MY._KEY == 6)&&(key6 == 0)) { msg.STRING = need_key6_str; GOTO message; }
	if((MY._KEY == 7)&&(key7 == 0)) { msg.STRING = need_key7_str; GOTO message; }
	if((MY._KEY == 8)&&(key8 == 0)) { msg.STRING = need_key8_str; GOTO message; }



operate:		
	slide_door_move();	
	
message: // and don't operate
	if(MY.__SILENT != ON) { show_message(); }
	if (DOOR_BEEP==0) {DOOR_BEEP=snd_play(trigger_snd,300,0);}
	
	}
	
}

function slide_door_move()
{
if (MY.__MOVING ==ON) {return;}
MY.__MOVING = ON;
PLAY_ENTSOUND ME,open_snd,300;
		// open gate
		while(MY.__MOVING == ON)
		{
			wait(1);			// DcP - moved wait to the start of this block, before the __MOVING flag is set to OFF
			// calculate the 3D direction to move to
			MY._SPEED_Z = MY._TARGET_Z - MY.Z;
			temp = MY._FORCE * TIME;  // use force for elevator speed
			// check the length to the target position to the normal speed
			if(vec_length(my._speed) > temp)
			{
				// if we still have room to move, move
			vec_normalize(MY._SPEED,temp);
			}
			else
			{
			// else, move to target position and stop
			MY.__MOVING = OFF;
			}
  			// move in that direction
			move_mode = ignore_passable + ignore_push + activate_trigger; 
			result = ent_move(NULLSKILL,MY._SPEED);
		}
			
			if (MY._TARGET_Z == MY._ENDPOS_Z)
					 {
				MY._TARGET_Z = MY._STARTPOS_Z;
					}	else  {
				MY._TARGET_Z = MY._ENDPOS_Z;
								}

}



ACTION gate
{
	MY.__GATE = ON;	// define this entity as a gate
	my.metal = ON;
	my.albedo = 70;
	my.untouchable = on; // now entities behind can be clicked at
	MY._FORCE=5;
		MY.ENABLE_SCAN  = ON;
		my.push=10;
	// give the gate a default speed (if it doesn't already have one)
	if(MY._FORCE == 0) { MY._FORCE = 5; }

		MY._ENDPOS_Z = MY.Z + 0.9*(MY.MAX_Z- MY.MIN_Z);
 	MY.EVENT = slide_door_event;
	// initialize the movement parameters of the gate
	MY._STARTPOS_Z = MY.Z;
	MY._TARGET_Z = MY._ENDPOS_Z;
	MY.__MOVING = OFF;
	
	
	// if it is switch activated...
	if(MY._SWITCH != 0)
	{
		door_use_switch();
	}

	
	
}


function door_use_switch()
{
	while(1)
	{
		if(MY._SWITCH==doorswitch_states)
		{
			slide_door_move();
			doorswitch_states=0;
			
		}		
		waitt(20);
		
 	}

}

function lift_use_switch()
{
	while(1)
	{
		if(MY._SWITCH==doorswitch_states)
		{
			lift_move();
			doorswitch_states=0;
			
		}		
		waitt(20);
		
 	}

}


//===============================================

function lift_event()
{
	if((EVENT_TYPE == EVENT_SCAN) && (indicator == _HANDLE))
	{
	if (MY.__MOVING ==ON) {return;}
	lift_move();	
	
	
	}
	
}

function lift_move()
{
if (MY.__MOVING ==ON) {return;}
MY.__MOVING = ON;
PLAY_ENTSOUND ME,open_snd,300;
		// open gate
		while(MY.__MOVING == ON)
		{
			wait(1);			// DcP - moved wait to the start of this block, before the __MOVING flag is set to OFF
			// calculate the 3D direction to move to
			MY._SPEED_Z = MY._TARGET_Z - MY.Z;
			temp = MY._FORCE * TIME;  // use force for elevator speed
			// check the length to the target position to the normal speed
			if(vec_length(my._speed) > temp)
			{
				// if we still have room to move, move
			vec_normalize(MY._SPEED,temp);
			}
			else
			{
			// else, move to target position and stop
			MY.__MOVING = OFF;
			}
  			// move in that direction
			move_mode = ignore_passable + ignore_push + activate_trigger; 
			result = ent_move(NULLSKILL,MY._SPEED);
		}
			
			if (MY._TARGET_Z == MY._ENDPOS_Z)
					 {
				MY._TARGET_Z = MY._STARTPOS_Z;
					}	else  {
				MY._TARGET_Z = MY._ENDPOS_Z;
								}

}



ACTION elevator
{
	MY.__GATE = ON;	// define this entity as a gate
	my.untouchable = on; // now entities behind can be clicked at
	MY._FORCE=5;
	MY.ENABLE_SCAN  = ON;
	my.push=10;
	// give the gate a default speed (if it doesn't already have one)
	if(MY._FORCE == 0) { MY._FORCE = 5; }

//	MY._ENDPOS_Z = MY.Z + 0.9*(MY.MAX_Z- MY.MIN_Z);
 	MY.EVENT = lift_event;
	// initialize the movement parameters of the gate
	MY._STARTPOS_Z = MY.Z;
	MY._TARGET_Z = MY._ENDPOS_Z;
	MY.__MOVING = OFF;
	if(MY._SWITCH != 0)
	{
	lift_use_switch();
	}
}

//================================================

// Desc: handle ranged trigger events

