// Template file v5.202 (02/20/02)
////////////////////////////////////////////////////////////////////////
// File: war.wdl
//		WDL prefabs for hostile entities
////////////////////////////////////////////////////////////////////////
//]- Mod Date: 8/22/00 DCP
//]-				Changed '_gib' function to take a parameter to determine
//]-			the number of pieces to create in the gib explosion.
//]- Mod Date: 8/31/00 DCP
//]-				Modified '_gib_action' function to scale absdist vector by movement_scale
//]-				Modified '_gib_action' function to scale the gibbits down by the actor_scale
//]- Mod Date: 10/31/00 DCP
//]-				Changed to 4.30 format
//]- Mod Date: 11/8/00 DCP
//]-          'attack_fire' & 'state_die': Replace set_frame with ent_frame
//]-
//]- Mod Date: 02/06/01 DCP
//]-		In 'fight_event':
//]-			Added wait before shoot command to remove 'Dangerous instruction error'
//]-	 	   Replaced SHOOT with trace()
//]-
//]-
//]- Mod: 05/05/01 DCP
//]-		In 'fight_event':
//]-			Modified damage from ranged explosion (replaced ABS with MAX)
//]-
//]- Mod Date: 05/16/01 DCP
//]-				Remove all 'BRANCH' commands (replace with <foo>(); return;)
//]-
//]- Mod Date: 05/18/01 DCP
//]-				Fixed "double shots" (the cause of robot1's self hits)
//]-
//]- Mod Date: 06/05/01 DCP
//]-		attack_approach(), avoid_walls(): Replaced TO_ANGLE with vec_to_angle()
//]-
//]- Mod Date: 06/21/01 DCP
//]-				Replaced SYNONYMs with pointers
//]-
//]- Mod: 07/19/01 MWS
//]-		state_wait(): Use specified cowardice value instead of universal 30.
//]-				Use specified alertness instead of universal 1000.
//]-				Also now skips the player scan entirely if alertness is zero.
//]-
//]-		attack_fire(): MY_ANGLE used in shooting at player now varies by a random
//]-				amount between -MY._I_ACCURACY to +MY._I_ACCURACY
//]-
//]- Mod Date: 7/26/01 MWS
//]-		attack_transitions(): Made "escape" branch test for MY._I_COWARDICE
//]-				instead of default 30.
//]-
//]- Mod Date: 12/18/01
//]-		Added WED 'uses' comments to all WED editable fields
//]-
//]- 7/12/02 JCL - menu_default re-renamed to menu_main
////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////
//var temp_robot {} // robot coordinates, add it at the beginning of the file    

DEFINE splash1_map,<bigblood1.bmp>;
DEFINE splash2_map,<bigblood2.bmp>;
DEFINE splash3_map,<blood3.bmp>;
var scale_blood;
var blood_splash_counter = 0;

string imp_ice=<imp_ice.bmp>;

//DEFINE WAR_CHAT_ON;	// display 'thought' actions for the AIs
IFDEF WAR_CHAT_ON;
	STRING war_wait_str,"Waiting...";
	STRING war_attack_str,"Attacking!!!";
	STRING war_hunt_str,"Searching...";
	STRING war_escape_str,"Retreat!!!";
	STRING war_dead_str,"I have been undone!";
ENDIF;

SOUND imp_walk=<tap.wav>;
sound imp_alert=<impsit1.wav>;
SOUND imp_pain=<impsit2.wav>;
SOUND imp_dead=<impdth2.wav>;
sound imp_hunt=<impact.wav>;
sound imp_claw=<dsclaw.wav>;


SOUND guy_walk=<tap.wav>;
sound guy_alert=<guysit1.wav>;
SOUND guy_pain=<guypain.wav>;
SOUND guy_dead=<guydth1.wav>;
sound guy_hunt=<impact.wav>;


//////////////////////////////////////////////////////////////////////
// WAR.WDL - fighting behaviour
///////////////////////////////////////////////////////////////////////
IFNDEF WAR_DEFS;
 DEFINE ACTOR_EXPLO,<explo+7.bmp>;
 DEFINE ACTOR_EXPLO_FRAMES,7;
ENDIF;

///////////////////////////////////////////////////////////////////////
var freeze_actors = 0;	// 1,2 for testing purposes


///////////////////////////////////////////////////////////////////////
DEFINE _STATE_WAIT,1;
DEFINE _STATE_ATTACK,2;
DEFINE _STATE_ESCAPE,3;
DEFINE _STATE_DIE,4;
DEFINE _STATE_FREEZE,5;       // 05/15/01 DCP: Changed from 4->5
DEFINE _STATE_HUNT,6;

DEFINE _MUZZLE_VERT,SKILL32;
DEFINE _I_ACCURACY,SKILL33;		// 07/19/01 MWS: Added
DEFINE _I_COWARDICE,SKILL34;		// 07/19/01 MWS: Added
DEFINE _I_ALERTNESS,SKILL35;		// 07/19/01 MWS: Added


// DEFINE USER INPUT SKILLs
// These skill will be inputted from WED and work with entities that use the actions:
//    "player_walk_fight" and "actor_walk_fight"
DEFINE	_WALKSWIM_DIST, SKILL1;   // Walk Distance . Swim Distance
DEFINE	_RUNCRAWL_DIST, SKILL2;   // Run Distance . Crawl Distance
DEFINE	_STANDJUMP_TIME, SKILL3;  // Stand Time . Jump Time
DEFINE	_ATTACKDUCK_TIME, SKILL4; // Attack Time . Duck Time
DEFINE	_RUNTHRESHOLD, SKILL14;	// Run Threshold
//DEFINE	_FORCE, SKILL5;			// Force
//DEFINE	_BANKING, SKILL6;			// Banking amount (player only)
//DEFINE	_HITMODE, SKILL6;			// Hitmode (actor only)
//DEFINE	_MOVEMODE, SKILL7;		// Starting movemode
//DEFINE	_FIREMODE, SKILL8;		// Firemode
//DEFINE	_HEALTH, SKILL9;			// Heath
//DEFINE	_ARMOR, SKILL10;			// Armor
DEFINE	_ALERTNESS, SKILL11;    // Alertness
DEFINE	_ACCURACY, SKILL12; 		// Accuracy
DEFINE	_COWARDICE, SKILL13;		// Cowardice
DEFINE	_MUZZLEATTACH, SKILL15;	// Muzzle vertex . Attach vertex
DEFINE	_WEAPONRANGE, SKILL16;	// weapon range for AI actors
define   _PAINSOUND, SKILL46;
define   _DEADSOUND, SKILL47;
define   _ALERTSOUND, SKILL48;
define   _SND_HANDLE, SKILL49;
//define   _HUNTSOUND, SKILL50;
define  _MONSTR_TYPE,SKILL52;
define _ICE,SKILL53;
define _HUNTSOUND,SKILL54; 
define _CLAWSOUND,SKILL55;
//string actor_explosion_mdl = <explosion.mdl>;
	
define _IN_VIEW,SKILL56;

define _BASE_VERT,SKILL60;


///////////////////////////////////////////////////////////////////////
entity* test_actor;	// test actor entity pointer. Used in robot_test




STRING	robot_attack_str, "attack";	// attack frame names used by robot

function ice_attach() 
{ 
	while(you)
	{ 
	vec_for_vertex(my.x,you,371); 
	vec_for_vertex(nullvector,you,302); //       
	vec_sub(nullvector,MY.pos); 
	vec_to_angle(my.angle,nullvector); 
	wait(1); 
	} 
}
// Desc: Action for robot #1
//			Init values and call actor_fight
// 	No WED defined skills




function Enemy_AI_event()
{
	if((EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
		|| (EVENT_TYPE == EVENT_SHOOT && indicator == _GUNFIRE))
		{

		MY._SIGNAL = _DETECTED;
	    if (my._ARMOR <= 0) { my._HEALTH -= damage; }
    						else { my._ARMOR -= damage; }
		
			
		
   if (MY._HEALTH>0) 
   {	
	
   	if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._PAINSOUND, 1000);}
  
   }
	
	TRACE_MODE = IGNORE_ME + IGNORE_YOU + IGNORE_PASSABLE + IGNORE_MODELS + IGNORE_SPRITES + IGNORE_MAPS;
   TRACE (gun_muzzle,gun_target);


     if (RESULT <400)

       {

       temp = INT(RANDOM(3));
       
       if (temp == 1)

         {
         create(splash1_map,TARGET,blood_splash);  // create blood splash
         }
       if (temp == 2)
         {
         create(splash2_map,TARGET,blood_splash);  // create blood splash
         }
       if (temp == 0)
         {
          create(splash3_map,TARGET,blood_splash);
         }

     }
		
	//	MY._SND_HANDLE=ent_playsound (MY, MY._ALERTSOUND, 1000);
		return;
		}	
		
		if (EVENT_TYPE == EVENT_DETECT && you == player)
		{
//		MY._IN_VIEW = 10;	// by shooting, player gives away his position
		MY._IN_VIEW = _DETECTED;
		return;
		}
		
	
		
	if (EVENT_TYPE == EVENT_block) // collision with other entity
		{
	//	wait(1);	
//	wait(1);	//fix for dangerous instruction
	//scan_dist=-1000;
		//	if (MY._STATE != _STATE_ESCAPE)
		//	{
		MY._TARGET_PAN=my.pan+180;
		MY._STATE = _STATE_ESCAPE;
		//	}
		return;	
		}
		
	if (EVENT_TYPE==EVENT_ENTITY)	
	{
			MY._TARGET_PAN=random(6)*60;
			MY._STATE = _STATE_ESCAPE;
			
	}
}			

//===================================================
DEFINE	kActorAIAvoidDist, 150;    // value used in distance traces
function _actor_ai_avoid_obs()
{
	// trace ahead for obstacles
	vec_set(temp.x,nullvector);
	temp.x = kActorAIAvoidDist;
	vec_rotate(temp.x,my.pan);	// vector pointing ahead of the actor
	vec_add(temp.x,my.x);      // offset by the actor

	trace_mode = ignore_me + ignore_passable + use_box;
	temp2 = trace(my.x,temp.x);
	if(temp2 == 0) { return; }  // nothing in the way, no change needed

	// if the obstical is an entity
	if(you != null)
	{
	  	// scale walk around
		temp = (kActorAIAvoidDist - temp2)/kActorAIAvoidDist;	// 0-1
		force.y = -force.x * temp; // use forward (max) force
		force.x += force.y;
 		return;
	}
	// else the obstical is a map object
	// check normal
	// if "ramp" return (the actor will walk up on it)
	if(normal.z > 0.7) { return; }

	temp = (kActorAIAvoidDist - temp2)/kActorAIAvoidDist; // 0 - 1
	// else it is a wall
	// calculate actor's sidestep force to avoid contact
	vec_to_angle(temp2.pan,normal.x);	// global angle to player  (assume results are between -180 & 180)
	temp2.pan = ang(ang(temp2.pan) - ang(my.pan));	 // angle to turn to line up with normal
	if(temp2.pan > 0)
	{
		force.y = force.x * temp; // use forward (max) force
		force.x -= force.y;
	}
	else
	{
		force.y = -force.x * temp; // use forward (max) force
		force.x += force.y;
	}
}



//===================================================
function Enemy_AI()
{
	
	
//	MY._SIGNAL = 0;
	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = ON;
	MY._STATE = _STATE_WAIT;
	my.ENABLE_stuck = ON; 	
	my.ENABLE_BLOCK = ON; 
	my.ENABLE_ENTITY = ON; // sensible for entity collision

	Enemy_AI_wait();
}

var angle=0;

function Enemy_AI_wall()
{	
MY._COUNTER = (RANDOM(3)+1)*10;
//while((MY._STATE==_STATE_ESCAPE) && (MY._COUNTER > 0))
while(1)
	{
		MY_ANGLE.PAN = MY._TARGET_PAN;
		MY_ANGLE.TILT = 0;
		MY_ANGLE.ROLL = 0;
		force = MY._FORCE * 2;
		actor_turn(); //  
		force = MY._FORCE;
		MY._MOVEMODE = _MODE_WALKING;
		actor_move(); //  
		MY._COUNTER -= TIME;
		if (MY._COUNTER<=0) { MY._STATE = _STATE_HUNT; Enemy_AI_hunt(); return;		}
		if (my._HEALTH <= 0) { Enemy_AI_die(); return; }
	
		wait(1);	
	}
//MY._STATE=_STATE_HUNT;			
//return;	
}


var temp1;

function Enemy_AI_hunt()
{
//MY._STATE = _STATE_HUNT;
//while(MY._STATE == _STATE_HUNT)	

	if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._HUNTSOUND, 500);}
	
while(1)
{
	
	
	if (MY._COUNTER<=0)
	{
	//======================		scan_dist=Pre_AI_shot();
	//===========if visible?===============
			MY._SIGNAL =0;
			MY._IN_VIEW =0;
			temp.PAN = 120;
			temp.TILT = 180;
			temp.Z = 2000;
			indicator = _WATCH;
			scan_entity(MY.x,temp);
			if(MY._IN_VIEW == _DETECTED) 
			{
			wait(1);
			indicator = _WATCH;
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;
			trace(MY.POS,player.POS);
			if((RESULT > 0) && (YOU == player))	// spotted him!
				{
			MY._COUNTER=random(5)*10+30;
			Enemy_AI_shot_anim();
			//return;
				}
			}
	
	//======================		
	}	
	MY._COUNTER-=time;	
	
	
	//      
	//   
		temp.X = player.X - MY.X;
		temp.Y = player.Y - MY.Y;
		temp.Z = 0;
		vec_to_angle(MY_ANGLE,temp);	
		//wait(1);
		
		MY._TARGET_PAN = MY_ANGLE.PAN;
		MY_ANGLE.PAN = MY._TARGET_PAN;
		MY_ANGLE.TILT = 0;
		MY_ANGLE.ROLL = 0;
		force = MY._FORCE * 2;
		actor_turn(); //  
		
		temp=(player.X - MY.X)/10;
		temp1=(player.Y - MY.Y)/10;
		temp=(temp*temp+temp1*temp1)*10;
		
		//temp = (player.X - MY.X)*(player.X - MY.X)+(player.Y - MY.Y)*(player.Y - MY.Y);
		
		temp2=abs(player.z-my.z);
			if((temp < 500) && (temp2<30))  // 100^2
				{
			 			Enemy_AI_close_anim();
						return;					 
				} 
			else
				 {
			force = MY._FORCE;
			MY._MOVEMODE = _MODE_WALKING;
			actor_move(); //  
		 
				 }
	

//	MY._COUNTER-=time;	
//	force = 0;     // no force from this actor
//	actor_move();	// react to outside forces (gravity, etc) even while waiting
	//scan_dist=1000;
	wait(1);
	_actor_ai_avoid_obs();
	//if (MY._STATE==_STATE_ESCAPE)		{Enemy_AI_wall(); return;}	
	if (my._HEALTH <= 0) { Enemy_AI_die(); return; }
	}
//return;	
}


function Pre_AI_shot()
{
//===========if visible?===============
			MY._SIGNAL =0;
			MY._IN_VIEW =0;
			temp.PAN = 120;
			temp.TILT = 180;
			temp.Z = 2000;
			indicator = _WATCH;
			scan_entity(MY.x,temp);
			
			if(MY._IN_VIEW != _DETECTED) {return(-1);}
			
			wait(1);
			indicator = _WATCH;
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;
			trace(MY.POS,player.POS);
			if((RESULT > 0) && (YOU == player))	// spotted him!
			{
			return(1);
	
			}
			return(-1);

}

function Enemy_AI_wait()
{
	
//MY._MOVEMODE = _MODE_STILL;
MY._STATE = _STATE_WAIT;
//	MY._MOVEMODE = _MODE_WALKING; 
//while(MY._STATE == _STATE_WAIT)
	MY._SIGNAL =0;
	MY._IN_VIEW =0;
	//MY._MOVEMODE = 0;	

while(1)
//	while(MY._STATE == _STATE_WAIT)
	{
	
	if ((MY._SIGNAL==_DETECTED) || (Pre_AI_shot()==1))
		{
		snd_stop(MY._SND_HANDLE);
		MY._SND_HANDLE=ent_playsound (ME, MY._ALERTSOUND, 1000);
		MY._STATE = _STATE_HUNT;
		Enemy_AI_hunt();
		return; //  
		}
	if (my._HEALTH <= 0) { Enemy_AI_die(); return; }
	
	
	waitt(1);
	
	force = 0;     // no force from this actor
	actor_move();	// react to outside forces (gravity, etc) even while waiting

	}
}


function Enemy_AI_close_anim()
{
	
	while(1)
	{

				MY._ANIMDIST = 0;
				while(MY._ANIMDIST < 50)
				{
					MY._ANIMDIST += 8.0 * TIME; 
					ent_frame(robot_attack_str,MY._ANIMDIST);
					wait(1);
				
				
					temp.X = player.X - MY.X;
					temp.Y = player.Y - MY.Y;
					temp.Z = 0;
					vec_to_angle(MY_ANGLE,temp);	
					MY_ANGLE.TILT = 0;
					MY_ANGLE.ROLL = 0;
					force = MY._FORCE * 2;
					//actor_turn(); //  
					//temp=(player.X - MY.X)/10;
					//temp1=(player.Y - MY.Y)/10;
					temp.x=temp.x/10;
					temp.y=temp.y/10;
					temp.z=(temp.x*temp.x+temp.y*temp.y)*10;
			
				if(temp.z > 500)  // 100^2
						{
				MY._STATE = _STATE_HUNT;
				Enemy_AI_hunt();
				return;
						}
				}	
//=========================================
				actor_turn(); //  
				wait(1);
		//		vec_set(temp, my.x);
		//		temp.x+=200;
 				trace_mode = ignore_me + ignore_passable; 
            trace (my, my._MUZZLE_VERT); 
            if (result != 0) 
            //if (temp<200)
                    { 
           //    effect_local(particle_sparks, 10, target, normal); 
             	if (you == player) {you._HEALTH -= 6 * time;}  
        			if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._CLAWSOUND, 500);}	            
                    } 
            
				
            
            
//========================================				
				

	wait(2);	
	if (my._HEALTH <= 0) { Enemy_AI_die(); return; }
	}			
				
}


function Enemy_AI_shot_anim()
{
				MY._ANIMDIST = 0;
				while(MY._ANIMDIST < 50)
				{
					MY._ANIMDIST += 8.0 * TIME; 
					ent_frame(robot_attack_str,MY._ANIMDIST);
					wait(1);
				}
				
				Enemy_AI_shot();
				return;
}


function Enemy_AI_shot()
{
	
					// reset entity's animation time to zero

	
	
	
	
	
	
	if(my._MUZZLE_VERT > 0)       // if we are using a muzzle vertex
	{
		// attach to gun point
		vec_for_vertex(gun_muzzle,my,my._muzzle_vert);
	}
	else
	{
		// else use the actor origin
		vec_set(gun_muzzle,my.x);
	}

	vec_diff(temp,player.x,gun_muzzle.x);
	vec_normalize(temp,int(MY._WEAPONRANGE));

	// offset vertor with accuracy modifier
//	temp2.pan =  (random(my._I_ACCURACY) - (0.5*(my._I_ACCURACY)));
//	temp2.tilt = (random(my._I_ACCURACY) - (0.5*(my._I_ACCURACY)))/4;
//	temp2.roll = 0;
 //	vec_rotate(temp,temp2);

  	vec_set(shot_speed,temp);
  	vec_set(gun_target,gun_muzzle.x);
	vec_add(gun_target,temp);  // gun target = gun_muzzle + shot_speed
	
	fire_mode=int(MY._FIREMODE);
	damage = frc(MY._FIREMODE) * 100;


	// particle trail shot (line of particles)
	if((fire_mode & MODE_FIRE) == FIRE_PARTICLE)
	{
		vec_set(p,gun_muzzle);
		vec_set(p2,gun_target);
		particle_line();
	}

	// single particle
	if((fire_mode & MODE_FIRE) == FIRE_DPARTICLE)
	{ emit(1,gun_muzzle,particle_shot); }

	// fireball
	if((fire_mode & MODE_FIRE) == FIRE_BALL)
	{
		// note: fireballs never stop moving until they hit something
		vec_scale(shot_speed,0.0625); // 1/16th the total distace
		create(fireball,gun_muzzle,bullet_shot);
		you.flare=ON;
		you._MONSTR_TYPE=my._MONSTR_TYPE; //not self damage Doom2!
	}

	// rocket model
	if((fire_mode & MODE_FIRE) == FIRE_ROCKET)
	{
		vec_scale(shot_speed,0.04); // 1/25
  		create(<rocket.mdl>,gun_muzzle,rocket_launch);
	}

	// eject brass?
	if((fire_mode & GUNFX_BRASS) != 0)
	{
	 	emit(1,gun_muzzle,particle_gunBrass); // emit brass
	}

	if((fire_mode & MODE_DAMAGE) == DAMAGE_SHOOT)
	{
		_gun_shot_damage_shoot();	// handle 'shot' weapons
	}
	
	
				MY._STATE = _STATE_HUNT;
		//		Enemy_AI_hunt();
				return;

	
}



function Enemy_AI_die() 
{
	snd_stop(MY._SND_HANDLE);
	ent_playsound (ME, MY._DEADSOUND, 500);

	
  my._ANIMDIST = 0; // reset entities' animation time to zero
  while (my._ANIMDIST < 100)
  {
    ent_FRAME("death",my._ANIMDIST); // set the frame from the percentage
    my._ANIMDIST += 5.0 * TIME; // calculate next percentage for death in ~1.25 seconds
//   force = 0;     // no force from this actor
//	actor_move();	// react to outside forces (gravity, etc) even while waiting
    wait(1);
  }
  my.enable_scan = OFF; // become insensible
  my.enable_shoot = OFF;
  my.event = NULL; // and don't react anymore
  my.passable=ON;
	my.ENABLE_stuck = Off; 	
	my.ENABLE_BLOCK = Off;   
}

//==================================================

function Soldier_AI_wait()
{
	
//MY._MOVEMODE = _MODE_STILL;
MY._STATE = _STATE_WAIT;
//	MY._MOVEMODE = _MODE_WALKING; 
//while(MY._STATE == _STATE_WAIT)
	MY._SIGNAL =0;
	MY._IN_VIEW =0;
	//MY._MOVEMODE = 0;	

while(1)
//	while(MY._STATE == _STATE_WAIT)
	{
	
	if ((MY._SIGNAL==_DETECTED) || (Pre_AI_shot()==1))
		{
		snd_stop(MY._SND_HANDLE);
		MY._SND_HANDLE=ent_playsound (ME, MY._ALERTSOUND, 1000);
		MY._STATE = _STATE_HUNT;
		Soldier_AI_hunt();
		return; //  
		}
	if (my._HEALTH <= 0) { Soldier_AI_die(); return; }
	
	
	waitt(1);
	
	force = 0;     // no force from this actor
	actor_move();	// react to outside forces (gravity, etc) even while waiting

	}
}


function Soldier_AI_die() 
{
	snd_stop(MY._SND_HANDLE);
	ent_playsound (ME, MY._DEADSOUND, 500);

	
  my._ANIMDIST = 0; // reset entities' animation time to zero
  while (my._ANIMDIST < 100)
  {
    ent_FRAME("die",my._ANIMDIST); // set the frame from the percentage
    my._ANIMDIST += 5.0 * TIME; // calculate next percentage for death in ~1.25 seconds
//   force = 0;     // no force from this actor
//	actor_move();	// react to outside forces (gravity, etc) even while waiting
    wait(1);
  }
  my.enable_scan = OFF; // become insensible
  my.enable_shoot = OFF;
  my.event = NULL; // and don't react anymore
  my.passable=ON;
	my.ENABLE_stuck = Off; 	
	my.ENABLE_BLOCK = Off;   
}


function Soldier_AI()
{
	
	
//	MY._SIGNAL = 0;
	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = ON;
	MY._STATE = _STATE_WAIT;
	my.ENABLE_stuck = ON; 	
	my.ENABLE_BLOCK = ON; 
	my.ENABLE_ENTITY = ON; // sensible for entity collision

	Soldier_AI_wait();
}

var angle=0;

function Soldier_AI_wall()
{	
MY._COUNTER = (RANDOM(3)+1)*10;
//while((MY._STATE==_STATE_ESCAPE) && (MY._COUNTER > 0))
while(1)
	{
		MY_ANGLE.PAN = MY._TARGET_PAN;
		MY_ANGLE.TILT = 0;
		MY_ANGLE.ROLL = 0;
		force = MY._FORCE * 2;
		actor_turn(); //  
		force = MY._FORCE;
		MY._MOVEMODE = _MODE_WALKING;
		actor_move(); //  
		MY._COUNTER -= TIME;
		if (MY._COUNTER<=0) { MY._STATE = _STATE_HUNT; Soldier_AI_hunt(); return;		}
		if (my._HEALTH <= 0) { Soldier_AI_die(); return; }
	
		wait(1);	
	}
//MY._STATE=_STATE_HUNT;			
//return;	
}


var temp1;

function Soldier_AI_hunt()
{
//MY._STATE = _STATE_HUNT;
//while(MY._STATE == _STATE_HUNT)	

	if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._HUNTSOUND, 500);}
	
while(1)
{
	
	
	if (MY._COUNTER<=0)
	{
	//======================		scan_dist=Pre_AI_shot();
	//===========if visible?===============
			MY._SIGNAL =0;
			MY._IN_VIEW =0;
			temp.PAN = 120;
			temp.TILT = 180;
			temp.Z = 2000;
			indicator = _WATCH;
			scan_entity(MY.x,temp);
			if(MY._IN_VIEW == _DETECTED) 
			{
			wait(1);
			indicator = _WATCH;
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;
			trace(MY.POS,player.POS);
			if((RESULT > 0) && (YOU == player))	// spotted him!
				{
			MY._COUNTER=random(5)*10+30;
			Enemy_AI_shot_anim();
			//return;
				}
			}
	
	//======================		
	}	
	MY._COUNTER-=time;	
	
	
	//      
	//   
		temp.X = player.X - MY.X;
		temp.Y = player.Y - MY.Y;
		temp.Z = 0;
		vec_to_angle(MY_ANGLE,temp);	
		//wait(1);
		
		MY._TARGET_PAN = MY_ANGLE.PAN;
		MY_ANGLE.PAN = MY._TARGET_PAN;
		MY_ANGLE.TILT = 0;
		MY_ANGLE.ROLL = 0;
		force = MY._FORCE * 2;
		actor_turn(); //  
		
		temp=(player.X - MY.X)/10;
		temp1=(player.Y - MY.Y)/10;
		temp=(temp*temp+temp1*temp1)*10;
		
		//temp = (player.X - MY.X)*(player.X - MY.X)+(player.Y - MY.Y)*(player.Y - MY.Y);
		
		temp2=abs(player.z-my.z);
			if(temp < 1000)
				{
			 //			Enemy_AI_close_anim();
						return;					 
				} 
			else
				 {
			force = MY._FORCE;
			MY._MOVEMODE = _MODE_WALKING;
			actor_move(); //  
		 
				 }
	

//	MY._COUNTER-=time;	
//	force = 0;     // no force from this actor
//	actor_move();	// react to outside forces (gravity, etc) even while waiting
	//scan_dist=1000;
	wait(1);
	if (MY._STATE==_STATE_ESCAPE)		{Soldier_AI_wall(); return;}	
	if (my._HEALTH <= 0) { Soldier_AI_die(); return; }
	}
//return;	
}

//==================================================

ACTION actor_imp
{
	MY._FORCE = 3;
	MY._FIREMODE = FIRE_BALL+0.20;	// use default
	MY._HITMODE = 0;
	
	MY._MONSTR_TYPE=1;
	my._HUNTSOUND= imp_hunt;
	MY._WALKSOUND = imp_walk;
	MY._ALERTSOUND= imp_alert;
	MY._DEADSOUND=imp_dead;
	MY._PAINSOUND=imp_pain;

	
	MY._CLAWSOUND=imp_claw;
	
	MY._MUZZLE_VERT =255;
	MY._BASE_VERT=160;
	
	
	MY._I_ACCURACY = 0;
	
	MY._HEALTH = 40;
	MY._ARMOR=10;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = ON;
	
	
	MY._SIGNAL = 0;
	
	MY._STATE = _STATE_WAIT;
	my.ENABLE_stuck = ON; 	
	my.ENABLE_BLOCK = ON; 
	my.ENABLE_ENTITY = ON; // sensible for entity collision

	
	
	
	
	
	MY._WEAPONRANGE=1000.2;  
	
	  	my.overlay = ON; //ice is empty
  
  	you=ent_create(imp_ice,nullvector,ice_attach ); 
	you.TRANSPARENT=ON;
	you.PASSABLE=ON;
	you.BRIGHT=ON;	
	you.NOFOG=ON;
	you.SCALE_X=0.04;
	you.SCALE_z=0.1;
	you.SCALE_y=0.05;
  	you.ORIENTED =ON;
  	you.facing = off;
  	you.decal = off;
  	you.lightrange = 0; // don't illuminate the environment
 	you.light = ON; 
 	you.red=255;
 	you.green=255;
 	you.blue=255;

	
	
	//MY._MOVEMODE = _MODE_WALKING; // standing/walking/running
	
	
 	anim_init();
	drop_shadow();	// attach shadow to robot
	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
	//enemy_AI();

	
}


ACTION actor_guy
{
	MY._FORCE = 3;
	MY._FIREMODE=DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH+0.05;
	MY._HITMODE = 0;
	
	MY._MONSTR_TYPE=1;
	my._HUNTSOUND= guy_hunt;
	MY._WALKSOUND = guy_walk;
	MY._ALERTSOUND= guy_alert;
	MY._DEADSOUND=guy_dead;
	MY._PAINSOUND=guy_pain;

	
//	MY._CLAWSOUND=imp_claw;
	
	MY._MUZZLE_VERT =21;
//	MY._BASE_VERT=160;
	
	
	MY._I_ACCURACY = 0;
	
	MY._HEALTH = 40;
	MY._ARMOR=10;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = ON;
	
	
	MY._SIGNAL = 0;
	
	MY._STATE = _STATE_WAIT;
	my.ENABLE_stuck = ON; 	
	my.ENABLE_BLOCK = ON; 
	my.ENABLE_ENTITY = ON; // sensible for entity collision

	
	
	
	
	
	MY._WEAPONRANGE=1000.2;  
	
	//  	my.overlay = ON; //ice is empty
  /*
  	you=ent_create(imp_ice,nullvector,ice_attach ); 
	you.TRANSPARENT=ON;
	you.PASSABLE=ON;
	you.BRIGHT=ON;	
	you.NOFOG=ON;
	you.SCALE_X=0.04;
	you.SCALE_z=0.1;
	you.SCALE_y=0.05;
  	you.ORIENTED =ON;
  	you.facing = off;
  	you.decal = off;
  	you.lightrange = 0; // don't illuminate the environment
 	you.light = ON; 
 	you.red=255;
 	you.green=255;
 	you.blue=255;

	*/
	
	//MY._MOVEMODE = _MODE_WALKING; // standing/walking/running
	
	
 	anim_init();
	drop_shadow();	// attach shadow to robot
	My.EVENT=Enemy_AI_event;
	Soldier_AI_wait();
	//enemy_AI();

	
}



// Desc: Debugging utility, watches a ROBOT and sets flags using its values
//
//]- Mod Date: 7/11/00 DCP
//]-				removed tst_values

////////////////////////////////////////////////////////////////////////

// Desc: take damage and detect player
//
// Mod: 02/06/01 DCP
//		Added wait before shoot command to remove 'Dangerous instruction error'
//	   Replaced SHOOT with trace()
//
// Mod: 05/05/01 DCP
//		Modified damage from ranged explosion (replaced ABS with MAX)
// Mod Date: 05/16/02 DCP
//		Use temp in blast damage calculation to remove problem when multiple entities are hit
// Mod Date: 06/11/02 DCP
//		Added wait before trace command


// PLAYER ACTIONS
///////////////////////////////////////////////////////////////////////

//		player_walk_fight - player walk and fight action (basic FPS)

// temp flags only used in player_walk_fight action.
DEFINE	__NO_FALLDAMAGE, FLAG1;
DEFINE	__NO_JUMP,FLAG4;
DEFINE	__NO_BOB,FLAG5;
DEFINE	__NO_STRAFE,FLAG6;
DEFINE	__NO_TRIGGER,FLAG7;
DEFINE	__NO_DUCK,FLAG8;

/////////////////////////////////////////////////////////////////////////
// Desc: player action. Walk and fight (take damage, use gun)
//
//	Used for basic FPS type games.  Set the following skills and flags in
//WED to define the player (note: all skills default to 0, all flags
//default to OFF)
//
//	Flags
//		Flag1 - ON = *NO damage from falls*
//				 OFF = Take damage from falls
//		Flag2 - ON = move as a car (i.e. no turning unless moving),
//				 OFF = move normally
//		Flag3 - ON = adapt tilt and roll angle to slops
//				 OFF = stay upright while walking up and down slops (normal)
//		Flag4 - ON = *NO JUMPING*
//				 OFF = Allow jumping
//		Flag5 - ON = *NO first person view "head-bob" while moving*
//				 OFF = Enable first person view "head-bob"
//		Flag6 - ON = *Disable strafe*
//				 OFF = Allow strafing
//		Flag7 - ON = *Disable trigger* (open doors automatically)
//				 OFF = Trigger on
//		Flag8 - ON = *NO DUCKING*
//				 OFF = Enable ducking
//	Skills
//	_WALKSWIM_DIST, SKILL1;   	// Walk Distance . Swim Distance
//	_RUNCRAWL_DIST, SKILL2;   	// Run Distance . Crawl Distance
//	_STANDJUMP_TIME, SKILL3;  	// Stand Time . Jump Time
//	_ATTACKDUCK_TIME, SKILL4; 	// Attack Time . Duck Time
//	_RUNTHRESHOLD, SKILL14;		// Run Threshold
//	_FORCE, SKILL5;				// Force
//	_BANKING, SKILL6;				// Hitmode (actor only)
//	_MOVEMODE, SKILL7;			// Starting movemode
//	_HEALTH, SKILL9;	 			// Heath
//	_ARMOR, SKILL10;				// Armor
//
//]- Mod: 6/18/01 DCP
//]-		Created
//]-
//]- Mod: 8/21/01 DCP
//]-		Updated to use new WED skills
//
// Mod: 04/30/02 DCP
//		now calls player_move2 (improved movement and animation)
//
// uses _WALKSWIM_DIST,_RUNCRAWL_DIST,_STANDJUMP_TIME,_ATTACKDUCK_TIME
//	uses _FORCE,_BANKING,_MOVEMODE,_FIREMODE,_HEALTH,_ARMOR,_RUNTHRESHOLD
// uses __NO_FALLDAMAGE, __WHEELS, __SLOPES, __NO_JUMP, __NO_BOB, __NO_STRAFE
// uses __NO_TRIGGER, __NO_DUCK
ACTION player_walk_fight
{
// player
	// Flags-------------------------------
	IF(MY.__NO_FALLDAMAGE == ON) { MY.__FALL = OFF; }
	ELSE { MY.__FALL = ON; }
	//MY.__WHEELS = MY.FLAG2; // note: redundant
	//MY.__SLOPES = MY.FLAG3; // note: redundant
	IF(MY.__NO_JUMP == ON) { MY.__JUMP = OFF; }
	ELSE { MY.__JUMP = ON; }
	IF(MY.__NO_BOB == ON) { MY.__BOB = OFF; }
	ELSE { MY.__BOB = ON; }
	IF(MY.__NO_STRAFE == ON) { MY.__STRAFE = OFF; }
	ELSE { MY.__STRAFE = ON; }
	IF(MY.__NO_TRIGGER == ON) { MY.__TRIGGER = OFF; }
	ELSE { MY.__TRIGGER = ON; }
	IF(MY.__NO_DUCK == ON) { MY.__DUCK = OFF; }
	ELSE { MY.__DUCK = ON; }

	// Skill1------------------------------
	if (MY._HEALTH == 0) {			// if user didn't enter a value
		MY._HEALTH = 100;				// use default
	}

	if (MY._ARMOR < 0) {				// if bad value specified somehow
		MY._ARMOR = 0;					// default to zero
	}

	if( MY._FORCE <= 0)
	{
		MY._FORCE = 0.75;				// use default
	}


	player_anim_pack();           // use SKILLs 1-4 to set up animation

 	// Other-------------------------------
	MY.NARROW = ON;	// use narrow hull!
	MY.FAT = OFF;
 	MY.TRIGGER_RANGE = 5;
	if( MY._MOVEMODE <= 0)
	{
		MY._MOVEMODE = _MODE_WALKING;
	}

	if( MY._BANKING == 0)
	{
		MY._BANKING = -0.1;
	}
	MY._WALKSOUND = plr_walk;
	MY._ALERTSOUND= plr_walk;
	MY._DEADSOUND=plr_dead;
	MY._PAINSOUND=plr_pain;
	MY._MONSTR_TYPE=0;
// NOTE: comment player_move2() and uncomment player_move() to return
//to older method of player movement/animation
//	player_move();    // basic player move loop
  	player_move2();    // advanced player move loop
	player_fight();   // basic player fight loop
	drop_shadow();		// add a drop shadow (if the player has no 'real' shadow)
	show_panels();    // show heath/armor/ammo panel
}



// Desc - An entity action that will make a generic AI player with skill
//			 settings that can be set as above in WED
////////////////////////////////////////////////////////////
// These skills can be set in WED for the intended effect //
////////////////////////////////////////////////////////////
//	_WALKSWIM_DIST, SKILL1;   	// Walk Distance . Swim Distance
//	_RUNCRAWL_DIST, SKILL2;   	// Run Distance . Crawl Distance
//	_STANDJUMP_TIME, SKILL3;  	// Stand Time . Jump Time
//	_ATTACKDUCK_TIME, SKILL4; 	// Attack Time . Duck Time
//	_RUNTHRESHOLD, SKILL14;		// Run Threshold
//	_FORCE, SKILL5;				// Force
//	_HITMODE, SKILL6;				// Hitmode (actor only)
//	_MOVEMODE, SKILL7;			// Starting movemode
//	_FIREMODE, SKILL8; 			// Firemode
//	_HEALTH, SKILL9;	 			// Heath
//	_ARMOR, SKILL10;				// Armor
//	_ALERTNESS, SKILL11; 	   // Alertness
//	_ACCURACY, SKILL12; 			// Accuracy
//	_COWARDICE, SKILL13;	 		// Cowardice
//	_MUZZLEATTACH, SKILL15;		// Muzzle vertex . Attach vertex
////////////////////////////////////////////////////////////
// 07/16/01 - MWS - Created
// 07/24/01 - MWS - Overhauled (16 WED skills now!)
//
// Mod: 8/21/01 DCP
//		Updated to use new WED skills
//
// uses _WALKSWIM_DIST,_RUNCRAWL_DIST,_STANDJUMP_TIME,_ATTACKDUCK_TIME
// uses _FORCE,_HITMODE,_MOVEMODE,_FIREMODE,_HEALTH,_ARMOR,_ALERTNESS
// uses _ACCURACY,_COWARDICE,_RUNTHRESHOLD,_MUZZLEATTACH


// ==========================================================================


// Desc: attach a bounding cube to the model (for testing purposes)
//		The cube will be the color of the current state
// TODO: need to line it up better with 'you' entity

// Desc show a visible line from my.x to you.x


// desc used to handle a simple "type one" actor AI
/* help This actor AI does the following:

	_WALKSWIM_DIST, SKILL1;   	// Walk Distance . Swim Distance
	_RUNCRAWL_DIST, SKILL2;   	// Run Distance . Crawl Distance
	_STANDJUMP_TIME, SKILL3;  	// Stand Time . Jump Time
	_ATTACKDUCK_TIME, SKILL4; 	// Attack Time . Duck Time
	_RUNTHRESHOLD, SKILL14;		// Run Threshold
	_FORCE, SKILL5;				// Force (1.5)
	_HITMODE, SKILL6;				// Hitmode (actor only)
	_FIREMODE, SKILL8; 			// Firemode . Damage (DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH+0.10)
	_HEALTH, SKILL9;	 			// Heath (75)
	_ARMOR, SKILL10;				// Armor (0)
	_ALERTNESS, SKILL11; 	   // Alertness.AlertCone (1000.180)
	_ACCURACY, SKILL12; 			// Accuracy  (5)
	_COWARDICE, SKILL13;	 		// Cowardice (30)
	_MUZZLEATTACH, SKILL15;		// Muzzle vertex . Attach vertex
	_WEAPONRANGE, SKILL16		// range of the weapon (1500) . time to reload (.32)

 NOTES:
		Use the flag "-d showaiboxes" to display AI bounding boxes around
	this entity.
*/
//
// uses _WALKSWIM_DIST,_RUNCRAWL_DIST,_STANDJUMP_TIME,_ATTACKDUCK_TIME
// uses _FORCE,_HITMODE,_MOVEMODE,_FIREMODE,_HEALTH,_ARMOR,_ALERTNESS
// uses _ACCURACY,_COWARDICE,_RUNTHRESHOLD,_MUZZLEATTACH,_WEAPONRANGE


// Desc: type one actor death


// Desc: can we see the player from our position?
//
// uses: temp
//
// returns: 0 - no
//				1 - yes
//				negitive value on error

var	pap_pack1; // used to pack SKILL1
var	pap_pack2; // used to pack SKILL2

function player_anim_pack()
{
	pap_pack1 = 0;	//reset
	pap_pack2 = 0;	//reset

	// Stand Time
	temp = INT(MY._STANDJUMP_TIME);				  		// quarter seconds
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_stand_ticks = 16
	}
 	pap_pack1 += temp >> 10;		  			// fractional 10 bits (2^10 = 1024)
	//pap_pack1 += temp / 1024;		  	  	// fractional 10 bits (2^10 = 1024)


	// Jump Time
	temp = INT(FRC(MY._STANDJUMP_TIME) * 100); 		// quarter seconds
	if (temp == 0) {								// no value entered in WED
		temp = 2;									// default anim_jump_ticks = 6
	}
	pap_pack1 += temp << 6;			 			// middle 6 bits (2^6 = 64)
	//pap_pack1 += temp * 64;				 	// middle 6 bits (2^6 = 64)


	// Attack Time
	temp = INT(MY._ATTACKDUCK_TIME);   					// quarter seconds
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_attack_ticks = 16
	}
	pap_pack1 += temp << 12;			  		// upper 9 bits, shift 12 (2^12 = 4096)
	//pap_pack1 += temp * 4096;				// upper 9 bits, shift 12 (2^12 = 4096)


	// Duck Time
	temp = INT(FRC(MY._ATTACKDUCK_TIME) * 100);	 	// quarter seconds * 4 = game ticks
	if (temp == 0) {								// no value entered in WED
		temp = 2;									// default anim_duck_ticks = 8
	}
	pap_pack1 += temp; 							// lowest 6 bits


	// Walk Distance
	temp = INT(MY._WALKSWIM_DIST); 		// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_walk_dist = 1
	}
	pap_pack2 += temp << 10;					// next upper 5 bits (2^10 = 1024)
	//pap_pack2 += temp * 1024;			  	// next upper 5 bits (2^10 = 1024)


	// Swim Distance
	temp = INT(FRC(MY._WALKSWIM_DIST) * 100); 		// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_swim_dist = 1
	}
	pap_pack2 += temp;	  						// bottom 5 bits


	// Skill6------------------------------
	// Run Distance
	temp = INT(MY._RUNCRAWL_DIST);   					// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 6;									// default anim_run_dist = 1.5
	}
	pap_pack2 += temp << 15;	  	 			// upper 6 bits (2^15 = 2^10 * 2^5 = 1024 * 32)
	//pap_pack2 += temp * 1024 * 32;	  		// upper 6 bits (2^15 = 2^10 * 2^5 = 1024 * 32)


	// Crawl Distance
	temp = INT(FRC(MY._RUNCRAWL_DIST) * 100);	  	// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 3;									// default anim_crawl_dist = 0.8
	}
	pap_pack2 += temp << 5;			  			// upper 5 bits (2^5 = 32)
	//pap_pack2 += temp * 32;					// upper 5 bits (2^5 = 32)


	// Skill7------------------------------
	// Walk Or Run
	temp = INT(MY._RUNTHRESHOLD);   		 			// whole quants
	if (temp == 0) {								// no value entered in WED
		temp = 12;									// default walk_or_run = 12
	}
	pap_pack2 += temp >> 10;			  		// fractional 10 bits (2^10 = 1024)
	//pap_pack2 += temp / 1024;		  		// fractional 10 bits (2^10 = 1024)


	MY._ADVANIM_TICK = -1 * pap_pack1;		// activate advanced animation
	MY._ADVANIM_DIST  = -1 * pap_pack2;		// activate advanced animation
}



// Desc: what to do when the player is dead.
//
// Note: overwrite this with your own behavior on death
//		Three second delay added for effect and to fix "eye_height" reset problem
function	player_dead()
{
	waitt(48);		// wait for 3 seconds
 	menu_main();	// bring up menu.
}
function fight_event()
{
	if((EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
		|| (EVENT_TYPE == EVENT_SHOOT && indicator == _GUNFIRE))
	{
		MY._SIGNAL = _DETECTED;	// by shooting, player gives away his position
		
		
				

		if (indicator == _EXPLODE)
		{
			var	vec_temp[3];
			var	local_damage;

			vec_set(vec_temp.x,your.x);	// store source values
			// reduce damage according to distance
			// note: result is set by scan_entity to the correct distance
			local_damage = damage * max(0,(range - RESULT))/range;			// store damage

  			wait(1);	// wait a frame before doing a trace (avoid "dangerous instruction in event")
			temp = local_damage;

			// trace back to the source to see if we are protected
 			trace_mode = ignore_me + ignore_passable + ignore_passents;
 			if(trace(my.x,vec_temp.x) != 0) { return; }
		}
		else
		{
			temp = damage;
			
		}
		
		//if (MY._MONSTR_TYPE!=mtp) {
			//temp=0;
		
		//mtp=MY._MONSTR_TYPE+mtp*10;
		

		if(MY._ARMOR <= 0)
		{
			MY._HEALTH -= temp;

		}
		else
		{
			MY._ARMOR -= temp;
		}
		
		
		
   
   if (MY._HEALTH>0) 
   {	
	
   	if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._PAINSOUND, 1000);}
  
   }
	
	TRACE_MODE = IGNORE_ME + IGNORE_YOU + IGNORE_PASSABLE + IGNORE_MODELS + IGNORE_SPRITES + IGNORE_MAPS;
   TRACE (gun_muzzle,gun_target);


     if (RESULT <400)

       {

       temp = INT(RANDOM(3));
       
       if (temp == 1)

         {
         create(splash1_map,TARGET,blood_splash);  // create blood splash
         }
       if (temp == 2)
         {
         create(splash2_map,TARGET,blood_splash);  // create blood splash
         }
       if (temp == 0)
         {
          create(splash3_map,TARGET,blood_splash);
         }

     }
		
		//------end blood

	//}		
		
		
		
		return;
		//-----------blood
}
	if(EVENT_TYPE == EVENT_DETECT && YOU == player)
	{
		wait(1);	//fix for dangerous instruction
		indicator = _WATCH;
//---		SHOOT MY.POS,YOUR.POS;	// can player be seen from here?
		trace_mode = IGNORE_ME + IGNORE_PASSABLE + ACTIVATE_SHOOT;
		RESULT = trace(MY.POS,YOUR.POS); // if entity YOU was visible from MY position, its SHOOT event was triggered
		if((RESULT > 0) && (YOU == player)) // yes
		{
			MY._SIGNAL = _DETECTED;
		}
		return;
	}
}

// Desc: enable the player to take damage and die
//
// Mod Date: 05/01/02
//		Replaced call to state_die with local handling of player death
function player_fight()
{
	if(MY._HEALTH == 0) { MY._HEALTH = 100; }

	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
	MY.EVENT = fight_event;

	while(MY._HEALTH > 0)
	{
		if(MY._SIGNAL == _DETECTED) 	// Hit received?
		{
			MY._SIGNAL = 0;	// reset the _signal skill
			if(person_3rd == 0) { player_shake(); }
		}
		wait(1);
	}

	// Dead
	MY._HEALTH = 0;
	weapon_remove();	// prevent dead player firing
	my._MOVEMODE = _MODE_STILL; // stop the player from moving


	if(person_3rd == 0)
	{	// 1st person die action
		MY._MOVEMODE = 0;		// don't move anymore
		MY.EVENT = NULL;		// prevent health counting down
		player_tip();
		waitt(8);
	}
	else
	{
		//state_die();
		wait(1);	// let the animation state start the death cycle
		while(my._ANIMDIST != -99)	// not done with death cycle
		{
			wait(1);
		}
	}
	my._MOVEMODE = _MODE_NONE;	// stop movment
	player_dead();// handle being dead
}





// Desc: explode into x number of random models
//
// Mod Date: 8/22/00 DCP
//				Uses function parameter (numberOfParts) to determine
//			how many 'gib' parts to create
function	_gib(numberOfParts)
{
	temp = 0;
	while(temp < numberOfParts)
	{
		create(<gibbit.mdl>, MY.POS, _gib_action);
		temp += 1;
	}

}

// Desc: Init and animate a gib-bit
//
// Mod Date: 6/29/00 Doug Poston
//				Added rotation and alpha-fading
// Mod Date: 8/31/00 DCP
//				Scale absdist vector by movement_scale
//				Scale the gibbits down by the actor_scale
function _gib_action()
{
	// scall the bits down by the actor_scale amount
	vec_scale(MY.SCALE_X,actor_scale);

	// Init gib bit
	MY._SPEED_X = 25 * (RANDOM(10) - 5);    // -125 -> +125
	MY._SPEED_Y = 25 * (RANDOM(10) - 5);    // -125 -> +125
	MY._SPEED_Z = RANDOM(35) + 15;          // 15 -> 50

	MY._ASPEED_PAN = RANDOM(35) + 35;       // 35 -> 70
	MY._ASPEED_TILT = RANDOM(35) + 35;      // 35 -> 70
	MY._ASPEED_ROLL = RANDOM(35) + 35;      // 35 -> 70

	MY.ROLL = RANDOM(180);	// start with a random orientation
	MY.PAN = RANDOM(180);

	MY.PUSH = -1;	// allow user/enemys to push thru



	// Animate gib-bit
	MY.SKILL9 = RANDOM(50);
	while(MY.SKILL9 > -75)
	{
		abspeed[0] = MY._SPEED_X * TIME;
		abspeed[1] = MY._SPEED_Y * TIME;
		abspeed[2] = MY._SPEED_Z * TIME;

		MY.PAN += MY._ASPEED_PAN * TIME;
		MY.TILT += MY._ASPEED_TILT * TIME;
		MY.ROLL += MY._ASPEED_ROLL * TIME;

		vec_scale(absdist,movement_scale);	// scale absolute distance by movement_scale
		MOVE  ME,NULLSKILL,abspeed;

		IF(BOUNCE.Z)
		{
			MY._SPEED_Z = -(MY._SPEED_Z/2);
			if(MY._SPEED_Z < 0.25)
			{
				MY._SPEED_X = 0;
				MY._SPEED_Y = 0;
				MY._SPEED_Z = 0;
				MY._ASPEED_PAN = 0;
				MY._ASPEED_TILT = 0;
				MY._ASPEED_ROLL = 0;
			}
		}

		MY._SPEED_Z -= 2;
		MY.SKILL9 -= 1;

		wait(1);
	}


	// Fade out
	MY.transparent = ON;
	MY.alpha = 100;
	while(1)
	{
   	MY.alpha -= 5*time;
		if(MY.alpha <=0)
		{
			// remove
			ent_remove(me);
			return;
		}

   	wait(1);
	}
}

//]-- NOTE: coming soon! include <war2.wdl>;


//==========MY BLOOD


 function blood_splash()

    {


    blood_splash_counter += 1;  // inc splash counter

    //MY.TRANSPARENT = ON;

    MY.ORIENTED = ON;

    //MY.ALPHA = 70;

    MY.PASSABLE = ON;

    MY.OVERLAY = ON;
    
    scale_blood=int(random(4)+1)/20;

    MY.SCALE_X = scale_blood;

    MY.SCALE_Y = scale_blood;

    MY.SCALE_Z = scale_blood;

    vec_to_angle(MY.PAN,NORMAL); // rotate to target normal

    wait(5);



    if ( blood_splash_counter > 50)

      {

       blood_splash_counter = 0; // reset splash counter

      remove(ME);

      }

    }
    
function _hincrease () // executed when the player runs into the health    
{    
      YOU = PLAYER;    
      YOUR._HEALTH += 50; // player's health is increased by 50    
      REMOVE ME; // removes the health model    
}    
function add_health () // will run when the health model is created    
{    
      MY.ENABLE_IMPACT = ON; // sensitive to impact    
      MY.EVENT = _hincrease;    
}    
    

