// Template file v5.202 (02/20/02)
////////////////////////////////////////////////////////////////////////
// File: war.wdl
//		WDL prefabs for hostile entities
////////////////////////////////////////////////////////////////////////
//]- Mod Date: 8/22/00 DCP
//]-				Changed '_gib' function to take a parameter to determine
//]-			the number of pieces to create in the gib explosion.
//]- Mod Date: 8/31/00 DCP
//]-				Modified '_gib_action' function to scale absdist vector by movement_scale
//]-				Modified '_gib_action' function to scale the gibbits down by the actor_scale
//]- Mod Date: 10/31/00 DCP
//]-				Changed to 4.30 format
//]- Mod Date: 11/8/00 DCP
//]-          'attack_fire' & 'state_die': Replace set_frame with ent_frame
//]-
//]- Mod Date: 02/06/01 DCP
//]-		In 'fight_event':
//]-			Added wait before shoot command to remove 'Dangerous instruction error'
//]-	 	   Replaced SHOOT with trace()
//]-
//]-
//]- Mod: 05/05/01 DCP
//]-		In 'fight_event':
//]-			Modified damage from ranged explosion (replaced ABS with MAX)
//]-
//]- Mod Date: 05/16/01 DCP
//]-				Remove all 'BRANCH' commands (replace with <foo>(); return;)
//]-
//]- Mod Date: 05/18/01 DCP
//]-				Fixed "double shots" (the cause of robot1's self hits)
//]-
//]- Mod Date: 06/05/01 DCP
//]-		attack_approach(), avoid_walls(): Replaced TO_ANGLE with vec_to_angle()
//]-
//]- Mod Date: 06/21/01 DCP
//]-				Replaced SYNONYMs with pointers
//]-
//]- Mod: 07/19/01 MWS
//]-		state_wait(): Use specified cowardice value instead of universal 30.
//]-				Use specified alertness instead of universal 1000.
//]-				Also now skips the player scan entirely if alertness is zero.
//]-
//]-		attack_fire(): MY_ANGLE used in shooting at player now varies by a random
//]-				amount between -MY._I_ACCURACY to +MY._I_ACCURACY
//]-
//]- Mod Date: 7/26/01 MWS
//]-		attack_transitions(): Made "escape" branch test for MY._I_COWARDICE
//]-				instead of default 30.
//]-
//]- Mod Date: 12/18/01
//]-		Added WED 'uses' comments to all WED editable fields
//]-
//]- 7/12/02 JCL - menu_default re-renamed to menu_main
////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////
//var temp_robot {} // robot coordinates, add it at the beginning of the file    




DEFINE splash1_map,<sprite\blood1dec.pcx>;
DEFINE splash2_map,<sprite\blood2dec.pcx>;
DEFINE splash3_map,<sprite\blood3dec.pcx>;
var scale_blood;
var blood_splash_counter = 0;

//string imp_ice=<models\enemy\imp_ice.bmp>;

//DEFINE WAR_CHAT_ON;	// display 'thought' actions for the AIs
IFDEF WAR_CHAT_ON;
	STRING war_wait_str,"Waiting...";
	STRING war_attack_str,"Attacking!!!";
	STRING war_hunt_str,"Searching...";
	STRING war_escape_str,"Retreat!!!";
	STRING war_dead_str,"I have been undone!";
ENDIF;


SOUND gib_sound=<sounds\player\gib.wav>;

//SOUND imp_walk=<tap.wav>;
sound imp_alert=<sounds\imp\alert.wav>;
SOUND imp_pain=<sounds\imp\pain.wav>;
SOUND imp_dead=<sounds\imp\death.wav>;
sound imp_hunt=<sounds\imp\hunt.wav>;
sound imp_claw=<sounds\imp\dsclaw.wav>;
sound rev_punch=<sounds\revenant\punch.wav>;


SOUND guy_walk=<sounds\soldier\walk.wav>;
sound guy_alert=<sounds\soldier\alert.wav>;
SOUND guy_pain=<sounds\soldier\pain.wav>;
SOUND guy_dead=<sounds\soldier\death.wav>;
sound guy_hunt=<sounds\soldier\hunt.wav>;

SOUND rev_walk=<sounds\revenant\walk.wav>;
sound rev_alert=<sounds\revenant\alert.wav>;
SOUND rev_pain=<sounds\revenant\pain.wav>;
SOUND rev_dead=<sounds\revenant\death.wav>;
sound rev_hunt=<sounds\revenant\hunt.wav>;

SOUND dem_walk=<sounds\demoness\walk.wav>;
sound dem_alert=<sounds\demoness\alert.wav>;
SOUND dem_pain=<sounds\demoness\pain.wav>;
SOUND dem_dead=<sounds\demoness\death.wav>;
sound dem_hunt=<sounds\demoness\hunt.wav>;


SOUND cyb_walk=<sounds\cyberdemon\walk.wav>;
sound cyb_alert=<sounds\cyberdemon\alert.wav>;
SOUND cyb_pain=<sounds\cyberdemon\pain.wav>;
SOUND cyb_dead=<sounds\cyberdemon\death.wav>;
sound cyb_hunt=<sounds\cyberdemon\walk.wav>;


SOUND h_walk=<sounds\women\walk.wav>;
sound h_alert=<sounds\women\alert.wav>;
SOUND h_pain=<sounds\women\pain.wav>;
SOUND h_dead=<sounds\women\death.wav>;
sound h_hunt=<sounds\women\hunt.wav>;



/*
SOUND dr_walk=<sounds\droid\walk.wav>;
sound dr_alert=<sounds\droid\alert.wav>;
SOUND dr_pain=<sounds\droid\pain.wav>;
SOUND dr_dead=<sounds\droid\death.wav>;
sound dr_hunt=<sounds\droid\walk.wav>;
*/
//bind <models\enemy\imp5.mdl>;
//bind <models\enemy\badguy.mdl>;
string stGuy=<models\enemy\badguy.mdl>;

string leg_gib=<leg_gib.mdl>;
//sound rail_shot=gun_rail_s;


//////////////////////////////////////////////////////////////////////
// WAR.WDL - fighting behaviour
///////////////////////////////////////////////////////////////////////
//IFNDEF WAR_DEFS;
 //DEFINE ACTOR_EXPLO,<explo+7.bmp>;
 //DEFINE ACTOR_EXPLO_FRAMES,7;
//ENDIF;

///////////////////////////////////////////////////////////////////////
var freeze_actors = 0;	// 1,2 for testing purposes
var distance;

///////////////////////////////////////////////////////////////////////
DEFINE _STATE_WAIT,1;
DEFINE _STATE_ATTACK,2;
DEFINE _STATE_ESCAPE,3;
DEFINE _STATE_DIE,4;
DEFINE _STATE_FREEZE,5;       // 05/15/01 DCP: Changed from 4->5
DEFINE _STATE_HUNT,6;
DEFINE _STATE_COMBAT,7;

DEFINE _MUZZLE_VERT,SKILL32;
DEFINE _I_ACCURACY,SKILL33;		// 07/19/01 MWS: Added
DEFINE _I_COWARDICE,SKILL34;		// 07/19/01 MWS: Added
DEFINE _I_ALERTNESS,SKILL35;		// 07/19/01 MWS: Added


// DEFINE USER INPUT SKILLs
// These skill will be inputted from WED and work with entities that use the actions:
//    "player_walk_fight" and "actor_walk_fight"
DEFINE	_WALKSWIM_DIST, SKILL1;   // Walk Distance . Swim Distance
DEFINE	_RUNCRAWL_DIST, SKILL2;   // Run Distance . Crawl Distance
DEFINE	_STANDJUMP_TIME, SKILL3;  // Stand Time . Jump Time
DEFINE	_ATTACKDUCK_TIME, SKILL4; // Attack Time . Duck Time
DEFINE	_RUNTHRESHOLD, SKILL14;	// Run Threshold
//DEFINE	_FORCE, SKILL5;			// Force
//DEFINE	_BANKING, SKILL6;			// Banking amount (player only)
//DEFINE	_HITMODE, SKILL6;			// Hitmode (actor only)
//DEFINE	_MOVEMODE, SKILL7;		// Starting movemode
//DEFINE	_FIREMODE, SKILL8;		// Firemode
//DEFINE	_HEALTH, SKILL9;			// Heath
//DEFINE	_ARMOR, SKILL10;			// Armor
DEFINE	_ALERTNESS, SKILL11;    // Alertness
DEFINE	_ACCURACY, SKILL12; 		// Accuracy
DEFINE	_COWARDICE, SKILL13;		// Cowardice
DEFINE	_MUZZLEATTACH, SKILL15;	// Muzzle vertex . Attach vertex
DEFINE	_WEAPONRANGE, SKILL16;	// weapon range for AI actors
define   _PAINSOUND, SKILL46;
define   _DEADSOUND, SKILL47;
define   _ALERTSOUND, SKILL48;
define   _SND_HANDLE, SKILL49;
//define   _HUNTSOUND, SKILL50;
define  _MONSTR_TYPE,SKILL52;
define _ICE,SKILL53;
define _HUNTSOUND,SKILL54; 
define _CLAWSOUND,SKILL55;
//string actor_explosion_mdl = <explosion.mdl>;
	
define _IN_VIEW,SKILL56;

define _MUZZLE_VERT1,SKILL60;
define _MOVE_TIMER,SKILL65;

define _FORCEX,SKILL62;
define _FIREBALL,SKILL64;

define _VOICE_TIMER,SKILL70;
define _rotate, skill67;

define _ZMAX_LADDER,SKILL96;
define _ZMIN_LADDER,SKILL97;
define _X_LADDER,SKILL98;
define _y_LADDER,SKILL99;

define _XLAST,SKILL95;
define _YLAST,SKILL94;

///////////////////////////////////////////////////////////////////////
//entity* test_actor;	// test actor entity pointer. Used in robot_test

//DEFINE	kActorAIAvoidDist, 150;    // value used in distance traces
var kActorAIAvoidDist=120;

STRING	robot_attack_str, "attack";	// attack frame names used by robot

function ice_attach() 
{ 
	while(you)
	{ 
	vec_for_vertex(my.x,you,371); 
	vec_for_vertex(nullvector,you,302); //       
	vec_sub(nullvector,MY.pos); 
	vec_to_angle(my.angle,nullvector); 
	wait(1); 
	} 
}




function Enemy_AI_event()
{
	var tyou;
	/*
	if((EVENT_TYPE == EVENT_SCAN && indicator == _RESCUE))
	{
		if (my._MONSTR_TYPE!=10) {return;}
		snd_play (snd_resque, 50,0);
		ENT_REMOVE(ME);
	}
	*/
	
		
	
		
	
	if((EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
		|| (EVENT_TYPE == EVENT_SHOOT && indicator == _GUNFIRE)
		
		|| (event_type==event_entity))
		//|| (EVENT_TYPE == EVENT_SCAN && indicator == _GUNFIRE)
		{




if (event_type==event_entity)
{
	
	if (my==player)
	{
		       if (you.SKILL52==_LADDER ) 
       	            {
       	            	MY._y_LADDER=my.y;
       	            	MY._x_LADDER=my.x;
	  	
       	            	MY._ZMAX_LADDER=you.max_z+you.z+32;
       	            	My._ZMin_LADDER=you.min_z;
       	            	
       	            	
       	            }
		
		
	}
	return;
}


		MY._SIGNAL = _DETECTED;
		
		
	if (you._MONSTR_TYPE==my._MONSTR_TYPE) {return;}
	
	
	
if(EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
{
		tyou=you;
		trace_mode = IGNORE_ME + IGNORE_PASSABLE + ignore_sprites+ignore_push;
		trace(my.x,you.x);
		if (tyou!=you) {return;}
		
}
		
		
		
	emit(10,target,particle_blood); // emit sparks	
	
	
			my._ARMOR -= damage;
		if (my._ARMOR < 0)
	{
	
		my._HEALTH += my._ARMOR;
		my._ARMOR = 0;
	}
   if (MY._HEALTH>0) 
   {	
	
   	if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._PAINSOUND, 600);}
  
   }
   
//=======================================	
	TRACE_MODE = IGNORE_ME + IGNORE_YOU + IGNORE_PASSABLE + IGNORE_MODELS + IGNORE_SPRITES + IGNORE_MAPS+ignore_push;

	
	vec_diff(temp2,target.x,you.x);
	vec_normalize(temp2,100);
	vec_add(temp2, target.x);  // gun target = gun_muzzle + shot_speed
	
   TRACE (target.x,temp2);
   
     if (RESULT >0)

       {

       temp = INT(RANDOM(3));
       
       if (temp == 1)

         {
         create(splash1_map,TARGET,blood_splash);  // create blood splash
         }
       if (temp == 2)
         {
         create(splash2_map,TARGET,blood_splash);  // create blood splash
         }
       if (temp == 0)
         {
          create(splash3_map,TARGET,blood_splash);
         }

     }
//================================================		
		return;
		}	
		
		
		if (EVENT_TYPE == EVENT_DETECT && you == player)
		{
				MY._IN_VIEW = _DETECTED;
		return;
		}

}			

//===================================================

function Breakable_AI_event()
{
	var tyou;
	if((EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
		|| (EVENT_TYPE == EVENT_SHOOT && indicator == _GUNFIRE))

		{
		if(EVENT_TYPE == EVENT_SCAN && indicator == _EXPLODE)
				{
				tyou=you;
				trace_mode = IGNORE_ME + IGNORE_PASSABLE + ignore_sprites+ignore_push;
				trace(my.x,you.x);
				if (tyou!=you) {return;}
				}
		my._HEALTH -= damage;
		if (my._HEALTH<0)
		 	{
		 	do_explosion(100,10,0);	
			ent_remove(me);
			}
		}
}			

//===================================================

function Pre_AI_Hear()
{

if (ALERT_SOUND_PLACE==0) {return(-1);};

temp=vec_dist(ALERT_SOUND_PLACE,my.x);

if (temp>1000) {return(-1);};

			trace_mode = IGNORE_ME + IGNORE_PASSABLE + ignore_you+IGNORE_PASSENTS+IGNORE_SPRITES+ignore_push+ignore_models;
			trace(MY.POS,ALERT_SOUND_PLACE);
			
			if(RESULT == 0) 
			{
			return(1);
	
			}
			return(-1);

}



function Pre_AI_View()
{
//===========if visible?===============
		//	MY._SIGNAL =0;
			MY._IN_VIEW =0;
			
			
			if (vec_dist(player.x,my.x)<120)
			{
				//MY._IN_VIEW == _DETECTED;
				return(1);
			}
			
			
			temp.PAN = 120;
			temp.TILT = 120;
			temp.Z = 1000;
			indicator = _WATCH;
			scan_entity(MY.x,temp);
			
			if(MY._IN_VIEW != _DETECTED) {return(-1);}
			
			//wait(1);
			indicator = _WATCH;
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS+IGNORE_SPRITES+ignore_push;
			trace(MY.POS,player.POS);
			if((RESULT > 0) && (YOU == player))	// spotted him!
			{
			MY._YLAST=player.y;
			MY._XLAST=player.x;
			return(1);
			}
			return(-1);

}



function AI_shot()
{
	
	

	
					// reset entity's animation time to zero
	if(my._MUZZLE_VERT > 0)       // if we are using a muzzle vertex
	{
		// attach to gun point
		vec_for_vertex(gun_muzzle,my,my._muzzle_vert);
	}
	else
	{
		// else use the actor origin
		vec_set(gun_muzzle,my.x);
	}

//Monster make headshoT!
	vec_set(temp2,player.x);
	temp2.z=player.MAX_Z/2+player.z;
	

//	vec_diff(temp,player.x,gun_muzzle.x);
	vec_diff(temp,temp2.x,gun_muzzle.x);
	
	vec_normalize(temp,int(MY._WEAPONRANGE));

	// offset vertor with accuracy modifier
	temp2.pan =  (random(my._I_ACCURACY) - (0.5*(my._I_ACCURACY)));
	temp2.tilt = (random(my._I_ACCURACY) - (0.5*(my._I_ACCURACY)))/4;
	temp2.roll = 0;
	vec_rotate(temp,temp2);

//	temp2.z+=20; //player head
	
  	vec_set(shot_speed,temp);
  	vec_set(gun_target,gun_muzzle.x);
	vec_add(gun_target,temp);  // gun target = gun_muzzle + shot_speed
	
	fire_mode=int(MY._FIREMODE);
	damage = frc(MY._FIREMODE) * 100;


	my.passable = ON;   // make it so the gun doesn't hit the player



	// particle trail shot (line of particles)
	if((fire_mode & MODE_FIRE) == FIRE_PARTICLE)
	{
		ent_playsound (MY, gun_rail_s, 800);
		vec_set(p,gun_muzzle);
		vec_set(p2,gun_target);
		particle_line();
	}

	// single particle
	if((fire_mode & MODE_FIRE) == FIRE_DPARTICLE)
	{ emit(1,gun_muzzle,particle_shot); }

	// fireball
	if((fire_mode & MODE_FIRE) == FIRE_BALL)
	{
		// note: fireballs never stop moving until they hit something
		
		
		
		
		vec_scale(shot_speed,0.0725); // 1/16th the total distace
		
		
		if (my._MONSTR_TYPE==2)
		{
			damage=3;
			create(impfireball,gun_muzzle,bullet_shot);
			you._MONSTR_TYPE=my._MONSTR_TYPE;
		}
		
		if (my._MONSTR_TYPE==3)
		{
			damage=10;
			create(skufireball,gun_muzzle,fireball_shot);
			you._MONSTR_TYPE=my._MONSTR_TYPE;
		}
		if (my._MONSTR_TYPE==4)
		{
			damage=8;
			create(demfireball,gun_muzzle,bullet_shot);
			you._MONSTR_TYPE=my._MONSTR_TYPE;
		}

		if (my._MONSTR_TYPE==6)
		{
			damage=10;
			create(demfireball,gun_muzzle,bullet_shot);
			you._MONSTR_TYPE=my._MONSTR_TYPE; //not self damage Doom2!
			wait(1);
			//wait(1);
			//MY._MUZZLE_VERT1
			damage=10;
			vec_for_vertex(gun_muzzle,my,my._muzzle_vert1);
			create(demfireball,gun_muzzle,bullet_shot);
					you._MONSTR_TYPE=my._MONSTR_TYPE; //not self damage Doom2!

			
		}
		
		
		/*
	you.passable=on;	
	 you.enable_entity = on;
    you.enable_impact = on;
    you.enable_block = on;
    */
		

		
	}

	// rocket model
	if((fire_mode & MODE_FIRE) == FIRE_ROCKET)
	{
		ent_playsound (MY, rocket_launc, 600);
		vec_scale(shot_speed,0.04); // 1/25
  		create(<missile.mdl>,gun_muzzle,rocket_launch);
  		you._MONSTR_TYPE=my._MONSTR_TYPE;
	//	you.ENABLE_detect = Off; // sensible for scans
	//	you.ENABLE_scan = Off; // sensible for scans
	//	you.ENABLE_shoot = Off;
	//	you.ENABLE_stuck = Off; // sensible for stuck
	
//	 you.enable_entity = on;
 //   you.enable_impact = on;
 //   you.enable_block = on;

	}

	// eject brass?
	if((fire_mode & GUNFX_BRASS) != 0)
	{
	 	emit(1,gun_muzzle,particle_gunBrass); // emit brass
	}

	if((fire_mode & MODE_DAMAGE) == DAMAGE_SHOOT)
	{
		_gun_shot_damage_shoot();	// handle 'shot' weapons
	}
	
	my.passable = Off;   // make it so the gun doesn't hit the player

}



var angl_temp=0;
var angle_look[6]=-60,60,120,-120,-180,180;
		
function AI_obstacle()		
{
	
	my._rotate=0;
	vec_set(temp,nullvector);
	temp.x = 32;
	vec_rotate(temp.x,MY._TARGET_PAN);	// vector pointing ahead of the actor
	vec_add(temp.x,my.x);      // offset by the actor
	trace_mode = ignore_me + ignore_passable + use_box+ignore_push+ ignore_sprites;
	//+activate_sonar;
	vec_set(temp2,my.x);
	temp2.z+=8;
	temp.z+=8;
	//my.min_z+=16;
	//indicator = _HANDLE;
	trace(temp2,temp.x);
	if (result!=0) {
		
			if (you!=NULL)
   		{
				// 
				if (you==player) {my._rotate=-3;	return;};
								
				//    ?  ?
			if (you.__GATE==ON && you._KEY == 0)
									 {
   							Direct_Open_Door(you);
  								return;	
   									}
   		
				
   			if (you!=player) {you._SIGNAL=_DETECTED;};
   			
				my._rotate=-2;
				
				return;
   			
   			
			}
				if(normal.z >0.5) { return; }
				my._rotate=-1;
				return;
						}
						
	 //.   
		vec_set(temp2,temp);
		//temp2.z-=80;
		temp2.z+= my.min_z-32;
		
		
		trace_mode = ignore_me + ignore_passable+ignore_push+ignore_sprites+ignore_models;
		trace(temp,temp2);
						if (result==0)
						{
						my._rotate=-1;
						return;
						}

}            

function Killer_AI()
{

	wait(1);
	

	
	
if (my._state==_STATE_DIE)
			{
			AI_die(); 
			return;
			}

if (my._state==_STATE_COMBAT)
			{
			AI_close_attack();
			return;
			}

if (my._state==_STATE_HUNT)
		{
			if (MY._MONSTR_TYPE==10)
			{
				AI_NPC();
			} else {
				AI_hunt();
			}
			return;
		}
if (MY._STATE==_STATE_ATTACK)
			{
			AI_shot_anim();	
			return;
			}		
			
		
			
}

function AI_close_attack()
{

		MY._ANIMDIST = 0;
		while(MY._ANIMDIST < 50)
			{
				
				
				
//		temp.X = player.X - MY.X;
//		temp.Y = player.Y - MY.Y;
//		temp.Z = 0;
		
		vec_set(temp,player.x); 
		vec_sub(temp,my.x);

		
		vec_to_angle(MY._TARGET_PAN,temp);
		
		
			
		AI_rotate();
		MY._ANIMDIST += 8.0 * TIME; 
					if (MY._MONSTR_TYPE==4) {
					ent_frame("jump",MY._ANIMDIST);	
					}
					if (MY._MONSTR_TYPE==2) {
					ent_frame("attack",MY._ANIMDIST);	
					}
					if (MY._MONSTR_TYPE==3) {
					ent_frame("attack",MY._ANIMDIST);	
					}
					wait(1);
			}	
				indicator = _GUNFIRE;
				damage=5;
				vec_set(temp,nullvector);
				temp.x = 100;
				vec_rotate(temp.x,my.pan);	// vector pointing ahead of the actor
				vec_add(temp.x,my.x);   
 				trace_mode = ignore_me + ignore_passable+ignore_sprites+activate_shoot+ignore_push; 
            trace(my.x, temp.x); 
	          wait(1);
            if (result != 0) 
                   { 
        			if (snd_playing(MY._SND_HANDLE)==0)	{MY._SND_HANDLE=ent_playsound (MY, MY._CLAWSOUND, 500);}	            
                    } 
			MY._STATE = _STATE_HUNT;		
			Killer_AI();
			
}


function AI_hunt()
{
	//var dist_to_player=0;
	
while(my._state==_STATE_HUNT)
{
//         		
if (MY._VOICE_TIMER<0)
	{
	ent_playsound (MY, MY._HUNTSOUND, 500);
	MY._VOICE_TIMER=(random(5)+10)*10;
	}	
//  		
	if (my._rotate==0) //     
	{
	MY._TARGET_PAN=MY.PAN;
	AI_obstacle();
	
	if (MY._MONSTR_TYPE==2 ||
		MY._MONSTR_TYPE==4 ||
		MY._MONSTR_TYPE==3  ) {
	
	if (my._rotate==-3)
							{
		my._state=_STATE_COMBAT;
		Killer_AI();
		return;
							}
									}
	
	if (my._rotate<0) {
//===========================		
//       
// 		

		if (random(2)>1)	{
			
		vec_set(temp,player.x); 
		vec_sub(temp,my.x);

			} else {
			
		temp.X = MY._XLAST - MY.X;
		temp.Y = MY._YLAST - MY.Y;
						}
		
//		temp.Z = 0;
		

		
		vec_to_angle(MY._TARGET_PAN,temp);	
//     		
//===========================		
	angl_temp=0;
	// 
	//old_pan=MY._TARGET_PAN;
	while (angl_temp<5)
			{
			AI_obstacle();
			if (my._rotate==0) {break;}
			//MY._TARGET_PAN+=60;
			//    
			//   
			//MY._TARGET_PAN=old_pan;
			MY._TARGET_PAN=my.pan+angle_look[angl_temp]+random(10)-5;
			
			angl_temp+=1;
			}			
	my._rotate=1;		
	MY.SKILL88=random(5)*5+16;	
						}	
			
	}
//========================================
	if (my._rotate==0 && MY.SKILL88<0) //   
	{
	//   
	//	temp.X = player.X - MY.X;
	//	temp.Y = player.Y - MY.Y;
	//		temp.X = MY._XLAST - MY.X;
	//	temp.Y = MY._YLAST - MY.Y;

	//	if (random(2)>1)	{
			
	//	temp.X = player.X - MY.X;
	//	temp.Y = player.Y - MY.Y;
		//	} else {
			
		vec_set(temp,player.x); 
		vec_sub(temp,my.x);
		vec_to_angle(MY._TARGET_PAN,temp); 	
	//	temp.X = MY._XLAST - MY.X;
	//	temp.Y = MY._YLAST - MY.Y;
				//		}
	
		//temp.Z = 0;
		//vec_to_angle(MY._TARGET_PAN,temp);	
	}	
	if (my._rotate==0)
		{
			force = MY._FORCE;
			MY._MOVEMODE = _MODE_WALKING;
			actor_move2(); //  
		} else {
			force = 0;
			MY._MOVEMODE = _MODE_WALKING;
			actor_move2(); //   ,      
		}	
//=====================================		
AI_rotate();
//==========================================	
	if (MY._COUNTER<=0)
	{
			if (Pre_AI_shot()==1) {

			
			MY._COUNTER=random(5)*5+15;
			my._state=_STATE_ATTACK;
				
		
				}
	}	
	MY._COUNTER-=time;	
	MY.SKILL88-=time;		
	MY._VOICE_TIMER-=TIME;		
	wait(1);
if (my._HEALTH <= 0) {	my._state=_STATE_DIE;}

	}
	Killer_AI();
}

//================================================
function AI_NPC()
{
	
while(my._state==_STATE_HUNT)
{
//         		
if (MY._VOICE_TIMER<0)
	{
	ent_playsound (MY, MY._HUNTSOUND, 500);
	MY._VOICE_TIMER=(random(5)+5)*10;
	
	
	//===========================
	
	temp.PAN = 360;
	temp.TILT = 360;
	temp.Z = 300;
	indicator = _RESCUE;
	scan_entity(MY.x,temp);

	
	
	//=========================
	}	
//  		
	if (my._rotate==0) //     
	{
	MY._TARGET_PAN=MY.PAN;
	AI_obstacle();
	
	
	if (my._rotate<0) {
//===========================		
//       
// 		
//       
// 		
//		temp.X = player.X - MY.X;
//		temp.Y = player.Y - MY.Y;
//		temp.Z = 0;
		
		vec_set(temp,player.x); 
		vec_sub(temp,my.x);

		
		vec_to_angle(MY._TARGET_PAN,temp);	
	angl_temp=0;
	// 
	//old_pan=MY._TARGET_PAN;
	while (angl_temp<5)
			{
			AI_obstacle();
			if (my._rotate==0) {break;}
			//MY._TARGET_PAN+=60;
			//    
			//   
			//MY._TARGET_PAN=old_pan;
			MY._TARGET_PAN=my.pan+angle_look[angl_temp]+random(10)-5;
			angl_temp+=1;
			}			
	my._rotate=1;		
	MY.SKILL88=random(5)*5+36;	
						}	
			
	}
//========================================

	if (my._rotate==0 && MY.SKILL88<0) //   
	{
	//   
//		temp.X = player.X - MY.X;
//		temp.Y = player.Y - MY.Y;
//		temp.Z = 0;
		
		vec_set(temp,player.x); 
		vec_sub(temp,my.x);

		
		vec_to_angle(MY._TARGET_PAN,temp);	
	}	
	if (my._rotate==0)
		{
			force = MY._FORCE;
			MY._MOVEMODE = _MODE_WALKING;
			actor_move2(); //  
		} else {
			force = 0;
			MY._MOVEMODE = _MODE_WALKING;
			actor_move2(); //   ,      
		}	
//=====================================		
AI_rotate();
//==========================================	
	MY.SKILL88-=time;		
	MY._VOICE_TIMER-=TIME;		
	wait(1);
if (my._HEALTH <= 0) {	my._state=_STATE_DIE;}
	}
	Killer_AI();
}
//=====================================================



function AI_rotate()
{
		force = MY._FORCE * 2;
//=========================================
	temp = ang(MY._TARGET_PAN-MY.PAN);
	
	if (abs(temp)<5) 
	{
		my._rotate=0;
	} 
	
	else {
	if(temp > 5)
	{
		aforce.PAN = force;
	}
	else
	{
		if(temp < -5)
		{
			aforce.PAN = -force;
		}
		else
		{
			aforce.PAN = force * temp * 0.25;
		}
	}
	MY.PAN += 2*aforce.pan  * TIME;
}	

}


function AI_shot_anim()
{

my.light = On;

	
	MY._STATE=_STATE_ATTACK;
				MY._ANIMDIST = 0;
				while(MY._ANIMDIST < 50)
				{
					MY._ANIMDIST += 8.0 * TIME; 
					ent_frame("attack",MY._ANIMDIST);
					if (my._HEALTH <= 0) {	my._state=_STATE_DIE; Killer_AI(); return;}
					wait(1);
				}
	
				AI_shot();
				my.light = Off;
				MY._STATE=_STATE_HUNT;	
				Killer_AI();			
			
}

function Pre_AI_shot()
{
//===========if visible?===============

			MY._IN_VIEW =0;
			temp.PAN = 30;
			temp.TILT = 120;
			temp.Z = 3000;
			indicator = _WATCH;
			scan_entity(MY.x,temp);
			
			if(MY._IN_VIEW != _DETECTED) {return(-1);}
			
			indicator = _WATCH;
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_SPRITES+ignore_push;
			trace(MY.POS,player.POS);
			if((RESULT > 0) && (YOU == player))	// spotted him!
			{
				
			MY._YLAST=player.y;
			MY._XLAST=player.x;
			return(1);
	
			}
			return(-1);

}


function Enemy_AI_collision()
{
	// 
	if (you._MONSTR_TYPE<=0) {return;};
		you._SIGNAL = _DETECTED;
		if (you._MONSTR_TYPE==my._MONSTR_TYPE) {return;}
		
		you._ARMOR -= damage;
		if (you._ARMOR < 0)
			{
			you._HEALTH += you._ARMOR;
			you._ARMOR = 0;
			}
			
			
			
			emit(10,my.x,particle_blood); // emit sparks		
		   if (you._HEALTH>0 && you._PAINSOUND!=0) 
   		{	
	   	if (snd_playing(you._SND_HANDLE)==0)	{you._SND_HANDLE=ent_playsound (you, you._PAINSOUND, 600);}
  			}
}			


/*
function Enemy_AI_collision()
{

		you._SIGNAL = _DETECTED;
		if (you._MONSTR_TYPE==my._MONSTR_TYPE) {return;}
		you._STATE=STATE_PAIN;
		you._ARMOR -= damage;
		if (you._ARMOR < 0)
			{
			you._HEALTH += you._ARMOR;
			you._ARMOR = 0;
			}
}			
*/

/*
function actor_move2() 
{
	
	force.Y = 0;
    vec_set(temp,my.x);
    temp.z += my.min_z-16; // calculate a position 4000 quants below the player
    // set a trace mode for using the player's hull, and detecting map entities and level surfaces only 
    trace_mode = ignore_me+ignore_sprites+ignore_passable+ignore_push+ignore_models;
    result = trace(my.x,temp); // subtract vertical distance to ground
    

//	drop_my_shadow();


    if (RESULT > ABS(MY.MIN_Z)+5 || result==0) // in the air?
    { 
  	  	force.X = 0; // no pushing force
     	force.Y = 0;
     	force.Z = -5; // gravity force
     	friction = 0.01; // air friction
   //  	MY.__FALL = On;
    }
    else // on or near ground
    { 
      force.Z = -0.9*(MY.MIN_Z+RESULT-5);//ground elasticity
      friction = 0.7; // ground friction
	 //  MY.__FALL = Off;
	}

    MY._SPEED_X = TIME*force.X + max(1-TIME*friction,0)*MY._SPEED_X; // calculate ahead speed
    MY._SPEED_y = TIME*force.y + max(1-TIME*friction,0)*MY._SPEED_y; // calculate ahead speed
    MY._SPEED_z = TIME*force.Z + max(1-TIME*friction,0)*MY._SPEED_z; // calculate vertical speed
    
    //wait(1);
    
    vec_set(temp,nullvector);
    
    dist.X = TIME * MY._SPEED_X; // distance ahead
    dist.y = TIME * MY._SPEED_y; // distance down
    //dist.Z = TIME * MY._SPEED_z; // distance down
    dist.Z=0;
	temp.Z = TIME * MY._SPEED_z; // distance down
    move_mode = ignore_passable + ignore_push+ignore_models+ignore_sprites;
    
    
    
    
    result=ent_MOVE(dist,temp); // move the player
 
 	vec_scale(dist,movement_scale);	// scale distance by movement_scale
 
 	if(result > 0)
	{
		// only use the relative distance traveled (for animation)
		my_dist = vec_length(dist);
	}
	else
	{
		// player is not moving, do not animate
		my_dist = 0;
	//	my._rotate=1;	
	}
 //=========================================
 
 			// walking animation
		if(MY._MOVEMODE == _MODE_WALKING)
		{
			// set the distance covered, in percent of the model width
			covered_dist = MY._WALKDIST + my_dist / (MY.MAX_X-MY.MIN_X);
			anim_dist = anim_walk_dist;
			// calculate the real cycle distance from the model size
			if(covered_dist > anim_dist)
			{
				covered_dist -= anim_dist;
			}


			temp = 100 * covered_dist / anim_dist;
			if(force.X < 0)	// moving backwards?
			{
				temp = 100 - temp;
			}

			ent_cycle("walk",temp);

			if (covered_dist < MY._WALKDIST)
			{
				
				
				
				_play_walksound();	// sound for left foot
				
				
			}
			if ((covered_dist > anim_dist*0.5) && (MY._WALKDIST < anim_dist*0.5))
			{
				_play_walksound();	// sound for left foot
	
			}
			MY._WALKDIST = covered_dist;
			return;
		}

}

*/
//============================

function actor_move2() 
{
	
	force.Y = 0;
    vec_set(temp,my.x);
    temp.z += my.min_z-16; // calculate a position 4000 quants below the player
    // set a trace mode for using the player's hull, and detecting map entities and level surfaces only 
    trace_mode = ignore_me+ignore_sprites+ignore_passable+ignore_push+ignore_models+use_box;
    result = trace(my.x,temp); // subtract vertical distance to ground
    

//	drop_my_shadow();


    if (RESULT > 8 || result==0) // in the air?
    { 
  	  	force.X = 0; // no pushing force
     	force.Y = 0;
     	force.Z = -5; // gravity force
     	friction = 0.01; // air friction
   //  	MY.__FALL = On;
    }
    else // on or near ground
    { 
      force.Z = -0.9*(RESULT-2);//ground elasticity
      friction = 0.7; // ground friction
	 //  MY.__FALL = Off;
	}

    MY._SPEED_X = TIME*force.X + max(1-TIME*friction,0)*MY._SPEED_X; // calculate ahead speed
    MY._SPEED_y = TIME*force.y + max(1-TIME*friction,0)*MY._SPEED_y; // calculate ahead speed
    MY._SPEED_z = TIME*force.Z + max(1-TIME*friction,0)*MY._SPEED_z; // calculate vertical speed
    
    //wait(1);
    
    vec_set(temp,nullvector);
    
    dist.X = TIME * MY._SPEED_X; // distance ahead
    dist.y = TIME * MY._SPEED_y; // distance down
    //dist.Z = TIME * MY._SPEED_z; // distance down
    dist.Z=0;
	temp.Z = TIME * MY._SPEED_z; // distance down
    move_mode = ignore_passable + ignore_push+ignore_sprites;
    //my.enable_scan=off;

    result=ent_MOVE(dist,temp); // move the player
 
 	vec_scale(dist,movement_scale);	// scale distance by movement_scale
 
 	if(result > 0)
	{
		// only use the relative distance traveled (for animation)
		my_dist = vec_length(dist);
	}
	else
	{
		// player is not moving, do not animate
		my_dist = 0;
	//	my._rotate=1;	
	}
 //=========================================
 
 			// walking animation
		if(MY._MOVEMODE == _MODE_WALKING)
		{
			// set the distance covered, in percent of the model width
			covered_dist = MY._WALKDIST + my_dist / (MY.MAX_X-MY.MIN_X);
			anim_dist = anim_walk_dist;
			// calculate the real cycle distance from the model size
			if(covered_dist > anim_dist)
			{
				covered_dist -= anim_dist;
			}


			temp = 100 * covered_dist / anim_dist;
			if(force.X < 0)	// moving backwards?
			{
				temp = 100 - temp;
			}

			ent_cycle("walk",temp);

			if (covered_dist < MY._WALKDIST)
			{
				
				
				
				_play_walksound();	// sound for left foot
				
				
			}
			if ((covered_dist > anim_dist*0.5) && (MY._WALKDIST < anim_dist*0.5))
			{
				_play_walksound();	// sound for left foot
	
			}
			MY._WALKDIST = covered_dist;
			return;
		}

}

//==================================================

function Enemy_AI_wait()
{
	


MY._STATE = _STATE_WAIT;
ToGround();	
wait(1);
my.untouchable = on; // now entities behind can be clicked at

	while(MY._STATE == _STATE_WAIT)
	{
		
		MY._VOICE_TIMER-=TIME;	
if (MY._VOICE_TIMER<0)
	{
	ent_playsound (MY, MY._HUNTSOUND, 500);
	MY._VOICE_TIMER=random(7)*10+30;
	}	

	if ((MY._SIGNAL==_DETECTED) || (Pre_AI_View()==1)
	 || (Pre_AI_Hear()==1))
		{
		snd_stop(MY._SND_HANDLE);
		MY._SND_HANDLE=ent_playsound (ME, MY._ALERTSOUND, 600);
		MY._STATE = _STATE_HUNT;
		
		
		if (MY._MONSTR_TYPE==1) {Killer_AI(); /*Soldier_AI_hunt()*/;return;}
		if (MY._MONSTR_TYPE==2) {Killer_AI(); /*Imp_AI_hunt();*/return;}
		if (MY._MONSTR_TYPE==3) {Killer_AI(); /* Revenant_AI_hunt();*/ return;}
		if (MY._MONSTR_TYPE==4) {Killer_AI(); /* Demoness_AI_hunt();*/ return;}
		if (MY._MONSTR_TYPE==5) {Killer_AI(); /* Cyberdemon_AI_hunt();*/return;}
		if (MY._MONSTR_TYPE==6) {Killer_AI(); /* LostSoul_AI_hunt();*/ return;}
		if (MY._MONSTR_TYPE==10) {Killer_AI(); /* LostSoul_AI_hunt();*/ return;}
		 //  
		}
	if (my._HEALTH <= 0) 
	{ 
	EXCLUSIVE_ENTITY;
	wait(1);
	AI_die(); 
	return; 
	}
	
	

	force.x=0;
	actor_move2();
	wait(10); //     
	}
}


function AI_die() 
{
	
	proc_kill(1);
	my.light = Off;
	if (MY._MONSTR_TYPE==5) 
	{
	snd_stop(MY._SND_HANDLE);
	temp=random(10)+30;
	_gib(temp);
	ent_morph(me,leg_gib);
	ent_playsound (ME, MY._DEADSOUND, 600);
	my.event = NULL; // and don't react anymore
 	my.passable=ON;
	return;
	}
	
	if (MY._HEALTH<-20)
	{
	snd_stop(MY._SND_HANDLE);
	temp=random(6)+4;
	_gib(temp);
	ent_remove(me);
	return;
	}	
	
	
	snd_stop(MY._SND_HANDLE);
	ent_playsound (ME, MY._DEADSOUND, 500);
  my._ANIMDIST = 0; // reset entities' animation time to zero
  while (my._ANIMDIST < 100)
  {
    ent_FRAME("death",my._ANIMDIST); // set the frame from the percentage
    my._ANIMDIST += 5.0 * TIME; // calculate next percentage for death in ~1.25 seconds
    
  	force.Y = 0;
	force.X = 0;
	
	MY._MOVEMODE = _MODE_STILL;
	actor_move2();
	
	
   wait(1);
  }
  
  	my.enable_scan = OFF; // become insensible
	my.enable_shoot = OFF;
 	my.event = NULL; // and don't react anymore
	my.ENABLE_stuck = Off; 	
	my.ENABLE_BLOCK = Off;   
 	my.passable=ON;
 	  
  while(2)
  {
  	force = 0;     // no force from this actor
  	
	MY._MOVEMODE = _MODE_STILL;
	actor_move2();
	if (MY.__FALL == Off) {	break;}
  	wait(1);
	}
	
	
	if (random(1)>0.5)
	{
  my._ANIMDIST = 100; // reset entities' animation time to zero
  while (my._ANIMDIST > 70)
  {
   ent_FRAME("death",my._ANIMDIST); // set the frame from the percentage
   my._ANIMDIST -=  TIME; // calculate next percentage for death in ~1.25 seconds
	MY._MOVEMODE = _MODE_STILL;
	emit(1,my.x,particle_blood); // emit sparks	
   wait(1);
  }
 	emit(10,my.x,particle_blood); // emit sparks	
	snd_stop(MY._SND_HANDLE);
	ent_playsound (ME, MY._DEADSOUND, 200);
 while (my._ANIMDIST < 100)
  {
   ent_FRAME("death",my._ANIMDIST); // set the frame from the percentage
   my._ANIMDIST +=  TIME; // calculate next percentage for death in ~1.25 seconds
	MY._MOVEMODE = _MODE_STILL;
   wait(1);
  }
	emit(10,my.x,particle_blood); // emit sparks		
	}	
	
	if (ZOMBY_TIME==0)	{
		
		return;
		
	};
	wait(ZOMBY_TIME*16);
	ent_remove(me);
	
	
	
  
}


var angle=0;

//==============================================

ACTION simple_box
{
	MY._HITMODE = 0;
	MY._MONSTR_TYPE=-1;
	MY._HEALTH = 20;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;
	
	
//	MY.PUSH=1;
	
	MY._PAINSOUND=0;
	
	My.EVENT=Breakable_AI_event;
	
	ToGround();
	
}


//==================================================

ACTION actor_imp
{
	MY._FORCE = 3;
	MY._FIREMODE = DAMAGE_IMPACT+FIRE_BALL+0.03;	// use default
	MY._HITMODE = 0;
	
//	MY._SHADOW=on;
	
	MY._MONSTR_TYPE=2;
	my._HUNTSOUND= imp_hunt;
	MY._WALKSOUND = 0;
	MY._ALERTSOUND= imp_alert;
	MY._DEADSOUND=imp_dead;
	MY._PAINSOUND=imp_pain;
//	MY._FIREBALL=handle(impfireball);
	
	MY._CLAWSOUND=imp_claw;
	
	MY._MUZZLE_VERT =255;
//	MY._BASE_VERT=160;
//	MY.PUSH=1;
	
	MY._I_ACCURACY = 0;
	
	MY._HEALTH = 50;
	MY._ARMOR=0;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
	
	
	MY._SIGNAL = 0;
	
	MY._STATE = _STATE_WAIT;
	
	
	
	
	MY._WEAPONRANGE=600.2;  
	
	MY._VOICE_TIMER=100;
	
	
	//Shader_bumpmap();
//	my.material=bumpmap; 
	//my.material=lightice;
	//impskin=my.material;
	//effect_load(my.material,mfx);	
	
	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;

	
	
	
 	anim_init();
	drop_shadow();	// attach shadow to robot
	

	
	My.EVENT=Enemy_AI_event;
Enemy_AI_wait();
//	Robot_AI_hunt();
	//enemy_AI();

	
}



ACTION actor_guy
{
//	proc_kill(1);
//wait(5);
	MY._FORCE = 3;
	MY._FIREMODE=DAMAGE_SHOOT+FIRE_PARTICLE+0.05;
	MY._HITMODE = 0;
	
	MY._MONSTR_TYPE=1;
	my._HUNTSOUND= guy_hunt;
	MY._WALKSOUND = guy_walk;
	MY._ALERTSOUND= guy_alert;
	MY._DEADSOUND=guy_dead;
	MY._PAINSOUND=guy_pain;

	
//	MY.PUSH=1;
//	MY._CLAWSOUND=imp_claw;
	
	MY._MUZZLE_VERT =11;
//	MY._BASE_VERT=160;
	
	
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 22;
	MY._ARMOR=0;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
	
	
	MY._SIGNAL = 0;
	
	MY._STATE = _STATE_WAIT;

//	my.material=bumpmap;
	
	
	
	
	MY._WEAPONRANGE=10000.2;  
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=200;
 	my.blue= 255;
 	my.green=200; 
 	
 	
 MY._VOICE_TIMER=100;
 	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;

	
 	anim_init();
	drop_shadow();	// attach shadow to robot



	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
}

ACTION actor_rocketguy
{
	MY._FORCE = 3;
	MY._FIREMODE=DAMAGE_EXPLODE+FIRE_ROCKET + 0.20;
	
	MY._HITMODE = 0;
	my.push=0;
	
	MY._MONSTR_TYPE=1;
	my._HUNTSOUND= guy_hunt;
	MY._WALKSOUND = guy_walk;
	MY._ALERTSOUND= guy_alert;
	MY._DEADSOUND=guy_dead;
	MY._PAINSOUND=guy_pain;
	
	MY._MUZZLE_VERT =11;
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 40;
	MY._ARMOR=20;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
	
//MY.PUSH=1;	
	MY._SIGNAL = 0;
	
	MY._STATE = _STATE_WAIT;
	
	MY._WEAPONRANGE=1500.2;  
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=255;
 	my.blue= 255;
 	my.green=200; 
 	
 	
 MY._VOICE_TIMER=100;
	 	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;

 	anim_init();
	drop_shadow();	// attach shadow to robot
	
	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();

	
}

ACTION actor_women
{
	MY._FORCE = 2;
	MY._FIREMODE=DAMAGE_SHOOT+FIRE_PARTICLE+0.05;
	MY._HITMODE = 0;
	
	MY._MONSTR_TYPE=10;
	my._HUNTSOUND= h_hunt;
	MY._WALKSOUND = h_walk;
	MY._ALERTSOUND= h_alert;
	MY._DEADSOUND=h_dead;
	MY._PAINSOUND=h_pain;

//MY.PUSH=1;
	
//	MY._CLAWSOUND=imp_claw;
	
	MY._MUZZLE_VERT =80;
//	MY._BASE_VERT=160;
	
	
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 140;
	MY._ARMOR=110;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = ON;
	
	
	MY._SIGNAL = 0;
	
	MY._STATE = _STATE_WAIT;
	
	MY._WEAPONRANGE=10000.2;  
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=200;
 	my.blue= 255;
 	my.green=200; 
 	 	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;

	
 	anim_init();
	drop_shadow();	// attach shadow to robot

	//my.shadow = on; 

	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
	
}
ACTION actor_revenant
{
	MY._FORCE = 2;
	MY._FIREMODE=DAMAGE_IMPACT+BULLET_SMOKETRAIL +FIRE_BALL + 0.10;
	MY._HITMODE = 0;
//	my._BULLETSPEED=100.5; 
	MY._MONSTR_TYPE=3;
	my._HUNTSOUND= rev_hunt;
	MY._WALKSOUND = rev_walk;
	MY._ALERTSOUND= rev_alert;
	MY._DEADSOUND=rev_dead;
	MY._PAINSOUND=rev_pain;

	//MY._FIREBALL=skufireball;

	MY._CLAWSOUND=rev_punch;
	
	MY._MUZZLE_VERT =11;
	
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 200;
	MY._ARMOR=0;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = ON;
//MY.PUSH=1;	
	
	MY._SIGNAL = 0;
	MY._STATE = _STATE_WAIT;
	MY._WEAPONRANGE=500.2;  
	
	
//	my.material=bumpmap;
	
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=200;
 	my.blue= 255;
 	my.green=200; 
 MY._VOICE_TIMER=100;
	 	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;

 	anim_init();
	drop_shadow();	// attach shadow to robot
	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
	
}

ACTION actor_demoness
{
	MY._FORCE = 3;
	MY._FIREMODE=DAMAGE_IMPACT+BULLET_SMOKETRAIL +FIRE_BALL + 0.08;
	MY._HITMODE = 0;
//	my._BULLETSPEED=100.5; 
	MY._MONSTR_TYPE=4;
	my._HUNTSOUND= dem_hunt;
	MY._WALKSOUND = dem_walk;
	MY._ALERTSOUND= dem_alert;
	MY._DEADSOUND=dem_dead;
	MY._PAINSOUND=dem_pain;
	
	MY._CLAWSOUND=imp_claw;
//	MY._FIREBALL=demfireball;

	
	MY._MUZZLE_VERT =18;
	
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 350;
	MY._ARMOR=0;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
 
	
	MY._SIGNAL = 0;
	MY._STATE = _STATE_WAIT;
	MY._WEAPONRANGE=400.2;  
	
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=125;
 	my.blue= 125;
 	my.green=240; 
 MY._VOICE_TIMER=100;
	 	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;
//MY.PUSH=1;
 	anim_init();
	drop_shadow();	// attach shadow to robot
	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
	
}

ACTION actor_cyberdemon
{
	my.fat = ON;
	my.narrow = Off;
	MY._FORCE = 2.5;
	MY._FIREMODE=DAMAGE_EXPLODE+FIRE_ROCKET + 0.20;
	MY._HITMODE = 0;
//	my._BULLETSPEED=100.5; 
	MY._MONSTR_TYPE=5;
	my._HUNTSOUND= cyb_hunt;
	MY._WALKSOUND = cyb_walk;
	MY._ALERTSOUND= cyb_alert;
	MY._DEADSOUND=cyb_dead;
	MY._PAINSOUND=cyb_pain;

	MY._MUZZLE_VERT =218;
	
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 2000;
	MY._ARMOR=0;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
 
//	my.material=bumpmap; 
	
	MY._SIGNAL = 0;
	MY._STATE = _STATE_WAIT;
	MY._WEAPONRANGE=2000.2;  
	
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=225;
 	my.blue= 125;
 	my.green=140; 
 
 	MY._VOICE_TIMER=100;
	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;
//MY.PUSH=1;
 	anim_init();
//	drop_shadow();	// attach shadow to robot
	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
	
}


ACTION actor_mancubus
{
	my.narrow = Off;
	my.fat = ON;
	
	MY._FORCE = 1;
	//MY._FIREMODE=DAMAGE_EXPLODE+FIRE_ROCKET + 0.20;
	MY._FIREMODE = DAMAGE_IMPACT+FIRE_BALL+0.03;	// use default

	MY._HITMODE = 0;
//	my._BULLETSPEED=100.5; 
	MY._MONSTR_TYPE=6;
	my._HUNTSOUND= cyb_hunt;
	MY._WALKSOUND = cyb_walk;
	MY._ALERTSOUND= cyb_alert;
	MY._DEADSOUND=cyb_dead;
	MY._PAINSOUND=cyb_pain;

	MY._MUZZLE_VERT =657;
	MY._MUZZLE_VERT1 =327;
	
	MY._I_ACCURACY = 5;
	
	MY._HEALTH = 1000;
	MY._ARMOR=0;	
	MY._I_COWARDICE = -1;
	MY._ALERTNESS=2500;
	MY._I_ALERTNESS = MY._ALERTNESS;
	MY.ENABLE_SCAN = On;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_DETECT = On;
 
//	my.material=bumpmap; 
	
	MY._SIGNAL = 0;
	MY._STATE = _STATE_WAIT;
	MY._WEAPONRANGE=500.2;  
	
	my.lightrange = 0; // don't illuminate the environment
 	my.light = Off; // illuminate myself
 	my.red=225;
 	my.blue= 100;
 	my.green=100; 
 
 	MY._VOICE_TIMER=100;
	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;

 	anim_init();
//	drop_shadow();	// attach shadow to robot
	My.EVENT=Enemy_AI_event;
	Enemy_AI_wait();
	
}

// Desc: Debugging utility, watches a ROBOT and sets flags using its values
//
//]- Mod Date: 7/11/00 DCP
//]-				removed tst_values

////////////////////////////////////////////////////////////////////////

// Desc: take damage and detect player
//
// Mod: 02/06/01 DCP
//		Added wait before shoot command to remove 'Dangerous instruction error'
//	   Replaced SHOOT with trace()
//
// Mod: 05/05/01 DCP
//		Modified damage from ranged explosion (replaced ABS with MAX)
// Mod Date: 05/16/02 DCP
//		Use temp in blast damage calculation to remove problem when multiple entities are hit
// Mod Date: 06/11/02 DCP
//		Added wait before trace command


// PLAYER ACTIONS
///////////////////////////////////////////////////////////////////////

//		player_walk_fight - player walk and fight action (basic FPS)

// temp flags only used in player_walk_fight action.
DEFINE	__NO_FALLDAMAGE, FLAG1;
DEFINE	__NO_JUMP,FLAG4;
DEFINE	__NO_BOB,FLAG5;
DEFINE	__NO_STRAFE,FLAG6;
DEFINE	__NO_TRIGGER,FLAG7;
DEFINE	__NO_DUCK,FLAG8;

/////////////////////////////////////////////////////////////////////////
// Desc: player action. Walk and fight (take damage, use gun)
//
//	Used for basic FPS type games.  Set the following skills and flags in
//WED to define the player (note: all skills default to 0, all flags
//default to OFF)
//
//	Flags
//		Flag1 - ON = *NO damage from falls*
//				 OFF = Take damage from falls
//		Flag2 - ON = move as a car (i.e. no turning unless moving),
//				 OFF = move normally
//		Flag3 - ON = adapt tilt and roll angle to slops
//				 OFF = stay upright while walking up and down slops (normal)
//		Flag4 - ON = *NO JUMPING*
//				 OFF = Allow jumping
//		Flag5 - ON = *NO first person view "head-bob" while moving*
//				 OFF = Enable first person view "head-bob"
//		Flag6 - ON = *Disable strafe*
//				 OFF = Allow strafing
//		Flag7 - ON = *Disable trigger* (open doors automatically)
//				 OFF = Trigger on
//		Flag8 - ON = *NO DUCKING*
//				 OFF = Enable ducking
//	Skills
//	_WALKSWIM_DIST, SKILL1;   	// Walk Distance . Swim Distance
//	_RUNCRAWL_DIST, SKILL2;   	// Run Distance . Crawl Distance
//	_STANDJUMP_TIME, SKILL3;  	// Stand Time . Jump Time
//	_ATTACKDUCK_TIME, SKILL4; 	// Attack Time . Duck Time
//	_RUNTHRESHOLD, SKILL14;		// Run Threshold
//	_FORCE, SKILL5;				// Force
//	_BANKING, SKILL6;				// Hitmode (actor only)
//	_MOVEMODE, SKILL7;			// Starting movemode
//	_HEALTH, SKILL9;	 			// Heath
//	_ARMOR, SKILL10;				// Armor
//
//]- Mod: 6/18/01 DCP
//]-		Created
//]-
//]- Mod: 8/21/01 DCP
//]-		Updated to use new WED skills
//
// Mod: 04/30/02 DCP
//		now calls player_move2 (improved movement and animation)
//
// uses _WALKSWIM_DIST,_RUNCRAWL_DIST,_STANDJUMP_TIME,_ATTACKDUCK_TIME
//	uses _FORCE,_BANKING,_MOVEMODE,_FIREMODE,_HEALTH,_ARMOR,_RUNTHRESHOLD
// uses __NO_FALLDAMAGE, __WHEELS, __SLOPES, __NO_JUMP, __NO_BOB, __NO_STRAFE
// uses __NO_TRIGGER, __NO_DUCK
ACTION player_walk_fight
{
// player
	// Flags-------------------------------
	IF(MY.__NO_FALLDAMAGE == ON) { MY.__FALL = OFF; }
	ELSE { MY.__FALL = ON; }
	//MY.__WHEELS = MY.FLAG2; // note: redundant
	//MY.__SLOPES = MY.FLAG3; // note: redundant
	IF(MY.__NO_JUMP == ON) { MY.__JUMP = OFF; }
	ELSE { MY.__JUMP = ON; }
	IF(MY.__NO_BOB == ON) { MY.__BOB = OFF; }
	ELSE { MY.__BOB = ON; }
	IF(MY.__NO_STRAFE == ON) { MY.__STRAFE = OFF; }
	ELSE { MY.__STRAFE = ON; }
	IF(MY.__NO_TRIGGER == ON) { MY.__TRIGGER = OFF; }
	ELSE { MY.__TRIGGER = ON; }
	IF(MY.__NO_DUCK == ON) { MY.__DUCK = OFF; }
	ELSE { MY.__DUCK = ON; }

	// Skill1------------------------------
	if (MY._HEALTH <= 0) {			// if user didn't enter a value
		MY._HEALTH = 100;				// use default
	}

	if (MY._ARMOR < 0) {				// if bad value specified somehow
		MY._ARMOR = 0;					// default to zero
	}

	if( MY._FORCE <= 0)
	{
		MY._FORCE = 0.75;				// use default
	}


	player_anim_pack();           // use SKILLs 1-4 to set up animation

 	// Other-------------------------------
	MY.NARROW = ON;	// use narrow hull!
	MY.FAT = OFF;
 	MY.TRIGGER_RANGE = 5;
	if( MY._MOVEMODE <= 0)
	{
		MY._MOVEMODE = _MODE_WALKING;
	}

	if( MY._BANKING == 0)
	{
		MY._BANKING = -0.1;
	}
	MY._WALKSOUND = plr_walk;
	MY._ALERTSOUND= plr_walk;
	MY._DEADSOUND=plr_dead;
	MY._PAINSOUND=plr_pain;
	MY._MONSTR_TYPE=100;
// NOTE: comment player_move2() and uncomment player_move() to return
//to older method of player movement/animation

	my.enable_entity=on;	

 	MY._SPEED_X=0;
	MY._SPEED_y=0;
	MY._SPEED_z=0;
//MY.PUSH=-1;
	MY.SKILL100=0;
	move_player();
	player_fight();   // basic player fight loop
//	drop_shadow();		// add a drop shadow (if the player has no 'real' shadow)
	//show_panels();    // show heath/armor/ammo panel
}



// Desc - An entity action that will make a generic AI player with skill
//			 settings that can be set as above in WED
////////////////////////////////////////////////////////////
// These skills can be set in WED for the intended effect //
////////////////////////////////////////////////////////////
//	_WALKSWIM_DIST, SKILL1;   	// Walk Distance . Swim Distance
//	_RUNCRAWL_DIST, SKILL2;   	// Run Distance . Crawl Distance
//	_STANDJUMP_TIME, SKILL3;  	// Stand Time . Jump Time
//	_ATTACKDUCK_TIME, SKILL4; 	// Attack Time . Duck Time
//	_RUNTHRESHOLD, SKILL14;		// Run Threshold
//	_FORCE, SKILL5;				// Force
//	_HITMODE, SKILL6;				// Hitmode (actor only)
//	_MOVEMODE, SKILL7;			// Starting movemode
//	_FIREMODE, SKILL8; 			// Firemode
//	_HEALTH, SKILL9;	 			// Heath
//	_ARMOR, SKILL10;				// Armor
//	_ALERTNESS, SKILL11; 	   // Alertness
//	_ACCURACY, SKILL12; 			// Accuracy
//	_COWARDICE, SKILL13;	 		// Cowardice
//	_MUZZLEATTACH, SKILL15;		// Muzzle vertex . Attach vertex
////////////////////////////////////////////////////////////
// 07/16/01 - MWS - Created
// 07/24/01 - MWS - Overhauled (16 WED skills now!)
//
// Mod: 8/21/01 DCP
//		Updated to use new WED skills
//
// uses _WALKSWIM_DIST,_RUNCRAWL_DIST,_STANDJUMP_TIME,_ATTACKDUCK_TIME
// uses _FORCE,_HITMODE,_MOVEMODE,_FIREMODE,_HEALTH,_ARMOR,_ALERTNESS
// uses _ACCURACY,_COWARDICE,_RUNTHRESHOLD,_MUZZLEATTACH


// ==========================================================================


// Desc: attach a bounding cube to the model (for testing purposes)
//		The cube will be the color of the current state
// TODO: need to line it up better with 'you' entity

// Desc show a visible line from my.x to you.x


// desc used to handle a simple "type one" actor AI
/* help This actor AI does the following:

	_WALKSWIM_DIST, SKILL1;   	// Walk Distance . Swim Distance
	_RUNCRAWL_DIST, SKILL2;   	// Run Distance . Crawl Distance
	_STANDJUMP_TIME, SKILL3;  	// Stand Time . Jump Time
	_ATTACKDUCK_TIME, SKILL4; 	// Attack Time . Duck Time
	_RUNTHRESHOLD, SKILL14;		// Run Threshold
	_FORCE, SKILL5;				// Force (1.5)
	_HITMODE, SKILL6;				// Hitmode (actor only)
	_FIREMODE, SKILL8; 			// Firemode . Damage (DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH+0.10)
	_HEALTH, SKILL9;	 			// Heath (75)
	_ARMOR, SKILL10;				// Armor (0)
	_ALERTNESS, SKILL11; 	   // Alertness.AlertCone (1000.180)
	_ACCURACY, SKILL12; 			// Accuracy  (5)
	_COWARDICE, SKILL13;	 		// Cowardice (30)
	_MUZZLEATTACH, SKILL15;		// Muzzle vertex . Attach vertex
	_WEAPONRANGE, SKILL16		// range of the weapon (1500) . time to reload (.32)

 NOTES:
		Use the flag "-d showaiboxes" to display AI bounding boxes around
	this entity.
*/
//
// uses _WALKSWIM_DIST,_RUNCRAWL_DIST,_STANDJUMP_TIME,_ATTACKDUCK_TIME
// uses _FORCE,_HITMODE,_MOVEMODE,_FIREMODE,_HEALTH,_ARMOR,_ALERTNESS
// uses _ACCURACY,_COWARDICE,_RUNTHRESHOLD,_MUZZLEATTACH,_WEAPONRANGE


// Desc: type one actor death


// Desc: can we see the player from our position?
//
// uses: temp
//
// returns: 0 - no
//				1 - yes
//				negitive value on error

var	pap_pack1; // used to pack SKILL1
var	pap_pack2; // used to pack SKILL2

function player_anim_pack()
{
	pap_pack1 = 0;	//reset
	pap_pack2 = 0;	//reset

	// Stand Time
	temp = INT(MY._STANDJUMP_TIME);				  		// quarter seconds
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_stand_ticks = 16
	}
 	pap_pack1 += temp >> 10;		  			// fractional 10 bits (2^10 = 1024)
	//pap_pack1 += temp / 1024;		  	  	// fractional 10 bits (2^10 = 1024)


	// Jump Time
	temp = INT(FRC(MY._STANDJUMP_TIME) * 100); 		// quarter seconds
	if (temp == 0) {								// no value entered in WED
		temp = 2;									// default anim_jump_ticks = 6
	}
	pap_pack1 += temp << 6;			 			// middle 6 bits (2^6 = 64)
	//pap_pack1 += temp * 64;				 	// middle 6 bits (2^6 = 64)


	// Attack Time
	temp = INT(MY._ATTACKDUCK_TIME);   					// quarter seconds
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_attack_ticks = 16
	}
	pap_pack1 += temp << 12;			  		// upper 9 bits, shift 12 (2^12 = 4096)
	//pap_pack1 += temp * 4096;				// upper 9 bits, shift 12 (2^12 = 4096)


	// Duck Time
	temp = INT(FRC(MY._ATTACKDUCK_TIME) * 100);	 	// quarter seconds * 4 = game ticks
	if (temp == 0) {								// no value entered in WED
		temp = 2;									// default anim_duck_ticks = 8
	}
	pap_pack1 += temp; 							// lowest 6 bits


	// Walk Distance
	temp = INT(MY._WALKSWIM_DIST); 		// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_walk_dist = 1
	}
	pap_pack2 += temp << 10;					// next upper 5 bits (2^10 = 1024)
	//pap_pack2 += temp * 1024;			  	// next upper 5 bits (2^10 = 1024)


	// Swim Distance
	temp = INT(FRC(MY._WALKSWIM_DIST) * 100); 		// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 4;									// default anim_swim_dist = 1
	}
	pap_pack2 += temp;	  						// bottom 5 bits


	// Skill6------------------------------
	// Run Distance
	temp = INT(MY._RUNCRAWL_DIST);   					// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 6;									// default anim_run_dist = 1.5
	}
	pap_pack2 += temp << 15;	  	 			// upper 6 bits (2^15 = 2^10 * 2^5 = 1024 * 32)
	//pap_pack2 += temp * 1024 * 32;	  		// upper 6 bits (2^15 = 2^10 * 2^5 = 1024 * 32)


	// Crawl Distance
	temp = INT(FRC(MY._RUNCRAWL_DIST) * 100);	  	// quarter widths
	if (temp == 0) {								// no value entered in WED
		temp = 3;									// default anim_crawl_dist = 0.8
	}
	pap_pack2 += temp << 5;			  			// upper 5 bits (2^5 = 32)
	//pap_pack2 += temp * 32;					// upper 5 bits (2^5 = 32)


	// Skill7------------------------------
	// Walk Or Run
	temp = INT(MY._RUNTHRESHOLD);   		 			// whole quants
	if (temp == 0) {								// no value entered in WED
		temp = 12;									// default walk_or_run = 12
	}
	pap_pack2 += temp >> 10;			  		// fractional 10 bits (2^10 = 1024)
	//pap_pack2 += temp / 1024;		  		// fractional 10 bits (2^10 = 1024)


	MY._ADVANIM_TICK = -1 * pap_pack1;		// activate advanced animation
	MY._ADVANIM_DIST  = -1 * pap_pack2;		// activate advanced animation
}



// Desc: what to do when the player is dead.
//
// Note: overwrite this with your own behavior on death
//		Three second delay added for effect and to fix "eye_height" reset problem
function	player_dead()
{
	waitt(48);		// wait for 3 seconds
 	menu_main();	// bring up menu.
}

// Desc: enable the player to take damage and die
//
// Mod Date: 05/01/02
//		Replaced call to state_die with local handling of player death
function player_fight()
{
	if(MY._HEALTH == 0) { MY._HEALTH = 100; }

	MY.ENABLE_SCAN = ON;
	MY.ENABLE_SHOOT = ON;
//	MY.EVENT = fight_event;
	MY.EVENT = Enemy_AI_event;

	while(MY._HEALTH > 0)
	{
		if(MY._SIGNAL == _DETECTED) 	// Hit received?
		{
			MY._SIGNAL = 0;	// reset the _signal skill
			player_shake();
		}
		wait(1);
	}

	// Dead
	MY._HEALTH = 0;
	weapon_remove();	// prevent dead player firing
	my._MOVEMODE = _MODE_STILL; // stop the player from moving


	//if(person_3rd == 0)
	//{	// 1st person die action
		MY._MOVEMODE = 0;		// don't move anymore
		MY.EVENT = NULL;		// prevent health counting down
		player_tip();
		waitt(8);
	/*}
	else
	{
		//state_die();
		wait(1);	// let the animation state start the death cycle
		while(my._ANIMDIST != -99)	// not done with death cycle
		{
			wait(1);
		}
	}*/
	my._MOVEMODE = _MODE_NONE;	// stop movment
//	player_dead();// handle being dead
}

DEFINE	_TRIGGER_X, SKILL1;   // Walk Distance . Swim Distance
DEFINE	_TRIGGER_Y, SKILL2;   // Run Distance . Crawl Distance
DEFINE	_TRIGGER_Z, SKILL3;  // Stand Time . Jump Time
DEFINE	_TRIGGER_RADIUS, SKILL4; // Attack Time . Duck Time
DEFINE	_TRIGERR_TYPE, SKILL5;	
DEFINE	_TRIGERR_COUNT, SKILL6;	
DEFINE	_TRIGERR_EVIL, SKILL7;	


action RespawnMonster
{
	
var m_x=0;
var m_y=0;	

var f_corner;
var f_cube;


ToGround();
my.invisible=on;
my.oriented = on;
my.facing = off;
my.decal = off;
my.transparent=off;
my.flare=off;

	MY.ENABLE_SCAN = Off;
	MY.ENABLE_SHOOT = Off;
	MY.ENABLE_DETECT = Off;
	my.passable = on;

while (1)	
{
	
if (vec_dist(player.x,my.x)<my._TRIGGER_RADIUS) {break;};	
	
wait(40);	
}
	

f_corner=MY._TRIGERR_COUNT*50*50; //  
f_cube=sqrt(f_corner); //  
f_corner=f_cube/2; // 


while (my._TRIGERR_COUNT>0)
{


temp.x=my._TRIGGER_X-f_corner;
temp.y=my._TRIGGER_y-f_corner;
temp.z=my._TRIGGER_Z;

temp.y+=m_y;
temp.x+=m_x;


if (my._TRIGERR_TYPE==1) { you=ent_create("badguy.mdl",temp,actor_guy);};
if (my._TRIGERR_TYPE==2) { you=ent_create("imp5.mdl",temp,actor_imp);};
if (my._TRIGERR_TYPE==3) { you=ent_create("revenant.mdl",temp,actor_revenant);};
if (my._TRIGERR_TYPE==4) { you=ent_create("demoness.mdl",temp,actor_demoness);};
if (my._TRIGERR_TYPE==5) { you=ent_create("cyberdemon.mdl",temp,actor_cyberdemon);};
if (my._TRIGERR_TYPE==10) { you=ent_create("hostage.mdl",temp,actor_women);};

// get the direction from the entity MY to the entity YOU
vec_set(temp,my.x); 
vec_sub(temp,you.x);
vec_to_angle(you.pan,temp); // now you looks at my
you.tilt=0;
you.roll=0;


if (my.SKILL7==1)
{
	you._SIGNAL=_DETECTED;
}


my._TRIGERR_COUNT-=1;
m_x+=50;

if (m_x>=f_cube) { m_y+=50; m_x=0; };

wait(1);
}

wait(1);
remove(me);


	
}


// Desc: explode into x number of random models
//
// Mod Date: 8/22/00 DCP
//				Uses function parameter (numberOfParts) to determine
//			how many 'gib' parts to create
function	_gib(numberOfParts)
{
//	temp = 0;
	while(numberOfParts>0)
	{
		
		create(<gib1.mdl>, MY.POS, _gib_action);
		you.ENABLE_SCAN = Off;
		you.scale_x=random(2)+1;
		you.scale_y=random(2)+1;
		you.scale_z=random(2)+1;
		you._SPEED_X =  (RANDOM(10) - 5);    // -125 -> +125
		you._SPEED_Y =  (RANDOM(10) - 5);    // -125 -> +125
		you._SPEED_Z =  (RANDOM(15) + 5);          // 15 -> 50
		you.ROLL = RANDOM(180);	// start with a random orientation
		you.PAN = RANDOM(180);
		//YOU.PUSH=-1;
	// Animate gib-bit
		you.SKILL9 = 600;

		
		
		
		you.passable=on;
		numberOfParts-=1;
	}
	ent_playsound (you, gib_sound, 700);
}




// Desc: Init and animate a gib-bit
//
// Mod Date: 6/29/00 Doug Poston
//				Added rotation and alpha-fading
// Mod Date: 8/31/00 DCP
//				Scale absdist vector by movement_scale
//				Scale the gibbits down by the actor_scale

function _gib_action()
{

	while(MY.SKILL9 > -75)
	{
		abspeed[0] = MY._SPEED_X*time;
		abspeed[1] = MY._SPEED_Y*time;
		abspeed[2] = MY._SPEED_Z* TIME;
		move_mode = IGNORE_YOU + IGNORE_PASSABLE +IGNORE_PASSENTS+IGNORE_MODELS+IGNORE_SPRITES;
		ent_move(nullvector,abspeed);
		MY._SPEED_Z -= 0.5;
		MY.SKILL9 -= 1;
		if (in_solid) {MY.SKILL9 =-100;};
		wait(1);
	}
		// Fade out
	MY.transparent = ON;
	MY.alpha = 100;
	while(MY.alpha >0)
	{
   	MY.alpha -= time;
   	wait(2);
	}
	ent_remove(me);

   	
	//}
//	remove(me);


}

//]-- NOTE: coming soon! include <war2.wdl>;


    
function _hincrease () // executed when the player runs into the health    
{    
      YOU = PLAYER;    
      YOUR._HEALTH += 50; // player's health is increased by 50    
      REMOVE ME; // removes the health model    
}    
function add_health () // will run when the health model is created    
{    
      MY.ENABLE_IMPACT = ON; // sensitive to impact    
      MY.EVENT = _hincrease;    
}    
    

