// Template file v5.202 (02/20/02)
////////////////////////////////////////////////////////////////////////
// File: weapons.wdl
//		WDL prefabs for weapon entities & effects
////////////////////////////////////////////////////////////////////////
//
//]- Mod Date: 8/31/00 DCP
//]-		Scaled entities that us _flashup and _blowup by actor_scale
//]-		Scaled bullet_shot and rocket_launch entities by actor_scale
//]-		Scaled bullet_shot and rocket_launch movement by movement_scale
//]-
//]- Mod Date: 10/3/00 DCP
//]-		Added 'wait' to ammo_pickup action if message is displayed,
//]-	  allows show_message to finish displaying
//]-
//]- Mod Date: 10/17/00 DCP
//]-		Replaced commands with "javascript" style commands
//]-		Add bullet holes
//]- Mod Date: 10/31/00 DCP
//]-				Changed to 4.30 format
//]-
//]-	Mod Date: 11/2/00 DCP
//]-		Added 'bullet_hole': creates a bullet_hole effect in map walls if
//]-	HIT_HOLE is set in weapon's _FIREMODE
//]-
//]- Mod Date: 11/17/00 DCP
//]-		Added DEFINE 'kMaxWeapons' to be equal to the maximum number of weapons
//]-	the player can have.
//]-		Added functions: 'gun_select_cycle_up' & 'gun_select_cycle_up' used
//]- to select the next or prev weapon in the player's list
//]- These new functions are called on 'E' and 'Q'
//]-
//]- Mod Date: 11/17/00 DCP
//]-		Added inverted bullet map (white)
//]-		Added 'laser_fire'  & 'FIRE_LASER' flag
//]-		Added 'GUNFX_BRASS' flag
//]-
//]- Mod Date: 12/11/00 DCP
//]-		Added weaponTmpSyn and code to gun_shot to store/restore YOU value
//]- when using a laser (so bullethole and other effects will continue to work).
//]-		To test new effects try the following FIREMODE with your weapon:
//]-			MY._FIREMODE = DAMAGE_SHOOT + HIT_FLASH + HIT_HOLE
//]-								+ HIT_SMOKE + HIT_SPARKS
//]-								+ FIRE_LASER + GUNFX_BRASS + 0.50;
//]-
//]- Mod Date: 01/24/01 JCL
//]-		Bullhole bitmaps fixed
//]-
//]- Mod Date: 02/06/01 DCP
//]-		In '_fireball_event':
//]-			Added wait before shoot command to remove 'Dangerous instruction error'
//]-
//]- Mod Date: 03/07/01 DCP
//]-		Added cross-hair panel and functions
//]-			- pan_cross_show(): position the cross-hair panel at the center
//]-			                   of the screen and make it visible.
//]-			- pan_cross_hide(): hide the cross-hair panel
//]-
//]-		Adjust the cross-hair offset using the following var	cross_pos[2]
//]-
//]- Mod Date: 04/08/01 DCP
//]-	 	Added functions/actions to automatically give the player a weapon
//]-	    	- gun_givePlayer(): init a gun, give it to the player, and select it
//]-	    	- function startgun1: demo on how to use the function gun_givePlayer
//]-									to give player the type 1 gun.
//]-
//]- Mod Date: 04/11/01 DCP
//]-		Changed STRING 'got_gun4_str' to "Got a laser gun!"
//]-		Added STRINGs 'got_ammo5_str', 'got_ammo6_str', 'got_ammo7_str'
//]-		Cleaned Code (added comments and grouped like values/functions)
//]-		Moved ON_KEYs to bottom
//]-		gun_select: Added weapon_number == 7 check
//]-		_ammo_limit: Added ammo5, ammo6, & ammo7
//]-		gun_pickup: Turned into function
//]-						Added ammo5, ammo6, & ammo7
//]-		ammo_pickup: Added ammo5, ammo6, & ammo7
//]-		ammopac: Added ammo5, ammo6, & ammo7
//]-		weapon_init: Added ammo5, ammo6, & ammo7
//]-		gun_fire: Added ammo5, ammo6, & ammo7
//]-
//]- Mod Date: 04/11/01 DCP
//]-		Added var 'gun_source'
//]-
//]- Mod:  04/13/01 DCP
//]-			gun_shot: Modify trace to calculate and use 'gun_source' instead of 'gun_muzzle'
//]-
//]- Mod:  04/17/01 DCP
//]-			Added Skills '_GUN_SOURCE_X', '_GUN_SOURCE_Y', and '_GUN_SOURCE_Z' to define
//]-		the source of a gun shot. If '_GUN_SOURCE_X == 0' then the default (gun_muzzle)
//]-		is used.
//]-			gun: added code to set the weapon source offset (if one is not already defined)
//]-			startgun1: Added _GUN_SOURCE_X/Y/Z values
//]-			gun_fire: Make player passable before calling 'gun_shot' (and nonpassable afterwords)
//]-			gun_shot: Use  MY._GUN_SOURCE_X/Y/Z to calculate 'gun_source' while in 1st person
//]-						 Changed to function.
//]-
//]- Mod:  04/18/01 DCP
//]-			gun_shot: Moved gun_source calculate outside, if gun_source[3] == 9, then use the
//]-		gun_source for tracing, else use gun_muzzle (backwards compatable)
//]-			gun_fire: Calculate 'gun_source' here now. Set 'gun_source[3] = 9' so gun_shot
//]-					knows to use the 'gun_source' vector for traces.
//]-	 					 Modified 3rd person 'gun_source', 'gun_muzzle', & 'gun_target' calculation
//]-					(no longer depends on cammera location)
//]-			rocket_launch:	Use 'vec_to_angle' and shot_speed to determine rocket orientation
//]-			laser_fire:	Use 'vec_to_angle' and shot_speed to determine beam orientation
//]-
//]- Mod:  04/19/01 DCP
//]-			_gun_fire_no_ammo: created (helper function for 'gun_fire')
//]-			gun_fire: Replaced goto no_ammo with branch _gun_fire_no_ammo
//]-
//]- Mod: 04/20/01 DCP
//]-			_gun_shot_damage_shoot: created (helper function for 'gun_shot')
//]-			gun_shot: Replace "damage shot" section of code with call to '_gun_shot_damage_shoot'
//]-						 Implemented HIT_SCATTER. If HIT_SCATTER flag is set in 'fire_mode' fire
//]-				'scatter_number' shots each randomly offset by the SCATTER_RAND amount.
//]-
//]- Mod: 04/25/01 DCP
//]-			Changed STRING got_gun5_str to "Got a shotgun!"
//]-			Added Action shotgun (type 5 weapon using HIT_SCATTER & HIT_HOLE)
//]-
//]- Mod: 05/04/01 DCP
//]-		gun_select_cycle_up: Fix endless loop when no weapon exists
//]-		gun_select_cycle_down: Fix endless loop when player has max weapon and no other
//]-		(Note: this would be cleaner with a do..while loop)
//]-
//]- Mod: 05/16/01 DCP
//]-		Remove all 'BRANCH' commands (replace with <foo>(); return;)
//]-
//]- Mod:  06/08/01 DCP
//]-		rocket_launch() & bullet_shot(): Replaced move() with ent_move()
//]-
//]- Mod:	06/21/01 DCP
//]-		Replaced SYNONYMs with pointers
//]-
//]- Mod:  06/25/01 DCP
//]-		Added function pan_cross_toggle(). Toggles cross-hair panel
//]-		Added ON_K to call pan_cross_toggle
//]-		Added fps weapons and ammo pack actions
//]-
//]- Mod Date: 07/14/01
//]-		bullet_hole(): Use new handles to turned it into an FIFO array
//]-
//]- Mod: 07/25/01
//]-		added "gun_animate()" function to animate gun model.
//]-		gun_fire(): Added check for gun animation (calls "gun_animate()").
//]-			- Gun must have animation frames labeled "shot1", "shot2", etc.
//]-			- gun action must set "GUNFX_ANIMATE" in "_FIREMODE"
//]-
//]-			ex) MY._FIREMODE = DAMAGE_SHOOT + GUNFX_ANIMATE + 0.25;
//]-
//]-		added action "weap_mg_animated" to use mgun.mdl
//]-
//]- Mod: 07/26/01 DCP
//]-		gun: broke out 'gun_restore' function
//]- 	gun_restore(): Created. Called from 'gun' action.
//]-			Restore a gun already owned by the player (from a previous level)
//]-
//]- Mod: 07/27/01 DCP
//]-		bullet_hole_remove_all(): Created. Remove all bullet holes
//]- 		Call this before changing levels to avoid a potential error when
//]-			trying to remove holes on the previous level.
//]-
//]- Mod: 08/01/01 DCP
//]-		laser_fire(): Made laser brighter
//]-
//]- Mod Date: 12/18/01
//]-		Added WED 'uses' comments to all WED editable fields
//]-		Changed weapon_carry from ACTION to function
//
// Mod: 02/13/02 DCP
// 		ACTION gun: Removed default _AMMOTYPE (if _AMMOTYPE = 0, gun has unlimited ammo)
//			gun_restore(): Added 'gun_loaded = 1' to reload repeating guns.
//
////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////

// change these sounds and graphics for your weapon
IFNDEF WEAPON_DEFS;
 SOUND gun_click,<empty.wav>;
 
 
 
 
 SOUND gun_deagle_s,<sounds\weapon\pistol_s.wav>;
 SOUND gun_deagle_r,<sounds\weapon\pistol_r.wav>;
 
 SOUND gun_shotg_s,<sounds\weapon\shotgun_s.wav>;
 SOUND gun_shotg_r,<sounds\weapon\shotgun_r.wav>;
  
 SOUND gun_ak47_s,<sounds\weapon\machine_s.wav>;
 SOUND gun_ak47_r,<sounds\weapon\machine_r.wav>;
 
 
 SOUND gun_rail_s,<sounds\weapon\rail_s.wav>;
 SOUND gun_rail_r,<sounds\weapon\rail_r.wav>;

 
 SOUND rocket_expl,<sounds\weapon\explode2.wav>;
 sound rocket_launc,<sounds\weapon\rlaunc.wav>;
 
 SOUND explo_wham,<explode1.wav>;
 DEFINE hit_wham,explo_wham;
 SOUND gun_fetch,<beamer.wav>;
 DEFINE ammo_fetch,gun_fetch;
 DEFINE health_fetch,gun_fetch;

 DEFINE muzzle_flash,<muzzleflash.pcx>;
 DEFINE small_flash,<particle.pcx>;
 
 DEFINE BULLET_EXPLO,<flash+4.pcx>;
 DEFINE EXPLO_FRAMES,4;//This is a delphi dllThis is a delphi dll
 DEFINE WEAPON_AMPL,0.2;	// swaying
ENDIF;

IFNDEF WEAPON_DEFS2;
 DEFINE bullethole_map <bulhole.tga>;    // bullet hole bitmap ***
 DEFINE ibullethole_map <ibulhole.tga>;    // inverted bullet hole bitmap (white) ***
ENDIF;

function rocket_launch();	// function prototype
string	strRocket_Model = <models\weapon\missile.mdl>;	// rocket

string	strExplode_Sprite = <gexplode+9.pcx>;	// used in explosions

string strBlast_Sprite=<blast.pcx>;

//string 	strExplode_Model = <explosion.mdl>;

string stDeagle=<models\weapon\deagle5.mdl>;
string stShotgun=<models\weapon\shotgun5.mdl>;
string stAk47=<models\weapon\ak475.mdl>;
string stRailgun=<models\weapon\railgun.mdl>;
string stgrenade=<models\weapon\grenade.mdl>;


bmap sniper_map = <sniper_scope.pcx>;

//////////////////////////////////////////////////////////////////////
// adapt those skills and strings to your game
// ammo starting and maximum values
var ammo1[3] = 0, 0, 50;
var ammo2[3] = 0, 0, 100;
var ammo3[3] = 0, 0,  200;
var ammo4[3] = 0, 0,  50;
var ammo5[3] = 0, 0,  10;
var ammo6[3] = 0, 0,  10;
var ammo7[3] = 0, 0,  10;

// dynamic light values
var light_explo[3]  =  50,  50, 255;// { RED 50; GREEN 50; BLUE 255; }
var light_flash[3]  = 200, 150,  50;// { RED 200; GREEN 150; BLUE 50; }
var light_muzzle[3] = 200,  20,  20;// { RED 200; GREEN 20; BLUE 20; }
var light_bullet[3] = 200,  50,  20;// { RED 200; GREEN 50; BLUE 20; }



// you'll probably want to redefine those strings. No problem.
STRING got_ammo1_str,"Got 7 bullets for Desert Eagle!";
STRING got_ammo2_str,"Got 16 bullets for M3";
STRING got_ammo3_str,"Got 25 powermass bullets for Ak47UAC";
STRING got_ammo4_str,"Got 10 slugs!";
STRING got_ammo5_str,"Got grenade!";
STRING got_ammo6_str,"Got a rocket pack!";
STRING got_ammo7_str,"Got ammo7 pack!";

STRING got_medi_str,"Got a first aid kit!";

STRING got_armo_str,"Got a kevlar vest";


STRING got_gun1_str,"Desert Eagle .50 AE";
STRING got_gun2_str,"Benneli M3 Super90";
STRING got_gun3_str,"Ak47UAC machine gun";
STRING got_gun4_str,"RaigunUAC";
STRING got_gun5_str,"Got a shotgun!";
STRING got_gun6_str,"Got a rocket launcher!";
STRING got_gun7_str,"Got a gun no. 7!";

//////////////////////////////////////////////////////////////////////
/* Gun Action

FLAG1  (__ROTATE from doors.wdl)
	If this flag is set, the gun model rotates before being picked up.

FLAG2  (__SILENT from doors.wdl)
	If this flag is set, the message on picking up the item will be
	suppressed.

FLAG5  (__BOB from movement.wdl)
   If this flag is marked, the gun sways a little if the camera is
	moving. The sway period is the same as used for head bobbing in the
	movement.wdl. If the flag is not marked, the gun stands still.

FLAG7  (__REPEAT)
   If this flag is marked, it's a machine gun. Otherwise, a single
	action gun.

SKILL1..SKILL3   (_OFFS_X, _OFFS_Y, _OFFS_Z)
	X Y Z position of the gun relative to the camera.

SKILL4  (_AMMOTYPE)
	Ammo type (1..7). If 0, the gun doesn't consume ammunition. The part
	after the decimal, times 100, gives the amount of ammo to be added
	on picking up the gun. E.g. 2.30 = Ammo type 2, 30 rounds are
	already in the gun.

SKILL5 (_BULLETSPEED)
	Speed of the bullet, default = 200 quants / tick. The part after the
	decimal, times 10, gives the strength of the recoil. If 0, then
	there is no recoil. If SKILL5 is above 0, the recoil is done by
	moving backwards. If SKILL5 is below 0, then the recoil is done by
	swinging upwards.

SKILL6  (_WEAPONNUMBER)
	Weapon number that determines the key (1..7) to be pressed to select
	that gun.

SKILL7  (_FIRETIME)
   The time (in ticks) the gun needs to reload. Includes the time for
   the gun animation, if any.

SKILL8 (_FIREMODE from movement.wdl)
   Fire mode, can be composed by adding the following numbers:

	1 - Damage is applied by a SHOOT instruction, without bullet (DAMAGE_SHOOT).
	2 - Damage is applied by IMPACT of the bullet (DAMAGE_IMPACT).
	3 - Damage is applied by a SCAN explosion of the bullet (DAMAGE_EXPLODE).

	4 - the gun fires line of particles (FIRE_PARTICLE).
	8 - the gun fires single particles (FIRE_DPARTICLE).
	12 - the gun fires orange fireballs, which radiate light (FIRE_BALL).
	16 - the gun fires a rocket model w/smoke trail (FIRE_ROCKET)
	20 - (NEW 11/17/00) the gun fires a laser (FIRE_LASER)
	24 - Reserved
	28 - Reserved

	32 - the bullets leave smoke trails(BULLET_SMOKETRAIL).

	64 - reserved

	128 - at hit point there will be a light flash (HIT_FLASH).
	256 - at hit point there will be an explosion (HIT_EXPLO).
	384 - at hit point there will be a big explosion (HIT_GIB).

	512 - at hit point a cloud of smoke will ascend (HIT_SMOKE).

	1024 - there will be multiple hit points, as by a shotgun (HIT_SCATTER).

	2048 - the gun spits out cartridge cases (GUNFX_BRASS).

	4096 - the bullets follow gravity.

	8192 - at hit point a shower of sparks (HIT_SPARKS).

	16384 - bullet hole at hit point (HIT_HOLE)

	32768 - gun has a "shot" animation (GUNFX_ANIMATE)

	The part after the decimal, times 100, gives the amount of damage
	the bullet produces (default = 10).  ***

SKILL11..SKILL13   (_GUN_SOURCE_X, _GUN_SOURCE_Y, _GUN_SOURCE_Z)
	X Y Z offset position of the bullet starting point (in 1st person view)
	if X == 0 then the gun muzzle will be used.

SKILL14 (_OFFS_FLASH )
	Muzzle flash offset in X direction.

SKILL15 (_RECOIL)
	Weapon recoil value.

SKILL16 (_DAMAGE)
	Damage from weapon

SKILL17 (_DISPLACEMENT)
	Distance weapon is 'displaced'

SKILL18 (

*/
///////////////////////////////////////////////////////////////////////

// Define Flags
//FLAG1 = __ROTATE from doors.wdl
//FLAG2 = __SILENT from doors.wdl
//FLAG5 = __BOB from movement.wdl
DEFINE __REPEAT,FLAG7;

// Define SKILLs
DEFINE _OFFS_X,SKILL1;
DEFINE _OFFS_Y,SKILL2;
DEFINE _OFFS_Z,SKILL3;
DEFINE _AMMOTYPE,SKILL4;
DEFINE _BULLETSPEED,SKILL5;
DEFINE _WEAPONNUMBER,SKILL6;
DEFINE _FIRETIME,SKILL7;
//SKILL8 = _FIREMODE from movement.wdl

DEFINE _GUN_SOURCE_X,SKILL11;
DEFINE _GUN_SOURCE_Y,SKILL12;
DEFINE _GUN_SOURCE_Z,SKILL13;


DEFINE _OFFS_FLASH,SKILL14;
DEFINE _RECOIL,SKILL15;
DEFINE _DAMAGE,SKILL16;
DEFINE _DISPLACEMENT,SKILL17;
DEFINE _FIRE,SKILL18;

DEFINE _PACKAMOUNT, SKILL5;	// ammo/med pack ammo amounts


DEFINE _CLIP_MAX,SKILL45;
DEFINE _CLIP,SKILL46;
DEFINE _RELOADTIME,SKILL48;
DEFINE _RELOAD,SKILL47;
DEFINE _SND_RELOAD,SKILL50;
DEFINE _SND_SHOT,SKILL51;

define  _MONSTR_TYPE,SKILL52;

define _grenade_TIMER,SKILL65; //_move_timer for monster and grenade timer

DEFINE _MUZZLEATTACH, SKILL70;	// Muzzle vertex . Attach vertex
define _PARENT, SKILL71;

//define _VOICE_TIMER,SKILL70;

// Constants
DEFINE MODE_DAMAGE,3;
DEFINE DAMAGE_SHOOT,1;
DEFINE DAMAGE_IMPACT,2;
DEFINE DAMAGE_EXPLODE,3;

DEFINE MODE_FIRE,28;
DEFINE FIRE_PARTICLE,4;
DEFINE FIRE_DPARTICLE,8;
DEFINE FIRE_BALL,12;
DEFINE FIRE_ROCKET,16;
DEFINE FIRE_LASER,20;

DEFINE BULLET_SMOKETRAIL,32;

DEFINE MODE_HIT,384;
DEFINE HIT_FLASH,128;
DEFINE HIT_EXPLO,256;
DEFINE HIT_GIB,384;

DEFINE HIT_SMOKE, 512;

DEFINE HIT_SCATTER,1024;
DEFINE GUNFX_BRASS,2048;		// gun drops brass

DEFINE HIT_SPARKS,8192;

DEFINE HIT_HOLE 16384;

DEFINE GUNFX_ANIMATE, 32768; 	// gun has a firing animation


///////////////////////////////////////////////////////////////////////
entity* weapon;
// The weapon must be a model pointing into X-direction,
// its center must be inside the barrel.

DEFINE	kMaxWeapons = 7;

entity* weapon1;
/*
entity weapon1
{
type=<models\weapon\deagle5.mdl>;
layer=2;	
x = 10; // place 100 quants ahead of the view
y = 0; // 50 to the right
z = 0; // and center vertically
pan=90;
flags = visible;// visible on screen from the start
view = CAMERA; // same camera parameters as the default view
}
*/

entity* weapon2;
entity* weapon3;
entity* weapon4;
entity* weapon5;
entity* weapon6;
entity* weapon7;



entity* weaponTmpSyn;     // tmp ENTITY pointer


var weapon_1 = 0; 	// set to 1 if the player owns that weapon
var weapon_2 = 0;
var weapon_3 = 0;
var weapon_4 = 0;
var weapon_5 = 0;
var weapon_6 = 0;
var weapon_7 = 0;

var gun_muzzle[3];
var gun_source[4];	// trace start point   (gun_source[3] = 9 if used)
var gun_target[3];
var gun_loaded = 1;
var fireball_speed = 0;

var weapon_number = 0;
var ammo_number = 0;

var range = 0;
var damage = 0;
var fire_mode = 0;
var weapon_firing = 0;
var weapon_reloading = 0;
var grenade_firing=0;

var ammo_in_clip=0;
var delta=0;

//STRING anim_gun_reload,"reload";
//STRING anim_gun_shot,"shot";
//STRING anim_idle_str,"idle";
var my_blast_range;
var my_blast_damage;
var my_graphic_type;

//function do_explosion(my_blast_range,my_blast_damage,my_graphic_type);


//////////////////////////////////////////////////////////////////////

// 'Default' First Person Shooter guns
/****************************************************************
	Weapon Actions - Some pre-defined weapons

	todo: perhaps come up with a way to have the world
	models (laying on the ground) separate and different
	from the view models (in player's hand).
******************************************************************/


// Desc: basic animated machinegun type weapon
//
// Created: 07/25/01 DCP
//
// uses _WEAPONNUMBER
// uses __ROTATE
//====================================================


//PreloadDeagle();



BMAP	cross_bmp, <cross.pcx>;
//var cross_pos[2] = 0, 0;	// position of cross-hair on screen

PANEL	cross_pan
{
	bmap = cross_bmp;
	layer = 1;
   pos_x = 0; 
   pos_y = 0; 
	flags = overlay,  refresh, d3d;
}

 panel sniper_pan 
{ 
    bmap = sniper_map; 
    layer = 20; 
    pos_x = 0; 
    pos_y = 0; 
    flags = overlay, refresh, d3d; 
} 





// Desc: basic 'M16' type weapon
//
// Created: MWS 06/25/01
//
// uses _WEAPONNUMBER
// uses __SILENT

// Desc: basic 'rocket launcher' type weapon
//
// Created: MWS 06/25/01
//
// uses _WEAPONNUMBER
// uses __SILENT

/**************************************************************
	Ammo Actions - Default ammopacs from weapons.wdl,
	but with specific ammunition types (to simplify
	things for the WED user).  Uses defines from weapons.wdl,
	thus must be included after it.

***************************************************************/

// Desc: ammo boxes (weapons 1-7)
//
// Created: MWS 06/25/01
//
// uses _PACKAMOUNT
// uses __SILENT
action ammo_type1
{
	MY.__ROTATE = ON;
	MY._AMMOTYPE = 1;
	MY._PACKAMOUNT=7;
	
	ammopac();
}

// uses _PACKAMOUNT
// uses __SILENT
action ammo_type2
{
	MY.__ROTATE = ON;
	MY._AMMOTYPE = 2;
	MY._PACKAMOUNT=16;
	ammopac();
}

// uses _PACKAMOUNT
// uses __SILENT
action ammo_type3
{
	MY.__ROTATE = 1;
	MY._AMMOTYPE = 3;
	MY._PACKAMOUNT=25;
	ammopac();
}

// uses _PACKAMOUNT
// uses __SILENT
action ammo_type4
{
	MY.__ROTATE = 1;
	MY._AMMOTYPE = 4;
	MY._PACKAMOUNT=10;
	ammopac();
}

// uses _PACKAMOUNT
// uses __SILENT
action ammo_type5
{
	MY.__ROTATE = 1;
	MY._AMMOTYPE = 5;
	MY._PACKAMOUNT=1;
	ammopac();
}

// uses _PACKAMOUNT
// uses __SILENT
action ammo_type6
{
	MY.__ROTATE = 1;
	MY._AMMOTYPE = 6;
	ammopac();
}

// uses _PACKAMOUNT
// uses __SILENT
action ammo_type7
{
	MY.__ROTATE = 1;
	MY._AMMOTYPE = 7;
	ammopac();
}



// testgun, logangun, lasergun, sparkgun, & flashgun are all examples
//on how to create guns with the template code. Each one calls 'gun'.

// Desc: a testgun. This gun is special because it is removed if you do
//     not define 'TEST'.
/*
ACTION testgun
{
IFNDEF TEST;
	remove(ME);
	return;
ENDIF;
	MY.__ROTATE = ON;
	MY.__REPEAT = ON;
	MY.__BOB = ON;
	MY.SKILL1 = 50;
	MY.SKILL2 = 20;
	MY.SKILL3 = 20;
	MY._AMMOTYPE = 1.50;
	MY._WEAPONNUMBER = 1;
	MY._BULLETSPEED = -500.05;
	MY._FIRETIME = 2;
	MY._FIREMODE = DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH+0.30;
	gun();
}
*/
// Desc: "Logan's Run" type gun, used for testing
//
// uses _WEAPONNUMBER
// uses __SILENT

// Desc: shotgun type gun
//
// uses _WEAPONNUMBER
// uses __SILENT


////////////////////////////////////////////////////////////////////////

// Desc: Called from player_move action; player must exist here
//
// Mod Date: 05/01/02
//		major re-write
//		No longer invisible in 3rd person view
//		NEAR flag only set in 1st player view
function weapon_carry()
{
  	if(weapon == NULL || player == NULL) { return; }
	   weapon.passable = on;
		weapon.NEAR = ON;     // don't clip to player view
	//	weapon.INVISIBLE = OFF;
		weapon.ROLL =360-CAMERA.TILT;
		weapon.PAN = CAMERA.PAN+90;
		weapon.X = CAMERA.X+10* cos(CAMERA.pan) * cos(CAMERA.tilt);
		weapon.Y = CAMERA.Y+10* sin(CAMERA.pan) * cos(CAMERA.tilt); 
		weapon.Z = CAMERA.Z+10 * sin(CAMERA.tilt); 

	//	if(weapon._RECOIL < 0)
	//	{
	//		weapon.TILT -= weapon._DISPLACEMENT;
	//	}
	
}


////////////////////////////////////////////////////////////////////////
// Gun select functions
ACTION _gun_select1 {if (weapon_1==0)	{return;}; 	 weapon_number = 1; gun_select();}
ACTION _gun_select2 { if (weapon_2==0)	{return;}; weapon_number = 2; gun_select(); }
ACTION _gun_select3 { if (weapon_3==0)	{return;}; weapon_number = 3; gun_select(); }
ACTION _gun_select4 { if (weapon_4==0)	{return;}; weapon_number = 4; gun_select(); }
ACTION _gun_select5 { if (weapon_5==0)	{return;}; weapon_number = 5; gun_select(); }
ACTION _gun_select6 { if (weapon_6==0)	{return;}; weapon_number = 6; gun_select(); }
ACTION _gun_select7 { if (weapon_7==0)	{return;}; weapon_number = 7; gun_select(); }

// Desc: select the 'next' weapon
//
// Mod Date: 05/04/01 DCP
//		Fix endless loop when no weapon exists
//		(Note: this would be cleaner with a do..while loop)
function	gun_select_cycle_up()
{

	temp = weapon_number; // save the current weapon_number
	weapon_number += 1;
	while(temp != weapon_number)
	{
		if(weapon_number > kMaxWeapons)
		{
			weapon_number = 0;
			if(temp == 0)  // started with no weapon
			{
				return(0);
			}
		}
		if(gun_select() != -1)
		{
			return(weapon_number);
		}
		weapon_number += 1;   // try next weapon
	}
}

// Desc: select the 'prev' weapon
//
// Mod Date: 05/04/01 DCP
//		Fix endless loop when player has max weapon and no other
//		(Note: this would be cleaner with a do..while loop)
function	gun_select_cycle_down()
{
	temp = weapon_number; // save the current weapon_number
	weapon_number -= 1;
	while(temp != weapon_number)
	{
		if(weapon_number < 0)
		{
			weapon_number = kMaxWeapons;
			if(temp == kMaxWeapons)  // started with max weapon
			{
				return(kMaxWeapons);
			}
		}
		if(gun_select() != -1)
		{
			return(weapon_number);
		}
		weapon_number -= 1;   // try next weapon
	}
}



// Desc: select/switch weapon
//
//]- Mod 11/17/00 DCP
//]- Function returns -1 if no weapon is found (ME == NULL)
//]-	Function returns new weapon_number is a weapon is selected
//]-
//]- Mod:  04/11/01 DCP
//]-		Added weapon_number == 7
//]-
//]-	Mod: 07/25/01 DCP
//]-		Changed to function
function gun_select()
{
	if(weapon != NULL)
	{	// remove old weapon
		weapon.INVISIBLE = ON;
		weapon.PASSABLE = ON;
	}

 //	sniper_pan.visible = off; 
 


	if(weapon_number == 1) {  ME = weapon1; }
	if(weapon_number == 2) {  ME = weapon2; }
	if(weapon_number == 3) {  ME = weapon3; }
	if(weapon_number == 4) {  ME = weapon4; }
	if(weapon_number == 5) {  ME = weapon5; }
	if(weapon_number == 6) {  ME = weapon6; }
	if(weapon_number == 7) {  ME = weapon7; }
	if(ME == NULL) { return(-1); }

	ammo_number = MY._AMMOTYPE;
	MY.INVISIBLE =  OFF;
	MY.PASSABLE = ON;	// prevent collision with obstacles
	MY.NEAR = ON;	// prevent clipping
	weapon = ME;		// I'm the current weapon now
	carry = weapon_carry;
	//attach_entity

	EXCLUSIVE_GLOBAL;

	ScopeOFF();

	// handle firing
	while(weapon == ME)
	{
		if(weapon_reloading && (gun_loaded > 0) && (MY._RELOAD <= 0) )
		{
			gun_reload();
		}

		if(weapon_firing && (gun_loaded > 0) && (MY._FIRE <= 0) )
		{
			gun_fire();
		}

		if((weapon_firing == 0) && (gun_loaded == 0) && (MY.__REPEAT == OFF))
		{
			gun_loaded = 1;
		}
		wait(1);
	}
	return(weapon_number);
}
//===================================
//strBlast_Sprite,my.x,_do_blast_sprite

function _do_blast_sprite()
{
	MY.AMBIENT = 100;
	MY.FACING = Off;
	my.ORIENTED =on;
	MY.NEAR = ON;
  	MY.FLARE = ON;
  	my.tilt=90;
  	
	//my.scale_z=2;
	//my.scale_y=2;
	//my.scale_x=2;
	
	MY.PASSABLE =  ON;
	MY.AMBIENT = 100;
	/*
	MY.LIGHTRED = light_flash.RED;
	MY.LIGHTGREEN = light_flash.GREEN;
	MY.LIGHTBLUE = light_flash.BLUE;
	MY.LIGHTRANGE = 64;
	
	my.z-=my.min_z*2;
	
	emit(20,my.x,particle_explode);
	
	wait(1);
	// play sound
	// must wait one turn before we can play the sound
//   ent_playsound(ME,hit_wham,100);
   
  	play_entsound ME,rocket_expl,700;
  	*/
	while(MY.CYCLE <= 6)
	{
		MY.CYCLE +=TIME;
		my.scale_y+=0.1;
		my.scale_x+=0.1;

		wait(2);
	}


	// animate
	/*
 	while(MY.CYCLE <= 16)
	{
		MY.CYCLE += TIME;
		wait(1);
	}
*/
	remove(me);
}




function _do_explosion_sprite()
{
	MY.AMBIENT = 100;
	MY.FACING = ON;
	MY.NEAR = ON;
  	MY.FLARE = ON;
	my.scale_z=2;
	my.scale_y=2;
	my.scale_x=2;
	
	MY.PASSABLE =  ON;
	MY.AMBIENT = 100;
	MY.LIGHTRED = light_flash.RED;
	MY.LIGHTGREEN = light_flash.GREEN;
	MY.LIGHTBLUE = light_flash.BLUE;
	MY.LIGHTRANGE = 64;
	
	my.z-=my.min_z*2;
	
	emit(20,my.x,particle_explode);
	
	wait(1);
	// play sound
	// must wait one turn before we can play the sound
//   ent_playsound(ME,hit_wham,100);
   
  	play_entsound ME,rocket_expl,700;
	while(MY.CYCLE <= 9)
	{
		MY.CYCLE +=2*TIME;
		waitt(1);
	}



	remove(me);
}


//=========================================================
function do_explosion( my_blast_range,my_blast_damage,my_graphic_type)
{
	range = my_blast_range;

		
		ent_create(strExplode_Sprite,my.x,_do_explosion_sprite); // create an explosion sprite
		ent_create(strBlast_Sprite,my.x,_do_blast_sprite); // create an explosion sprite
	MY.push=0;

	// Apply damage
	damage = my_blast_damage;
 	temp.PAN = 360;
	temp.TILT = 360;
	temp.Z = range;
	indicator = _EXPLODE;	// must always be set before scanning
	scan_entity(MY.x,temp);


}


//////////////////////////////////////////////////////////////////////
// Pickup functions



// Desc: limit ammo to maximum values
//
// Mod:  04/11/01 DCP
//		Added ammo5, ammo6, & ammo7
function _ammo_limit()
{
	if(ammo1 > ammo1.Z) { ammo1 = ammo1.Z; }
	if(ammo2 > ammo2.Z) { ammo2 = ammo2.Z; }
	if(ammo3 > ammo3.Z) { ammo3 = ammo3.Z; }
	if(ammo4 > ammo4.Z) { ammo4 = ammo4.Z; }
	if(ammo5 > ammo5.Z) { ammo5 = ammo5.Z; }
	if(ammo6 > ammo6.Z) { ammo6 = ammo6.Z; }
	if(ammo7 > ammo7.Z) { ammo7 = ammo7.Z; }
}

// Desc: handle gun pickup event
//
// Mod:  04/11/01 DCP
//		Turned into function
//		Added ammo5, ammo6, & ammo7
function gun_pickup()
{
	if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }

	MY.ENABLE_SCAN = OFF;
	MY.ENABLE_CLICK = OFF;
	MY.ENABLE_PUSH = OFF;

	if(INT(MY._AMMOTYPE) == 1) { ammo1 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); }
	if(INT(MY._AMMOTYPE) == 2) { ammo2 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); }
	if(INT(MY._AMMOTYPE) == 3) { ammo3 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 4) { ammo4 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 5) { ammo5 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 6) { ammo6 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 7) { ammo7 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	MY._AMMOTYPE = INT(MY._AMMOTYPE);	// ammo type
//	_ammo_limit();

	//ent_morph (my, deagle_mdl); 
	if(MY.__SILENT != ON) { show_message(); }
	weapon_number = MY._WEAPONNUMBER;
	
	if(weapon_number == 1) {remove(me); weapon_1 = 1;ON_1 = _gun_select1;  msg.STRING = got_gun1_str; }
	if(weapon_number == 2) {remove(me); weapon_2 = 1;ON_2 = _gun_select2;  msg.STRING = got_gun2_str; }
	if(weapon_number == 3) {remove(me); weapon_3 = 1;ON_3 = _gun_select3;  msg.STRING = got_gun3_str; }
	if(weapon_number == 4) {remove(me); weapon_4 = 1;ON_4 = _gun_select4;  msg.STRING = got_gun4_str; }
		
	
	
	//if(weapon_number == 4) {  weapon4 = ME; weapon_4 = 1;  ON_4 = _gun_select4;  msg.STRING = got_gun4_str; }
//	if(weapon_number == 5) {  weapon5 = ME; weapon_5 = 1;  ON_5 = _gun_select5;  msg.STRING = got_gun5_str; }
//	if(weapon_number == 6) {  weapon6 = ME; weapon_6 = 1;  ON_6 = _gun_select6;  msg.STRING = got_gun6_str; }
//	if(weapon_number == 7) {  weapon7 = ME; weapon_7 = 1;  ON_7 = _gun_select7;  msg.STRING = got_gun7_str; }


	//CREATE(<WAFFE1.MDL>,nullskill,startgun1);
	
	gun_select();
}


// Desc: handle ammo pickup event
//]- Mod: 10/3/00 Added 'wait' if message is displayed, allows show_message
//]- 				to finish displaying
// Mod:  04/11/01 DCP
//		Added ammo5, ammo6, & ammo7
function ammo_pickup()
{
//	if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }
	
	/*
	if(ammo1 > ammo1.Z) { ammo1 = ammo1.Z; }
	if(ammo2 > ammo2.Z) { ammo2 = ammo2.Z; }
	if(ammo3 > ammo3.Z) { ammo3 = ammo3.Z; }
	if(ammo4 > ammo4.Z) { ammo4 = ammo4.Z; }
	if(ammo5 > ammo5.Z) { ammo5 = ammo5.Z; }
	if(ammo6 > ammo6.Z) { ammo6 = ammo6.Z; }
	if(ammo7 > ammo7.Z) { ammo7 = ammo7.Z; }
	*/
	if(MY._AMMOTYPE == 1 && ammo1 >= ammo1.Z) {return;}
	if(MY._AMMOTYPE == 2 && ammo2 >= ammo2.Z) {return;}
	if(MY._AMMOTYPE == 3 && ammo3 >= ammo3.Z) {return;}
	if(MY._AMMOTYPE == 4 && ammo4 >= ammo4.Z) {return;}
	if(MY._AMMOTYPE == 5 && ammo5 >= ammo5.Z) {return;}
	if(MY._AMMOTYPE == 6 && ammo6 >= ammo6.Z) {return;}
	if(MY._AMMOTYPE == 7 && ammo7 >= ammo7.Z) {return;}
	
		

	if(MY._AMMOTYPE == 1) { ammo1 += MY._PACKAMOUNT;  msg.STRING = got_ammo1_str; } 
	if(MY._AMMOTYPE == 2) { ammo2 += MY._PACKAMOUNT;  msg.STRING = got_ammo2_str; } 
	if(MY._AMMOTYPE == 3) { ammo3 += MY._PACKAMOUNT;  msg.STRING = got_ammo3_str; } 
	if(MY._AMMOTYPE == 4) { ammo4 += MY._PACKAMOUNT;  msg.STRING = got_ammo4_str; } 
	if(MY._AMMOTYPE == 5) { ammo5 += MY._PACKAMOUNT;  msg.STRING = got_ammo5_str; } 
	if(MY._AMMOTYPE == 6) { ammo6 += MY._PACKAMOUNT;  msg.STRING = got_ammo6_str; } 
	if(MY._AMMOTYPE == 7) { ammo7 += MY._PACKAMOUNT;  msg.STRING = got_ammo7_str; } 
	if(MY.__SILENT != ON) { show_message(); }
	//_ammo_limit();
	PLAY_SOUND ammo_fetch,100;


	if(MY.__SILENT != ON)
	{
		// hide item..
		MY.EVENT = NULL;
		MY.PASSABLE = ON;
		MY.INVISIBLE = ON;
		waitt(MSG_TICKS);	// wait for message to vanish
	}

	remove(ME);
}


// Desc: ammo pack entity
//
// Mod:  04/11/01 DCP
//		Added ammo5, ammo6, & ammo7
//
// uses _AMMOTYPE, _PACKAMOUNT
// uses __ROTATE, __SILENT
ACTION ammopac
{
	// default ammo type is 1
	if(MY._AMMOTYPE == 0) { MY._AMMOTYPE = 1; }

	// default ammo amount is a quarter of ammo maximum
	if(MY._PACKAMOUNT == 0)
	{
		if(MY._AMMOTYPE == 1) { MY._PACKAMOUNT = ammo1.Z * 0.25; }
		if(MY._AMMOTYPE == 2) { MY._PACKAMOUNT = ammo2.Z * 0.25; }
		if(MY._AMMOTYPE == 3) { MY._PACKAMOUNT = ammo3.Z * 0.25; }
		if(MY._AMMOTYPE == 4) { MY._PACKAMOUNT = ammo4.Z * 0.25; }
		if(MY._AMMOTYPE == 5) { MY._PACKAMOUNT = ammo5.Z * 0.25; }
		if(MY._AMMOTYPE == 6) { MY._PACKAMOUNT = ammo6.Z * 0.25; }
		if(MY._AMMOTYPE == 7) { MY._PACKAMOUNT = ammo7.Z * 0.25; }
	}
	
	ToGround();
	MY.ENABLE_SCAN = Off;
	MY.EVENT = ammo_pickup;
	item_pickup();
}

// Desc: handle medipac event
function medi_pickup()
{
	//if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }

	if(YOU == NULL) {  YOU = player; }
	if(YOU == NULL) { return; }
	if(YOUR._HEALTH > =100) { return; }
	
	
	YOUR._HEALTH += MY.SKILL5;
	if(YOUR._HEALTH > 100) { YOUR._HEALTH = 100; }  // health max at 100%

	PLAY_SOUND health_fetch,100;
	msg.STRING = got_medi_str;

	if(MY.__SILENT != ON) { show_message(); }
	remove(ME);
}

function armor_pickup()
{
	//if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }

	if(YOU == NULL) {  YOU = player; }
	if(YOU == NULL) { return; }
	if(YOUR._ARMOR > 100) { return; }

	YOUR._ARMOR += MY.SKILL5;
	if(YOUR._ARMOR > 100) { YOUR._ARMOR = 100; }  // health max at 100%

	PLAY_SOUND health_fetch,100;
	msg.STRING = got_armo_str;

	if(MY.__SILENT != ON) { show_message(); }
	remove(ME);
}

// Desc: medipac entity
//
// uses _PACKAMOUNT
// uses __ROTATE, __SILENT
ACTION medipac
{
	if(MY._PACKAMOUNT == 0) { MY._PACKAMOUNT = 25; }
	ToGround();
	MY.EVENT = medi_pickup;
	item_pickup();
}

ACTION armor50
{
	MY._PACKAMOUNT = 50; 
	ToGround();
	MY.EVENT = armor_pickup;
	item_pickup();
}

// Desc: restore a gun already owned by the player (from a previous level)
//
// Note: keep the gun in the level
//
// Mod Date: 02/13/02 DCP
//		Added 'gun_loaded = 1' to reload repeating guns.
function gun_restore()
{
	// weapon was already picked up by the player
	MY._AMMOTYPE = INT(MY._AMMOTYPE);	// happens on pickup

	MY.INVISIBLE = ON;
	MY.PASSABLE = ON;
	MY.ENABLE_SCAN = OFF;
	MY.ENABLE_CLICK = OFF;
	MY.ENABLE_PUSH = OFF;
	MY.EVENT = NULL;
	// Was it the last weapon the player carried?
	if(weapon_number == MY._WEAPONNUMBER) { gun_select(); }
	if(MY.__REPEAT == ON)
	{
		//reload repeating guns (in case they were in 'mid-fire')
		wait(1);    		// allow the gun to move 'in place'
		gun_loaded = 1;   // reload
	}
}

// Desc: set up a gun
//
//]- Mod: 04/17/01 DCP
//]-		set the weapon source offset (if one is not already defined)
//]-
//]- Mod: 07/26/01 DCP
//]-		broke out 'gun_restore' function
//]-
// Mod: 12/18/01 DCP
//		Moved _OFFS_FLASH (made it user definable)
//		Added default _AMMOTYPE
//
// Mod: 02/13/02 DCP
// 	Removed default _AMMOTYPE (if _AMMOTYPE = 0, gun has unlimited ammo)
//
// uses _OFFS_X, _OFFS_Y, _OFFS_Z, _GUN_SOURCE_X, _GUN_SOURCE_Y, _GUN_SOURCE_Z
// uses _OFFS_FLASH, _WEAPONNUMBER, _FIREMODE, _BULLETSPEED, _AMMOTYPE, _FIRETIME
// uses __ROTATE, __SILENT, __REPEAT, __BOB



/*
ACTION gun
{
	MY._CLIP=0;
	MY._CLIP_MAX=int(frc(MY._AMMOTYPE)*100+0.5);
	//MY._FIREMODE = DAMAGE_SHOOT + HIT_HOLE + GUNFX_BRASS + GUNFX_ANIMATE + 0.20;
//	MY._FIREMODE = DAMAGE_SHOOT + HIT_HOLE + HIT_FLASH + HIT_SPARKS + GUNFX_ANIMATE+0.10;
	// set the weapon camera offset (if one is not already defined)
//	if(MY._OFFS_X == 0)
//	{
//		MY._OFFS_X = 50;
//		MY._OFFS_Y = 20;
//		MY._OFFS_Z = 20;
//	}


	if(MY._OFFS_FLASH == 0)
	{
		MY._OFFS_FLASH = MY.MAX_y + 1; 	// Muzzle flash offset
	}

	// set the weapon source offset (if one is not already defined)
//	if(MY._GUN_SOURCE_X == 0)
//	{
//		MY._GUN_SOURCE_X = MY._OFFS_X + MY._OFFS_FLASH;
//		MY._GUN_SOURCE_Y = -MY._OFFS_Y;
//		MY._GUN_SOURCE_Z = -MY._OFFS_Z;
//	}

	// make sure we have a valid _WEAPONNUMBER
	if(MY._WEAPONNUMBER <= 0 || MY._WEAPONNUMBER > 7)
	{ MY._WEAPONNUMBER = 1; }

	// set damage
	MY._DAMAGE = FRC(MY._FIREMODE) * 100;
 	if(MY._DAMAGE == 0)
	{ MY._DAMAGE = 20; } // default to 20 damage

	// set firemode
	MY._FIREMODE = INT(MY._FIREMODE);
	if(MY._FIREMODE == 0)
	{ MY._FIREMODE = DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH; }   // default to

	// set recoil (up or back)
	MY._RECOIL = FRC(MY._BULLETSPEED) * 100;

	// set bullet speed
	MY._BULLETSPEED = ABS(MY._BULLETSPEED);
	if(MY._BULLETSPEED < 1)
	{ MY._BULLETSPEED = 200; }   // default to 200


	// make sure we have an ammotype
//	if(MY._AMMOTYPE == 0)
//	{ MY._AMMOTYPE = 1; } // default ammotype


	MY.EVENT = gun_pickup;
	item_pickup();

	// check whether this gun was picked up before in another level,
	// and has to be re-created for this level
	if(MY._WEAPONNUMBER == 1 && weapon_1 == 1 && weapon1 == NULL)
	{ weapon1 = ME; gun_restore(); return; }
	if(MY._WEAPONNUMBER == 2 && weapon_2 == 1 && weapon2 == NULL)
	{ weapon2 = ME; gun_restore(); return; }
	if(MY._WEAPONNUMBER == 3 && weapon_3 == 1 && weapon3 == NULL)
	{ weapon3 = ME; gun_restore(); return; }
	if(MY._WEAPONNUMBER == 4 && weapon_4 == 1 && weapon4 == NULL)
	{ weapon4 = ME; gun_restore(); return; }
	if(MY._WEAPONNUMBER == 5 && weapon_5 == 1 && weapon5 == NULL)
	{ weapon5 = ME; gun_restore(); return; }
	if(MY._WEAPONNUMBER == 6 && weapon_6 == 1 && weapon6 == NULL)
	{ weapon6 = ME; gun_restore(); return; }
	if(MY._WEAPONNUMBER == 7 && weapon_7 == 1 && weapon7 == NULL)
	{ weapon7 = ME; gun_restore(); return; }
}

*/


// Desc: init a gun, give it to the player, and select it
// Note: see the Action 'startgun1' to see how to use this function
/*
function	gun_givePlayer()
{
	gun();   // init the gun

	MY.ENABLE_SCAN = OFF;
	MY.ENABLE_CLICK = OFF;
	MY.ENABLE_PUSH = OFF;

	if(INT(MY._AMMOTYPE) == 1) { ammo1 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); }
	if(INT(MY._AMMOTYPE) == 2) { ammo2 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); }
	if(INT(MY._AMMOTYPE) == 3) { ammo3 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 4) { ammo4 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 5) { ammo5 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 6) { ammo6 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	if(INT(MY._AMMOTYPE) == 7) { ammo7 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);	}
	MY._AMMOTYPE = INT(MY._AMMOTYPE);	// ammo type
	_ammo_limit();

	weapon_number = MY._WEAPONNUMBER;
	if(weapon_number == 1) {  weapon1 = ME; weapon_1 = 1;  ON_1 = _gun_select1;  msg.STRING = got_gun1_str; }
	if(weapon_number == 2) {  weapon2 = ME; weapon_2 = 1;  ON_2 = _gun_select2;  msg.STRING = got_gun2_str; }
	if(weapon_number == 3) {  weapon3 = ME; weapon_3 = 1;  ON_3 = _gun_select3;  msg.STRING = got_gun3_str; }
	if(weapon_number == 4) {  weapon4 = ME; weapon_4 = 1;  ON_4 = _gun_select4;  msg.STRING = got_gun4_str; }
	if(weapon_number == 5) {  weapon5 = ME; weapon_5 = 1;  ON_5 = _gun_select5;  msg.STRING = got_gun5_str; }
	if(weapon_number == 6) {  weapon6 = ME; weapon_6 = 1;  ON_6 = _gun_select6;  msg.STRING = got_gun6_str; }
	if(weapon_number == 7) {  weapon7 = ME; weapon_7 = 1;  ON_7 = _gun_select7;  msg.STRING = got_gun7_str; }

	if(MY.__SILENT != ON) { show_message(); }
	gun_select();
}
*/


//////////////////////////////////////////////////////////////////////

// Desc: fire weapon
function weapon_fire()
{
	weapon_firing = 1;
 	while(key_pressed(scan_code_fire)) { wait(1); }
	weapon_firing = 0;
}

// Desc: deselect weapon
function weapon_remove()
{
	if(weapon != NULL)
	{
		weapon.INVISIBLE = ON;
		weapon = NULL;
		weapon_number = 0;
	}
}
function weapon_reload() 
{ 

	weapon_reloading = 1;
 	while(key_pressed(scan_code_reload)) { wait(1); }
	weapon_reloading = 0;
   
} 

// Desc: put weapons and ammo to inital state
//
//]- Mod: 04/11/00 DCP
//]-Added ammo5, ammo6, & ammo7
function weapon_init()
{
	weapon_remove();
	ammo1 = 0;
	ammo2 = 0;
	ammo3 = 0;
	ammo4 = 0;
	ammo5 = 0;
	ammo6 = 0;
	ammo7 = 0;
	weapon_1 = 0;
	weapon_2 = 0;
	weapon_3 = 0;
	weapon_4 = 0;
	weapon_5 = 0;
	weapon_6 = 0;
	weapon_7 = 0;
	weapon_number = 0;
}

//////////////////////////////////////////////////////////////////////

//string	anim_gun_shot = "shot"; 	// gun animation string
												// used in 'gun_animate()'

// Desc: animate the gun model using _FIRETIME and _FIRE
//
// Mod: 07/25/01	DCP
//		Created

function gun_animate_my()
{
	
if (my._FIRE > 0)	{
	MY._FIRE=MY._FIRETIME;	
	snd_PLAY (MY._SND_SHOT, 100, 0);
	
  while (my._FIRE > 0)
  {
  	temp = ((MY._FIRETIME - MY._FIRE)/ MY._FIRETIME) * 100;
  	ent_cycle("shot",temp); // set the frame from the percentage
   wait(1);
   MY._FIRE -= TIME;
  }
  ent_frame("shot",0); 	// return to base frame
  return;
 						}	
						
if (my._RELOAD > 0)	{

 	my._RELOAD= MY._RELOADTIME;
 	snd_PLAY (MY._SND_RELOAD, 100, 0);
  while (my._RELOAD>0)
  {
  	temp = ((MY._RELOADTIME - MY._RELOAD)/ MY._RELOADTIME) * 100;
   ent_cycle("reload",temp); // set the frame from the percentage
   wait(1);
   my._RELOAD-=time;
  }
  ent_frame("shot",0); 	// return to base frame
  	return;
						}	
						
							
	
}


// Desc:  Handle the player firing the gun
//
//]- Mod: 6/14/00 DCP
//]-			Added a WAIT 1 so bullet does not collide with muzzle_flash
//]-
// Mod:  04/11/01 DCP
//		Added ammo5, ammo6, & ammo7
//
// Mod:  04/17/01 DCP
//		Make player passable before calling 'gun_shot' (restore afterwords)
//
// Mod:  04/18/01 DCP
//		Calculate 'gun_source' here now. Set 'gun_source[3] = 9' so gun_shot
//	knows to use the 'gun_source' vector for traces.
//	 	Modified 3rd person 'gun_source', 'gun_muzzle', & 'gun_target' calculation
//	(no longer depends on cammera location)
//
// Mod:  04/18/01 DCP
//		Replaced goto no_ammo with _gun_fire_no_ammo();
//
// Mod: 07/25/01 DCP
//	Added check for gun animation (calls "gun_animate()").
//
// Mod: 05/13/02 DCP
//	Added a local var "my_gun_target" to save the gun_target value during a wait command
function gun_fire()
{
	var	my_gun_target[3];     	
	
		while(MY._RELOAD > 0) {return;}
	
	//MY._RELOAD =-1;
	// check to make sure we have ammo
	// if so, reduce ammo# count by one
	// else got 'no_ammo'
		if(MY._CLIP > 0) { MY._CLIP -= 1; }
		
		
		else{ 
		
		gun_reload();
		
		
		return;
	
		
		
		}


   gun_loaded = 0;

   
	if(my._MUZZLEATTACH > 0)       // if we are using a muzzle vertex
	{
	// attach to gun point
		vec_for_vertex(gun_muzzle,my,my._MUZZLEATTACH);
		create(muzzle_flash,gun_muzzle,_flashup);
		vec_set(gun_source.x,gun_muzzle.x);
	}
	else
	{
	gun_source.Y =CAMERA.y;
	gun_source.Z =CAMERA.z;
	gun_source.x =CAMERA.x;
	}
	//Alert! Sound
	vec_set(ALERT_SOUND_PLACE, gun_muzzle);
   // use local var to save gun_target value over the wait command
	vec_set(my_gun_target.x,nullvector);
	my_gun_target.x = MY._BULLETSPEED;
	vec_rotate(my_gun_target.x,camera.pan);	// vector pointing ahead of the actor
	vec_add(my_gun_target.x,camera.x);      // offset by the actor
	wait(1); // allow muzzle_flash to become passable (so bullet does not hit it!)

	vec_set(gun_target,my_gun_target);
	gun_source[3] = 9;             // mark this as 'player fired'
   // emit a bullet or particle
	shot_speed.X = (gun_target.X - gun_source.X);
	shot_speed.Y = (gun_target.Y - gun_source.Y);
	shot_speed.Z = (gun_target.Z - gun_source.Z);

	damage = MY._DAMAGE;
	fire_mode = MY._FIREMODE;
	player.passable = ON;   // make it so the gun doesn't hit the player
	gun_shot();   				// fire the shot
	player.passable = OFF;
	
	// animate gun?
	my._FIRE =1;
	if((fire_mode & GUNFX_ANIMATE) != 0)
	{
	 	gun_animate_my(); // animate gun cycle
	}
	if(MY.__REPEAT == ON) { gun_loaded = 1;}
}


function gun_reload()
{
	// check to make sure we have ammo
	// if so, reduce ammo# count by one
	// else got 'no_ammo'
	
	while(MY._FIRE > 0) { return; }
	
	if (MY._CLIP >= MY._CLIP_MAX) {return;}
	 	
 //sniper_pan.visible = off; 
 ScopeOFF();


	  	
		delta=MY._CLIP_MAX-MY._CLIP;
	
	
	
	if(MY._AMMOTYPE == 1)
	{
		if(ammo1 > 0)
		 {
				if (ammo1 >= delta) { MY._CLIP+=delta; ammo1-=delta;}
				else {MY._CLIP+=ammo1; ammo1=0;}
			 
		 }
		
		
		else{ return; }
	}
	
	if(MY._AMMOTYPE == 2)
	{
		if(ammo2 > 0) 
		{
			
			while(1)
			{
			if (my.INVISIBLE == ON) {return;};
		//	if (MY._FIRE > 0) {return;};
			
			 ammo2 -= 1; 
			 MY._CLIP+=1;
			 //===========================
			 
			 	MY._RELOAD = MY._RELOADTIME;
				gun_animate_my(); // animate gun cycle
				snd_PLAY (MY._SND_RELOAD, 100, 0);
				while(MY._RELOAD > 0)
					{
					wait(2);
				
					}
				//MY._RELOAD = 0 ;

			 if (MY._CLIP == MY._CLIP_MAX) {break;};
			 if (ammo2 <=0) {break;};
			 if (weapon_firing ==1) {break;};
			 //========================
		 		}
		return;
		}
		
		else{ return; }
		
	}
	
	if(MY._AMMOTYPE == 3)
	{
		if(ammo3 > 0)
		 {
		
		
				if (ammo3 >= delta) { MY._CLIP+=delta; ammo3-=delta;}
				else {MY._CLIP+=ammo3; ammo3=0;}
			}
		
		else{ return; }
			

	}
	
	
	if(MY._AMMOTYPE == 4)
	{
			if(ammo4 > 0)
		 {
	
				if (ammo4 >= delta) { MY._CLIP+=delta; ammo4-=delta;}
				else {MY._CLIP+=ammo4; ammo4=0;}
		}
		
		else{ return; }

	}
	
//	snd_PLAY (MY._SND_RELOAD, 100, 0);
	MY._RELOAD = MY._RELOADTIME;
	gun_animate_my(); // animate gun cycle
	//MY._RELOAD = MY._RELOADTIME;
	while(MY._RELOAD > 0)
	{
		wait(1);
 		// rock back into place from recoil
		//MY._DISPLACEMENT *= 0.6;

	}
	//MY._DISPLACEMENT = 0 ;
//	MY._RELOAD = 0 ;

	//if(MY.__REPEAT == ON) { gun_loaded = 1;}
}
// Desc: handle gun_fire's no ammo case
//		(play 'gun_click' noise at half volume)
//
// Note: entity (ME) must be valid
//
// Mod 04/19/01 DCP
//		Created
function _gun_fire_no_ammo()
{
	PLAY_ENTSOUND(ME,gun_click,100);
}

var	_gun_shot_temp[3];     // 'local' temp vector
var	_gun_shot_sCount;      // 'local' counter
var	scatter_number = 6;   	// number of SCATTER rounds
DEFINE	SCATTER_RAND, 160;      // SCATTER width
DEFINE	SCATTER_HALF_RAND, 80;

// Desc: select and handle shot type using 'fire_mode'
//
// needs gun_muzzle,shot_speed,damage,fire_mode
//
function gun_shot()
{
	// particle trail shot (line of particles)
	if((fire_mode & MODE_FIRE) == FIRE_PARTICLE)
	{
		vec_set(p,gun_muzzle);
		vec_set(p2,gun_target);
		particle_line();
	}
	// single particle
	if((fire_mode & MODE_FIRE) == FIRE_DPARTICLE)
	{ emit(1,gun_muzzle,particle_shot); }
	// fireball
	if((fire_mode & MODE_FIRE) == FIRE_BALL)
	{ create(impfireball,gun_muzzle,bullet_shot); }
	// rocket model
	if((fire_mode & MODE_FIRE) == FIRE_ROCKET)
	{ 
	ent_create(strRocket_Model,gun_muzzle,rocket_launch);
	}

	// eject brass?
	if((fire_mode & GUNFX_BRASS) != 0)
	{
	 	emit(1,gun_muzzle,particle_gunBrass); // emit brass
	}
	// bullet damage is done with a trace
	if((fire_mode & MODE_DAMAGE) == DAMAGE_SHOOT)
	{
		// set gun_target
		gun_target.X = 2*shot_speed.X + gun_muzzle.X;
		gun_target.Y = 2*shot_speed.Y + gun_muzzle.Y;
		gun_target.Z = 2*shot_speed.Z + gun_muzzle.Z;

		if((fire_mode & HIT_SCATTER) != 0)	// scatter gun?
		{
			vec_set(_gun_shot_temp.X, gun_target.X);	// save base gun_target

			_gun_shot_sCount = 0;
			while(_gun_shot_sCount < scatter_number)
			{
				// offset each shot by a random amount
				gun_target.X = _gun_shot_temp.X + (Random(SCATTER_RAND)-SCATTER_HALF_RAND);
				gun_target.Y = _gun_shot_temp.Y + (Random(SCATTER_RAND)-SCATTER_HALF_RAND);
				gun_target.Z = _gun_shot_temp.Z + (Random(SCATTER_RAND)-SCATTER_HALF_RAND);
				_gun_shot_damage_shoot();
				_gun_shot_sCount += 1;
			}
			vec_set(gun_target.X, _gun_shot_temp.X);	// restore  gun_target
 		}
		else
		{
			// fire one shot
 			_gun_shot_damage_shoot();
		}

	}
//snd_PLAY (MY._SND_SHOT, 100, 0);
}


// Desc: handle DAMAGE_SHOOT shots from function 'gun_shot'
//
// Note: helper function for gun_shot
//
/* help The follow must be set before calling:
		gun_source: source of the shot (x,y,z)
				NOTE: gun_source used "only" if gun_source[3] is set to 9
				NOTE2: if gun_source[3] == 9, then it is set to 0
		gun_muzzle: source of the shot (x,y,z) if gun_source[3] != 9
		gun_target: target of the weapon fire (x,y,z)
		shot_speed: used for effects such as the laser

*/
// Mod 04/20/01 DCP
//		Created
//
// Mod 05/13/02 DCP
//		Calculate/Recalculate 'shot_speed' for laser effect.
function _gun_shot_damage_shoot()
{
		indicator = _GUNFIRE;	// indicator for the entity that was hit
		trace_mode = IGNORE_ME + IGNORE_PASSABLE + ACTIVATE_SHOOT+ignore_sprites+ignore_push;
//breakpoint;
		if(gun_source[3] == 9) 	// player firing?
		{
			// use gun_source
 			RESULT = trace(gun_source,gun_target);
			gun_source[3] = 0;	// reset value
			vec_set(gun_muzzle,gun_source);				// important for when/if we calculate shot_speed
		}
		else
		{
	 		RESULT = trace(gun_muzzle,gun_target);
		}
   	if(RESULT > 0)
		{ // hit something?
			_hit_point_effect();	// send fire_mode and TARGET
		}
}

///////////////////////////////////////////////////////////////////////
// Desc: hit flash
//
//]- Mod Date: 8/31/00 DCP
//]-		Scaled by actor_scale

function _blowup()
{
	MY.SCALE_X = 2;
	MY.SCALE_Y = 2;
	vec_scale(MY.SCALE_X,actor_scale);

	MY.PASSABLE = ON;
	MY.FACING = ON;
	MY.NEAR = ON;
	MY.FLARE = ON;
	MY.AMBIENT = 100;
	MY.LIGHTRED = light_flash.RED;
	MY.LIGHTGREEN = light_flash.GREEN;
	MY.LIGHTBLUE = light_flash.BLUE;
	MY.LIGHTRANGE = 64;
	wait(1);
	PLAY_ENTSOUND ME,hit_wham,100;
	remove(ME);
}

// Desc: muzzle flash
//
//]- Mod Date: 8/31/00 DCP
//]-		Scaled by actor_scale
function _flashup()
{
	MY.SCALE_X = 0.2;
	MY.SCALE_Y = 0.2;
	//vec_scale(MY.SCALE_X,actor_scale);
	//vec_for_vertex(my.x,you,you._OFFS_FLASH); 
	
	MY.PASSABLE = ON;
	my.overlay = ON;
	// Set flare only in D3D mode
	if(VIDEO_MODE > 8) { MY.FLARE = ON; }
	else{ MY.TRANSPARENT = ON; }

	MY.FACING = ON;
	MY.AMBIENT = 100;
	my.unlit=on;
	MY.LIGHTRED = 255;
	MY.LIGHTGREEN = 255;
	MY.LIGHTBLUE = 255;
	
//	MY.LIGHTRED = light_muzzle.RED;
//	MY.LIGHTGREEN = light_muzzle.GREEN;
//	MY.LIGHTBLUE = light_muzzle.BLUE;
	MY.LIGHTRANGE = 100;
	wait(2);
	//PLAY_SOUND gun_wham,50;
	remove(ME);
}


//]- Mod Date: 02/06/01 DCP
//]-			Added wait before shoot command to remove 'Dangerous instruction error'
function _fireball_event()
{
	// check for all collision events
	if(EVENT_TYPE == EVENT_BLOCK
		|| EVENT_TYPE == EVENT_ENTITY
	//	|| EVENT_TYPE == EVENT_STUCK
		|| EVENT_TYPE == EVENT_IMPACT
		|| EVENT_TYPE == EVENT_PUSH)
	{
		
	
		if (EVENT_TYPE == EVENT_ENTITY) 
		{
		
		damage = MY._DAMAGE;
	
		Enemy_AI_collision();
		}
		
		
		EXCLUSIVE_ENTITY;	// terminate other actions, to stop moving
		MY.EVENT = NULL;


	
	wait(1);
		
		morph BULLET_EXPLO,ME;
		MY._DIEFRAMES = EXPLO_FRAMES;
		actor_explode();
	
	}
}





// Desc: event attached to rocket
//			Explode the rocket.
//
//]- Mod Date: 6/13/00 Doug Poston
//]-				Created
//
// Mod Date: 6/07/02 DCP
//		Added wait before scan to avoid "dangerous instruction in event"
function _rocket_event()
{
	proc_kill(1);	//EXCLUSIVE_ENTITY;	// terminate other functions started by 'my' to stop moving
	MY.EVENT = NULL;
	MY.SKILL9 = -1;   // stop movement
wait(1);	// to avoid dangerous instruction in event warning
  	//   my_blast_range=200;
  //  my_blast_damage=60;
   // my_graphic_type=0;
   
   light_flash=vector(120,30,10);
   
    do_explosion(MY._DAMAGE * 6,MY._DAMAGE,0);
 
    
    do_explosion();
    
  /*  
	
	// Apply damage
	range = MY._DAMAGE * 6;
	damage = MY._DAMAGE;
 	temp.PAN = 360;
	temp.TILT = 360;
	temp.Z = range;
	indicator = _EXPLODE;	// must always be set before scanning
	scan(MY.POS,MY_ANGLE,temp);




  	// Explode
	morph <rexplode+9.bmp>, ME;
	MY.AMBIENT = 100;
	MY.FACING = ON;
	MY.NEAR = ON;
  	MY.FLARE = ON;

	MY.PASSABLE =  ON;
//	MY.AMBIENT = 100;
	//MY.LIGHTRED = light_flash.RED;
	//MY.LIGHTGREEN = light_flash.GREEN;
	//MY.LIGHTBLUE = light_flash.BLUE;
	
	
	MY.LIGHTRED =255;
	MY.LIGHTGREEN =255;
	MY.LIGHTBLUE = 255;

	MY.LIGHTRANGE = 100;
	
	MY.SCALE_X=2;
	MY.SCALE_y=2;
	MY.SCALE_z=2;
	
	wait(1);

	play_entsound ME,rocket_expl,700;
	while(MY.CYCLE <= 9)
	{
		MY.CYCLE +=2*TIME;
		waitt(1);
	}
*/
	remove(ME);
}




// runs a bullet; requires shot_speed, damage, fire_mode to be set
//
// Note: called from gun_shot
//
//]- Mod Date: 8/31/00 DCP
//]-				Scale fireball_speed by movement_scale
//]-				Scaled entity by actor_scale
//]-
// Mod Date: 05/17/01 DCP
//			Changed to function.
//
// Mod Date: 06/08/01 DCP
//			Replaced move() with ent_move()
//
function bullet_shot()
{
	//vec_scale(MY.SCALE_X,actor_scale);	// use actor_scale

var last_time;
	//my._PARENT=you;
my.narrow =off;
my.fat=off;
MY.PUSH=-1;
	MY.ENABLE_BLOCK = ON;
	MY.ENABLE_ENTITY = ON;
	MY.ENABLE_STUCK = ON;
	MY.ENABLE_IMPACT = ON;
	MY.ENABLE_PUSH = ON;
	
		my.flare=ON;
		my.scale_x=0.3;
		my.scale_y=0.3;
		my.scale_z=0.3;

		my.ENABLE_detect = Off; // sensible for scans
		my.ENABLE_scan = Off; // sensible for scans
		my.ENABLE_shoot = Off;
		my.ENABLE_stuck = Off; // sensible for stuck

	my.min_z=0;
my.min_x=0;
my.min_y=0;

my.max_z=0;
my.max_x=0;
my.max_y=0;

	
	MY.EVENT = _fireball_event;

	MY.FACING = ON;	// in case of fireball

	MY.LIGHTRED = light_bullet.RED;
	MY.LIGHTGREEN = light_bullet.GREEN;
	MY.LIGHTBLUE = light_bullet.BLUE;
	MY.LIGHTRANGE = 30;
	MY.AMBIENT = 100;

	MY.SKILL2 = shot_speed.x;
	MY.SKILL3 = shot_speed.y;
	MY.SKILL4 = shot_speed.z;
	MY._DAMAGE = damage;
	MY._FIREMODE = fire_mode;

  	// my.near is set by the explosion
	while(MY.NEAR != ON)
	{
		wait(1); // wait at the loop beginning, to let it appear at the start position

last_time+=TIME;

		temp = TIME;
		if(temp > 1.5) { temp = 1.5; }	// make bullet slower on slow PCs
// MOVE moves by a distance, so multiply the speed by time.
		fireball_speed.x = MY.SKILL2 * temp;
		fireball_speed.y = MY.SKILL3 * temp;
		fireball_speed.z = MY.SKILL4 * temp;

		if((MY._FIREMODE & BULLET_SMOKETRAIL) == BULLET_SMOKETRAIL)
		{
	//		temp = 3 * TIME;
	//		if(temp > 6) { temp = 6; }	// generate max 6 particels
	if (last_time>1) {
			emit(1,MY.POS,particle_fade); 	// smoke trail
			last_time=0;
						}
		}

		vec_scale(fireball_speed,movement_scale);	// scale fireball_speed by movement_scale
 		//--move(ME,nullskill,fireball_speed);
		move_mode = ignore_me + ignore_you + ignore_passable + IGNORE_SPRITES+IGNORE_PUSH;
		//damage = MY._DAMAGE;
		//indicator =_GUNFIRE;
		result = ent_move(nullskill,fireball_speed);
		
		
		
		
	}
}



function fireball_shot()
{
	//vec_scale(MY.SCALE_X,actor_scale);	// use actor_scale
	var last_time;
my.narrow =off;
my.fat=off;
MY.PUSH=-1;
	MY.ENABLE_BLOCK = ON;
	MY.ENABLE_ENTITY = ON;
	MY.ENABLE_STUCK = ON;
	MY.ENABLE_IMPACT = ON;
	my.ENABLE_shoot = Off;
	
		my.flare=ON;
		my.scale_x=0.3;
		my.scale_y=0.3;
		my.scale_z=0.3;
/*
my.min_z=-1;
my.min_x=-1;
my.min_y=-1;

my.max_z=1;
my.max_x=1;
my.max_y=1;
*/

		my.ENABLE_detect = Off; // sensible for scans
		my.ENABLE_scan = Off; // sensible for scans
		my.ENABLE_shoot = Off;
		my.ENABLE_stuck = Off; // sensible for stuck



//	MY.ENABLE_PUSH = ON;
	
	MY.EVENT = _fireball_event;

	MY.FACING = ON;	// in case of fireball

	MY.LIGHTRED = light_bullet.RED;
	MY.LIGHTGREEN = light_bullet.GREEN;
	MY.LIGHTBLUE = light_bullet.BLUE;
	MY.LIGHTRANGE = 30;
	MY.AMBIENT = 100;

	MY.SKILL2 = shot_speed.x;
	MY.SKILL3 = shot_speed.y;
	MY.SKILL4 = shot_speed.z;
	MY._DAMAGE = damage;
	MY._FIREMODE = fire_mode;
	MY.SKILL9 = 200;  // burn fuel
	
  	// my.near is set by the explosion
	
	
	while(MY.SKILL9>0)
	{
	
		wait(1); // wait at the loop beginning, to let it appear at the start position
last_time+=TIME;
		temp = TIME;
		if(temp > 1.5) { temp = 1.5; }	// make bullet slower on slow PCs
// MOVE moves by a distance, so multiply the speed by time.
//=========================================================


//===================================================
/*
		fireball_speed.x = 20 * temp;
		fireball_speed.y = 0;
		fireball_speed.z = 0;
*/


		fireball_speed.x = (player.x-my.x)/25;
		fireball_speed.y = (player.y-my.y)/25;
		fireball_speed.z = (player.z+20-my.z)/25;

		if((MY._FIREMODE & BULLET_SMOKETRAIL) == BULLET_SMOKETRAIL)
		{
		
	if (last_time>1) {
			emit(1,MY.POS,particle_fade); 	// smoke trail
			last_time=0;
							}
		}

		vec_scale(fireball_speed,movement_scale);	// scale fireball_speed by movement_scale
 		move_mode = ignore_me + ignore_you + ignore_passable + IGNORE_SPRITES+IGNORE_PUSH+ACTIVATE_SHOOT;
		//result = ent_move(fireball_speed,nullvector );
		result = ent_move(nullvector, fireball_speed );
/*		
		temp.X = player.X - MY.X;
		temp.Y = player.Y - MY.Y;
		temp.Z = 0;
		vec_to_angle(MY.PAN,temp);
*/		
/*		
vec_set(temp,player.x); 
vec_sub(temp,my.x);
vec_to_angle(my.pan,temp); // now MY looks at YOU
*/
		
	//	temp.X = 0;
	//	temp.Y = vec_dist(player.Y, MY.Y);
	//	temp.Z = player.z - MY.Z;
	//	vec_to_angle(MY.tilt,temp);
		//temp=
		
		
		
		
		/*
			vec_set(temp2,player.x);
			temp2.z=player.MAX_Z/2+player.z;
			vec_diff(temp,temp2.x,my.x);
		//	vec_normalize(temp,int(MY._WEAPONRANGE));
		  	vec_set(shot_speed,temp);
		*/
	MY.SKILL9 -= TIME;  // burn fuel
		
	}
	
	
	ENT_REMOVE(ME);
	
	
	//_rocket_event(); 
}


// Desc: launch a rocket (models)
//
//]- Mod Date: 6/13/00 Doug Poston
//]-				Created
//]- Mod Date: 8/31/00 DCP
//]-				Scale rocket movement by movement_scale
//]-				Scale rocket size by actor_scale
//]-
//]- Mod:  04/18/01 DCP
//]-    	Use 'vec_to_angle' and shot_speed to determine rocket orientation
//
// Mod:  06/08/01 DCP
//			Replaced move() with ent_move()
function rocket_launch()
{
	vec_scale(MY.SCALE_X,actor_scale);	// use actor_scale

 	MY.ENABLE_BLOCK =  ON;      // collision with map surface
	MY.ENABLE_ENTITY =  ON;     // collision with entity
 	MY.ENABLE_STUCK = ON;
	MY.ENABLE_IMPACT = ON;
	MY.ENABLE_PUSH = ON;
	
			my.ENABLE_detect = Off; // sensible for scans
		my.ENABLE_scan = Off; // sensible for scans
		my.ENABLE_shoot = Off;
	//	my.ENABLE_stuck = Off; // sensible for stuck

	MY.PUSH=-1;
	
	//my.push=0;
	
 	MY.EVENT = _rocket_event;

	MY.AMBIENT = 100;  // bright
	MY.LIGHTRANGE = 150;
	MY.LIGHTRED = 250;
	MY.LIGHTGREEN = 50;
	MY.LIGHTBLUE = 50;

//- 	MY.PAN = YOUR.PAN; // the rocket start in the same direction than this 'emitter'
//- 	MY.TILT = YOUR.TILT;
//- 	MY.ROLL = YOUR.ROLL;
	vec_to_angle(MY.PAN, shot_speed);

	MY.SKILL2 = shot_speed.x;
	MY.SKILL3 = shot_speed.y;
	MY.SKILL4 = shot_speed.z;
	MY._DAMAGE = damage;
	MY._FIREMODE = fire_mode;

	MY.SKILL9 = 250; // 'burn time'  (fuel)
	while(MY.SKILL9 > 0)
	{
		temp.X = MY.SKILL2 * TIME;
		temp.Y = MY.SKILL3 * TIME;
		temp.Z = MY.SKILL4 * TIME;
  		vec_scale(temp,movement_scale);	// scale distance by movement_scale
//--		move(ME,NULLSKILL,temp);
		move_mode = ignore_you + ignore_passable + IGNORE_PASSENTS+ignore_sprites+ignore_push;
		result = ent_move(nullskill,temp);

		emit(1,MY.POS,particle_smoke);	// emit( smoke
		MY.SKILL9 -= TIME;  // burn fuel
		wait(1);     // update position once per tick
	}
	_rocket_event();   // explode when out of fuel
}


function move_grenade()
{
	my.narrow=off;
	my.fat=off; 
 	my.pan=camera.pan;
 	my.tilt=camera.tilt;
 	my.roll=0;
 
 	MY._SPEED_X = 50;
 	MY._SPEED_y = 0;
	MY._SPEED_z = 0;
   my._MONSTR_TYPE=-1;
   my.enable_block = on;
   my.enable_entity = on;
	my.ENABLE_detect = Off; // sensible for scans
	my.ENABLE_scan = Off; // sensible for scans
	my.ENABLE_shoot = Off;
	MY._DAMAGE=60;
	
	MY.PUSH=-1;
	
	MY._grenade_TIMER=0;	
    while (my._grenade_TIMER<30)
    {
   	move_mode =ignore_passable + ignore_push+ignore_me+ignore_you+ignore_sprites;
   	vec_set(temp2,nullvector);
	   vec_set(temp,nullvector);
   	temp.x=TIME * MY._SPEED_x; // distance down
   	temp2.z=TIME * MY._SPEED_z; // distance down
	   result=ent_move(temp,temp2);
   	   if (MY._SPEED_z>-50) {MY._SPEED_z-=time; };
    
  		if (in_solid==1 || result<=0)
 		{
     	vec_to_angle(my.pan,bounce.x);
		My._Speed_x=My._Speed_x/2;
		}
  
   MY._SPEED_x-=time;
 	my._grenade_TIMER+=time;
    wait(1);
	 }   
    //my_blast_range,my_blast_damage,my_graphic_type
   light_flash=vector(120,30,255);
   do_explosion(MY._DAMAGE * 4,MY._DAMAGE,0);
   vec_set(ALERT_SOUND_PLACE, my.x);
   remove(me);
} 

// Desc: actor "explode" :
//				face camera
//				play explosion sound
//				animate frames
//		  		remove
ACTION actor_explode
{
	MY.FACING = ON;	// face the camera
	MY.NEAR = ON;
	MY.FLARE = ON;
	MY.PASSABLE = ON;	// don't push the player through walls
	MY.FRAME = 1;
	wait(1);

	PLAY_ENTSOUND ME,explo_wham,700;
	MY.LIGHTRED = light_explo.RED;
	MY.LIGHTGREEN = light_explo.GREEN;
	MY.LIGHTBLUE = light_explo.BLUE;
	MY.AMBIENT = 100;
	MY.LIGHTRANGE = 5;

	// use the new sprite animation
	while(MY.FRAME < MY._DIEFRAMES)
	{
		wait(1);
		MY.LIGHTRANGE += 5;
		MY.LIGHTRED += 20 * TIME;	// fade to red
		MY.LIGHTBLUE -= 20 * TIME;
		MY.FRAME += TIME;
	}
	wait(1);
	remove(ME);
}


// Desc: create a hit point 'effect' depending on (fire_mode & MODE_HIT) value
//
// Input:fire_mode
//			TARGET
//
//]- 		6/14/00 Doug Poston
//]-
function _hit_point_effect()
{
	// flash at hit point?
	if((fire_mode & MODE_HIT) == HIT_FLASH)
	{
		weaponTmpSyn = YOU;  // save YOU value
		create(small_flash,TARGET,_blowup);
		YOU = weaponTmpSyn;
	}

	// smoke at hit point?
	if(fire_mode & HIT_SMOKE)
	{
	 	emit(20,TARGET,particle_smoke); // emit smoke
	}

	if(fire_mode & HIT_SPARKS)
	{
		if(YOU == NULL)	// hit wall (not entity)
		{
		emit(20,TARGET,particle_scatter); // emit sparks
		}
	//	else  {
	//	emit(10,TARGET,particle_blood); // emit sparks
	//			}
	}

	// bullet hole ***
	if(fire_mode & HIT_HOLE)
	{
		if(YOU == NULL)	// hit wall (not entity)
		{
			create(bullethole_map,TARGET,bullet_hole);  // create bullet hole
		}
	}
}


var	bullet_hole_index = 0;
DEFINE	kMaxBulletHole	100;
var	h_bullet_hole_array[kMaxBulletHole];
entity* p_bullet_hole_temp;

// Desc: bullet hole
//
// Mod Date: 07/14/01
//		Use new handles to turned it into an FIFO array
// Mod Date: 07/16/01
//		Fixed index problem with remove (use SKILL4 to store local index)
// PROBLEM: 07/26/01
//		If you change levels with 'outstanding' bullet holes you will get
//	'WDL Crash' errors when this function tries to remove the hole from the
//	previous level. Solution: clear all bullet_holes before switching levels
//	by calling 'bullet_hole_remove_all()'.
function bullet_hole()
{
	MY.TRANSPARENT = ON;
	MY.FLARE = ON;

	// check for maximum bullet holes at any time
	if(bullet_hole_index >= kMaxBulletHole)
	{
		bullet_hole_index = 0;
	}

	// check to see if its already in use
	temp = h_bullet_hole_array[bullet_hole_index];
	if(temp != 0)
	{
		// remove old hole
		p_bullet_hole_temp = ptr_for_handle(temp);
		remove(p_bullet_hole_temp);
	}

	// assign this as the new value in the array
	h_bullet_hole_array[bullet_hole_index] = handle(ME);
	MY.SKILL4 = bullet_hole_index;  // save index for removal

	bullet_hole_index += 1;		// increament index


	MY.PASSABLE = ON;
	MY.ORIENTED = ON;
	my.scale_x=0.2;
	my.scale_z=0.2;
	my.scale_y=0.2;

	vec_to_angle(MY.PAN,NORMAL);	// rotate to target normal
	waitt(160);          // time bullet stays before vanishing
	h_bullet_hole_array[MY.SKILL4] = 0;	// zero out pointer
	remove(ME);
}

// Desc: remove all bullet holes
// Note: Call this before changing levels.
function	bullet_hole_remove_all()
{
	bullet_hole_index = 0;
	while(bullet_hole_index < kMaxBulletHole)
	{
		temp = h_bullet_hole_array[bullet_hole_index];
		if(temp != 0)
		{
			// remove old hole
			p_bullet_hole_temp = ptr_for_handle(temp);
			remove(p_bullet_hole_temp);
			h_bullet_hole_array[bullet_hole_index] = 0;	// zero out pointer
		}
		bullet_hole_index += 1;
	}
}



// Desc: scale and remove the laser beam
//
// Uses: TARGET,
//
// ToDo: make work in 3D player mode
//
// Mod:  04/18/01 DCP
// 	Use 'vec_to_angle' and shot_speed to determine beam orientation
//
// Mod: 08/01/01 DCP
//		Made laser brighter
////////////////////////////////////////////////////////////////////////
// Cross-hair panel and functions
//
// Use the var 'cross_pos.x' and 'cross_pos.y' you adjust the position
//of the cross-hair on the screen


// Desc: position the cross-hair panel at the center of the screen
//		and make it visible.

function	pan_cross_show()
{
	cross_pan.pos_x = (screen_size.x - bmap_width(cross_bmp))/2;
	cross_pan.pos_y = (screen_size.y - bmap_height(cross_bmp))/2;
	cross_pan.visible = ON;
}

// Desc: hide the cross-hair panel
function	pan_cross_hide()
{
	cross_pan.visible = OFF;
}



//====================================================
action weap_deagle
{
	MY.passable = Off;
	MY._WEAPONNUMBER = 1;     		// weapon number (press to equip)
	MY._AMMOTYPE = 1.07; 	
	MY.unlit=ON;
	MY.Ambient=100;
	ToGround();
	MY.EVENT = gun_pickup;

	MY.PUSH = -1;
	MY.ENABLE_SCAN = Off;
	MY.ENABLE_PUSH = ON;		// or touching the item

}

action weap_ak47
{
	MY.passable = Off;
	MY._WEAPONNUMBER = 3; 
	MY._AMMOTYPE = 3.25; 	
	MY.unlit=ON;
	MY.Ambient=100;
	ToGround();
	MY.EVENT = gun_pickup;
	MY.PUSH = -1;
	MY.ENABLE_SCAN = Off;		// pick up pressing SPACE..
	MY.ENABLE_PUSH = ON;		// or touching the item
	
}

action weap_shotgun
{

	MY.passable = Off;
	MY._WEAPONNUMBER = 2; 
	MY._AMMOTYPE = 2.08; 	
	MY.unlit=ON;
	MY.Ambient=100;
	ToGround();	
	MY.EVENT = gun_pickup;
	MY.PUSH = -1;
	MY.ENABLE_SCAN = Off;		// pick up pressing SPACE..
	MY.ENABLE_PUSH = ON;		// or touching the item
}

action weap_railgun
{

	MY.passable = Off;
	MY._WEAPONNUMBER = 4; 
	MY._AMMOTYPE = 4.05; 	
	MY.unlit=ON;
	MY.Ambient=100;
	ToGround();
	MY.EVENT = gun_pickup;
	MY.PUSH = -1;
	MY.ENABLE_SCAN = Off;
	MY.ENABLE_PUSH = ON;		// or touching the item

}
FUNCTION Trow_grenades()
{
   //while (player == null) {wait (4);} 
   //while (Player._HEALTH>0)
   //{
   	
   	
  	if (ammo5>0)
    	{
    		grenade_firing=1;
//       if (key_pressed(scan_code_grenade) == 1) 
  //     	{
          ent_create (stgrenade, camera.x, move_grenade);
          ammo5-=1; 
          while (key_pressed(scan_code_grenade) == 1) {wait (3);} // wait until the LMB is released
          wait(40);
          grenade_firing=0;
          
    //   	}
  		}       
    //wait(2);
    //}
} 

function ToGround()
{

    vec_set(temp,my.x);
    temp.z -= 8000; // calculate a position 4000 quants below the player
    trace_mode = ignore_me+ignore_you+ignore_sprites+USE_BOX+ignore_passable;
    result = trace(my.x,temp); // subtract vertical distance to ground
    
    if (RESULT > 0) { 
    dist.x=0;
    dist.y=0;
    dist.z = -result+my.min_z;
    move_mode = ignore_passable+ignore_sprites+ignore_push;
    ent_MOVE(dist,nullvector);
    						}
	
}

//====================================================

function PreloadDeagle()
{

my = ent_create(stDeagle,nullvector,NULL);
my.passable = on;
my.INVISIBLE = On;
my.push=-10;
MY.__REPEAT = OFF;		// repeats (Auto-fire)
MY.__BOB = ON;  		// 'bobs' when the player moves
MY._AMMOTYPE = 1; 	  		// type of ammo '.' rounds in gun
MY._WEAPONNUMBER = 1;
MY._BULLETSPEED = 10000.01;		// bulletspeed '.' recoil
MY._FIRETIME = 8;          	// time to cycle (reload)
MY._DAMAGE=15;
MY._FIREMODE = GUNFX_BRASS+DAMAGE_SHOOT + HIT_HOLE + HIT_FLASH + HIT_SPARKS + GUNFX_ANIMATE+0.10;
//MY._OFFS_FLASH =232;
my._MUZZLEATTACH=232;
MY._RELOADTIME=30;
MY._CLIP=0;
MY._CLIP_MAX=7;
MY.__SILENT = ON;
MY._SND_RELOAD=gun_deagle_r;
MY._SND_SHOT=gun_deagle_s;
MY.near=ON;
//layer=2;
weapon1 = ME;
/*

weapon1.__REPEAT = OFF;		// repeats (Auto-fire)
weapon1.__BOB = ON;  		// 'bobs' when the player moves
weapon1._AMMOTYPE = 1; 	  		// type of ammo '.' rounds in gun
weapon1._WEAPONNUMBER = 1;
weapon1._BULLETSPEED = 10000.01;		// bulletspeed '.' recoil
weapon1._FIRETIME = 8;          	// time to cycle (reload)
weapon1._DAMAGE=15;
weapon1._FIREMODE = GUNFX_BRASS+DAMAGE_SHOOT + HIT_HOLE + HIT_FLASH + HIT_SPARKS + GUNFX_ANIMATE+0.10;
//MY._OFFS_FLASH =232;
weapon1._MUZZLEATTACH=232;
weapon1._RELOADTIME=30;
weapon1._CLIP=0;
weapon1._CLIP_MAX=7;
weapon1.__SILENT = ON;
weapon1._SND_RELOAD=gun_deagle_r;
weapon1._SND_SHOT=gun_deagle_s;
weapon1.layer=2;
*/

}

function PreloadRailgun()
{
my = ent_create(stRailgun,nullvector,NULL);/*or your player's main function*/
my.passable = on;
my.INVISIBLE = On;
my.push=-10;
//my.layer=2;
MY.__REPEAT = OFF;		// repeats (Auto-fire)
MY.__BOB = ON;  		// 'bobs' when the player moves
MY._WEAPONNUMBER = 4;
MY._BULLETSPEED = 5000.01;		// bulletspeed '.' recoil
//MY._FIRETIME = 4;          	// time to cycle (reload)

//MY._OFFS_FLASH =338;
my._MUZZLEATTACH=338;
MY._RELOADTIME=20;
MY._AMMOTYPE = 4; 	  		// type of ammo '.' rounds in gun
MY._FIRETIME = 16;          	// time to cycle (reload)
MY._DAMAGE=81;
MY._FIREMODE =GUNFX_ANIMATE+DAMAGE_SHOOT+FIRE_PARTICLE+0.81;
//DAMAGE_SHOOT +HIT_FLASH + HIT_SPARKS + GUNFX_ANIMATE+0.10;

MY._CLIP=0;
MY._CLIP_MAX=5;
MY.__SILENT = ON;

MY._SND_RELOAD=gun_rail_r;
MY._SND_SHOT=gun_rail_s;

weapon4 = ME;
}

function PreloadShotgun()
{
my = ent_create(stShotgun,nullvector,NULL);/*or your player's main function*/
my.passable = on;
my.INVISIBLE = On;
my.push=-10;
//my.layer=2;
MY.__REPEAT = OFF;		// repeats (Auto-fire)
MY.__BOB = ON;  		// 'bobs' when the player moves
MY._WEAPONNUMBER = 2;
MY._BULLETSPEED = 1000.01;		// bulletspeed '.' recoil
MY._FIRETIME = 4;          	// time to cycle (reload)

//MY._OFFS_FLASH =232;
MY._RELOADTIME=14;
MY._AMMOTYPE = 2; 	  		// type of ammo '.' rounds in gun
MY._FIRETIME = 16;          	// time to cycle (reload)
MY._DAMAGE=6;
MY._FIREMODE =GUNFX_BRASS + DAMAGE_SHOOT + HIT_SCATTER + HIT_FLASH + HIT_SPARKS + GUNFX_ANIMATE+HIT_HOLE+0.06;
//MY._OFFS_FLASH =529;
my._MUZZLEATTACH=529;
MY._CLIP=0;
MY._CLIP_MAX=8;
MY.__SILENT = ON;

MY._SND_RELOAD=gun_shotg_r;
MY._SND_SHOT=gun_shotg_s;

weapon2 = ME;
}

function PreloadAk47()
{
my = ent_create(stAk47,nullvector,NULL);/*or your player's main function*/
my.passable = on;
my.INVISIBLE = On;
my.push=-10;
MY.__REPEAT = On;		// repeats (Auto-fire)
MY.__BOB = ON;  		// 'bobs' when the player moves
MY._AMMOTYPE = 3; 	  		// type of ammo '.' rounds in gun
MY._WEAPONNUMBER = 3;
MY._BULLETSPEED = 10000.01;		// bulletspeed '.' recoil
MY._FIRETIME = 2;          	// time to cycle (reload)
MY._DAMAGE=15;
MY._FIREMODE = DAMAGE_SHOOT + HIT_HOLE + HIT_FLASH + HIT_SPARKS + GUNFX_ANIMATE+0.10;
MY.passable = On;
//MY._OFFS_FLASH =551;
my._MUZZLEATTACH=551;
MY._RELOADTIME=30;
MY._CLIP=0;
MY._CLIP_MAX=25;
MY.__SILENT = ON;
MY._SND_RELOAD=gun_ak47_r;
MY._SND_SHOT=gun_ak47_s;

weapon3 = ME;
}